;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-3056      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
P386
LOCALS
JUMPS

code32  segment para public use32
	assume cs:code32, ds:code32
	largestack

include gve32.inc
include gomez.inc
include keys.inc



Frame_Ptr	dd	?
World_Ptr	dd	?
Camera_Ptr	dd	?

STXT		db	"Gomez Vector Engine                                 (C) 1996 by Marc van Shaney",10,13,'$'
STXT1		db	"Drawing frames ",'$'
STXT2		db	"",'$'
ETXT0		db	"Usage: GPROF.EXE [vectorfile.GVE]  {/16}",10,13,'$'
ETXT1		db	"Error: Data file not found . . .",10,13,'$'
D16		db	"/16",0
TILDE		db	"~",0

;[]------------------------------------------------------------------------[]
;|
;| This is the main routine
;|
PUBLIC C main
main PROC NEAR
	mov	esi,OFFSET STXT
	call	Print32
	mov	eax,OFFSET D16
	call	Scan_Argument
	mov	ecx,8
	jc	short @@1
	mov	ecx,16
@@1:	mov	eax,DISPLAY_Width
	mov	ebx,DISPLAY_Height
	call	Init_GVE
	mov 	ecx,DISPLAY_Width*DISPLAY_Height*2
	call 	Malloc				;Get frame buffer !
	mov 	ds:[Frame_Ptr],eax
	;
	mov	eax,OFFSET Tilde
	call	Scan_Argument
	jc	@@NoFile
	mov	esi,eax			;ESI = ptr to file-name
	;
	mov	ebx,esi
	xor	edx,edx				;Start at file offset 0
	call	GVE_Load_World			;Load world
	mov	ds:[World_Ptr],eax		;Save returned ptr !
	jc	@@LoadError			;JC => Error
	call	GVE_Init_World			;Initialize world

	mov	eax,ds:[World_Ptr]
	mov	eax,ds:[eax+World_Camera_List]
	mov	eax,ds:[eax+4]
	mov	ds:[Camera_Ptr],eax
	;
	mov	esi,OFFSET STXT1
	call	Print32
	mov	ebp,200h
@@L1:   mov	eax,ds:[World_Ptr]
	mov	edx,ds:[Camera_Ptr]
	call	GVE_Move_Camera			;Move camera !
	call	GVE_Transform_World		;Transform world !
	mov	eax,ds:[World_Ptr]
	mov	ebx,ds:[Camera_Ptr]
	mov	ecx,ds:[Frame_Ptr]		;EDX = Frame buffer
	mov	edx,ds:[Frame_Ptr]		;EDX = Frame buffer
	call	GVE_Draw_World			;Draw world !

	mov	ebx,ds:[Camera_Ptr]		;EBX = Viewport
	add	dword ptr ds:[ebx+Camera_RotationX],4
	sub	dword ptr ds:[ebx+Camera_RotationY],3
	add	dword ptr ds:[ebx+Camera_RotationZ],5
	test	ebp,01fh
	jnz	short @@J1
		mov	esi,OFFSET STXT2
		call	Print32
@@J1:	dec	ebp
	jnz	short @@L1
	;
@@End:  mov	eax,ds:[World_Ptr]
	call	GVE_Free_World                  ;Release memory
	call	Exit_GVE			;Bye-bye !
	mov	ecx,ds:[Frame_Ptr]
	call 	Free                            ;Realease frame-buffer
	jmp	Exit_PMODE32			;Thats all folks !

@@LoadError:					;An error occured
	mov	esi,OFFSET ETXT1		;Display error-text
	call	Print32
	jmp	Exit_PMODE32

@@NoFile:
	mov	esi,OFFSET ETXT0		;Display error-text
	call	Print32
	jmp	Exit_PMODE32
main ENDP
code32 ends
END
