;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
P386
LOCALS
JUMPS

code32  segment para public use32
	assume cs:code32, ds:code32
	largestack

include gomez.inc
include keys.inc
include gvechunk.inc
include gvi32.inc


;
;
;
;   GOMEZ VECTOR ENGINE                                 FLI2VID Converter
;
;
;
InFile		db	128 dup (0)
OutFile		db	128 dup (0)
InHandle	dd	?
FileBuffer	dd	?
PaletteBuffer	db	1024 dup (?)
MovieHeader	GVI_MOVIE <?>


STXT		db	"Gomez Video Interface                               (C) 1997 by Marc van Shaney",10,13,'$'
ETXT		db	"Usage: FLI2VID.EXE [inputfile.FLI]",10,13
		db	'$'
PTXT		db	"Converting FLI-File . . .",10,13,'$'
TILDE		db	"~",0

;
;   GOMEZ VECTOR ENGINE                                         Main routine
;
PUBLIC C main
main PROC NEAR
	mov	es,cs:[DATA32_Selector]
	mov	esi,OFFSET STXT
	call	Print32

	mov	ecx,1024*1024
	call	Malloc
	jc	@@Err
	mov	ds:[FileBuffer],eax
	mov	ebp,eax

	mov	eax,OFFSET Tilde
	call	Scan_Argument
	jc	@@Info
	;
	mov	esi,eax
	mov	edi,OFFSET InFile
	mov	ecx,128/4
	rep	movsd

	mov	esi,eax
	mov	edi,OFFSET OutFile
	mov	ecx,128/4
	rep	movsd

	mov	ebx,OFFSET InFile
	mov	al,'.'
	call	Find_Char
	jnc	short @@1
	mov	d ds:[ebx],'ILF.'
	mov	d ds:[ebx+4],0

@@1:	mov	ebx,OFFSET OutFile
	mov	al,'.'
	call	Find_Char
	mov	d ds:[ebx],'DIV.'
	mov	d ds:[ebx+4],0
	;
	mov	cx,O_RDONLY
	mov	ebx,OFFSET InFile
	call	Open
	jc	@@Err
	mov	ds:[InHandle],eax

	mov	eax,'ODIV'
	mov	ebx,'ELIF'
	mov	ecx,GVI_FILE_VERSION
	mov	edx,OFFSET OutFile
	call	Creat_File
	jc	@@Err
	;
	mov	ebx,ds:[InHandle]
	mov	ecx,128
	mov	edx,ebp
	call	Read

	cmp	ds:[ebp+FLI_Header_Magic],FLI_FILE_MAGIC
	je	short @@2
	cmp	ds:[ebp+FLI_Header_Magic],FLC_FILE_MAGIC
	jne	@@Err

@@2:	mov	ax,ds:[ebp+FLI_Header_Width]
	mov	bx,ds:[ebp+FLI_Header_Height]
	mov	cx,ds:[ebp+FLI_Header_Depth]
	movzx	edx,ds:[ebp+FLI_Header_Frames]
	mov	ds:[MovieHeader.Movie_Width],ax
	mov	ds:[MovieHeader.Movie_Height],bx
	mov	ds:[MovieHeader.Movie_Depth],cl
	mov	ds:[MovieHeader.Movie_Frames],edx
	mov	ds:[@@frames],edx
	mov	ds:[MovieHeader.Movie_Compression],'CLF'

	mov     eax,'DAEH'
	mov	ebx,COMPRESSION_LZW
	call	Creat_Chunk
	mov	eax,COMPRESSION_LZW
	mov	ecx,GVI_FILE_MOVIE_SIZE
	mov	edx,OFFSET MovieHeader
	call	Compress_Chunk
	call	Close_Chunk
	;
	mov	eax,'ODIV'
	mov	ebx,COMPRESSION_NONE
	call	Creat_Chunk
	;
@@L1:   mov	ebx,ds:[InHandle]
	mov	ecx,SIZE FLI_FRAME_HEADER
	mov	edx,ebp
	call	Read

	movzx	eax,ds:[ebp+FLI_Frame_Chunks]
	cmp	ds:[ebp+FLI_Frame_Magic],FLI_FRAME_FILE_MAGIC
	jne	short @@Skp
	mov	ds:[@@chunks],eax

	mov	eax,'ATLD'
	mov	ebx,COMPRESSION_NONE
	call	Creat_Chunk

	mov	ebx,ds:[InHandle]
	mov	ecx,ds:[ebp+FLI_Frame_Size]
	sub	ecx,SIZE FLI_FRAME_HEADER
	jz	@@Rdy
	mov	edx,ebp
	call	Read

	cmp	ds:[@@chunks],0
	je	@@Rdy
	mov	esi,ebp
	jmp	short @@L2
	;
@@Skp:  mov	al,SEEK_CUR
	mov	ebx,ds:[InHandle]
	mov	ecx,ds:[ebp+FLI_Frame_Size]
	sub	ecx,SIZE FLI_FRAME_HEADER
	jz	short @@L1
	call	Seek
	jmp	short @@L1
	;
@@L2:	movzx	edx,ds:[esi+FLI_Chunk_Type]
	cmp	edx,FLI_CHUNK_BLACK
	jne	short @@CH1
		mov	eax,'KCLB'
		call	Creat_SubChunk
		mov	d ds:[ebp],0
		mov	ebx,ds:[File_handle]
		mov	ecx,4
		mov	edx,ebp
		call	Write
		call	Close_SubChunk
		jmp	@@Nxt
	;                                  
@@CH1:  cmp	edx,FLI_CHUNK_DELTA_FLI
	jne	short @@CH2
		mov	eax,'ILF'
		call	Creat_SubChunk
		mov	ebx,ds:[File_handle]
		mov	ecx,ds:[esi+FLI_Chunk_Size]
		sub	ecx,6
		lea	edx,[esi+6]
		call	Write
		call	Close_SubChunk
		jmp	@@Nxt
	;                                  
@@CH2:  cmp	edx,FLI_CHUNK_DELTA_FLC
	jne	short @@CH3
		mov	eax,'CLF'
		call	Creat_SubChunk
		mov	ebx,ds:[File_handle]
		mov	ecx,ds:[esi+FLI_Chunk_Size]
		sub	ecx,6
		lea	edx,[esi+6]
		call	Write
		call	Close_SubChunk
		jmp	@@Nxt
	;                                  
@@CH3:  cmp	edx,FLI_CHUNK_BRUN
	jne	short @@CH4
		mov	eax,'8ELR'
		call	Creat_SubChunk
		mov	ebx,ds:[File_handle]
		mov	ecx,ds:[esi+FLI_Chunk_Size]
		sub	ecx,6
		lea	edx,[esi+6]
		call	Write
		call	Close_SubChunk
		jmp	@@Nxt
	;                                  
@@CH4:  cmp	edx,FLI_CHUNK_COPY
	jne	short @@CH5
		mov	eax,'8PMB'
		call	Creat_SubChunk
		mov	ebx,ds:[File_handle]
		mov	ecx,ds:[esi+FLI_Chunk_Size]
		sub	ecx,6
		lea	edx,[esi+6]
		call	Write
		call	Close_SubChunk
		jmp	@@Nxt
	;                                  
@@CH5:  cmp	edx,FLI_CHUNK_PAL18
	jne	short @@CH6
		mov	eax,'6LAP'
		call	Creat_SubChunk
		mov	ebx,ds:[File_handle]
		mov	ecx,ds:[esi+FLI_Chunk_Size]
		sub	ecx,6
		lea	edx,[esi+6]
		call	Write
		call	Close_SubChunk
		push	ebp
		push	esi
		add	esi,6
		mov	ebp,OFFSET PaletteBuffer
		call	FLC_Decompress_PAL18
		pop	esi
		pop	ebp
		jmp	@@Nxt
	;                                  
@@CH6:  cmp	edx,FLI_CHUNK_PAL24
	jne	short @@CH7
		mov	eax,'8LAP'
		call	Creat_SubChunk
		mov	ebx,ds:[File_handle]
		mov	ecx,ds:[esi+FLI_Chunk_Size]
		sub	ecx,6
		lea	edx,[esi+6]
		call	Write
		call	Close_SubChunk
		push	ebp
		push	esi
		add	esi,6
		mov	ebp,OFFSET PaletteBuffer
		call	FLC_Decompress_PAL24
		pop	esi
		pop	ebp
		jmp	@@Nxt
	;                                  
@@CH7:
@@Nxt:  add	esi,ds:[esi+FLI_Chunk_Size]
	dec	ds:[@@chunks]
	jnz	@@L2
@@Rdy:  ;
	mov	eax,'DNE'
	mov	ebx,COMPRESSION_NONE
	call	Creat_SubChunk
	call	Close_SubChunk
	call	Close_Chunk
	dec	ds:[@@frames]
	jnz	@@L1
	;
	mov	eax,'DNE'
	mov	ebx,COMPRESSION_NONE
	call	Creat_Chunk
	call	Close_Chunk
	call	Close_Chunk
	;
	mov	eax,'LAP'
	mov	ebx,COMPRESSION_LZW
	call	Creat_Chunk
	mov	eax,COMPRESSION_LZW
	mov	ecx,1024
	mov	edx,OFFSET PaletteBuffer
	call	Compress_Chunk
	call	Close_Chunk
	;
	mov	eax,'DNE'
	mov	ebx,COMPRESSION_NONE
	call	Creat_Chunk
	call	Close_Chunk
	call	Close_File
	mov	ebx,ds:[InHandle]
	call	Close

@@Err:	jmp	Exit_PMODE32
	;
@@Info:	mov	esi,OFFSET ETXT
	call	Print32
	jmp	Exit_PMODE32

		ALIGN	DWORD
@@frames	dd	?
@@chunks	dd	?
main ENDP


;
;
; FLC_Decompress_PAL18:
;  Input:
; 	ESI	- DATA32 ptr to source
;	EBP	- DATA32 ptr to destination
;  Output:
;	[CF]	- Error flag
;
FLC_Decompress_PAL18 PROC NEAR
	push 	esi
	push 	ebp

	xor	eax,eax				;EAX = 0
	xor	ecx,ecx				;ECX = 0
	movzx	ebx,w ds:[esi]			;EBX = Number of blocks
	add	esi,2
	test	ebx,ebx
	jz 	short @@end
	;
@@L1:	mov	al,ds:[esi]			;EAX = colours to skip
	lea	ebp,[ebp+4*eax]			;Skip colours
	mov	cl,ds:[esi+1]			;ECX = colours to copy
	add	esi,2
	or  	cl,cl				;test for zero
	jnz 	short @@L2
	mov 	ecx,256
	;
@@L2:	mov	eax,ds:[esi]			;EAX = Colour triple
	add	esi,3
	shl	eax,2
	and	eax,0ffffffh
	mov	ds:[ebp],eax
	add	ebp,4
	dec 	ecx
	jnz 	short @@L2
	;
	dec	ebx
	jnz	short @@L1

@@end:  clc
	pop ebp
	pop esi
	retn
FLC_Decompress_PAL18 ENDP


;
;
; FLC_Decompress_PAL24:
;  Input:
; 	ESI	- DATA32 ptr to source
;	EBP	- DATA32 ptr to destination
;  Output:
;	[CF]	- Error flag
;
FLC_Decompress_PAL24 PROC NEAR
	push 	esi
	push 	ebp

	xor	eax,eax				;EAX = 0
	xor	ecx,ecx				;ECX = 0
	movzx	ebx,w ds:[esi]			;EBX = Number of blocks
	add	esi,2
	test	ebx,ebx
	jz 	short @@end
	;
@@L1:	mov	al,ds:[esi]			;EAX = colours to skip
	lea	ebp,[ebp+4*eax]			;Skip colours
	mov	cl,ds:[esi+1]			;ECX = colours to copy
	add	esi,2
	or  	cl,cl				;test for zero
	jnz 	short @@L2
	mov 	ecx,256
	;
@@L2:	mov	eax,ds:[esi]			;EAX = Colour triple
	add	esi,3
	and	eax,0ffffffh
	mov	ds:[ebp],eax
	add	ebp,4
	dec 	ecx
	jnz 	short @@L2
	;
	dec	ebx
	jnz	short @@L1

@@end:  clc
	pop ebp
	pop esi
	retn
FLC_Decompress_PAL24 ENDP



;
;
; Find_CHar:
;  Input:
;	EBX	- DATA32 ptr to string
;      AL	- Character to search
;  Output:
;	EBX	- DATA32 ptr to found character or to end of string
;	[CF]	- Error flag
;
Find_Char PROC NEAR
@@L1:	cmp	b ds:[ebx],0
	je	short @@Err
	cmp	b ds:[ebx],al
	je	short @@Succ
	inc	ebx
	jmp	short @@L1

@@Succ:	clc
	retn

@@Err:	stc
	retn
Find_CHar ENDP
code32 ends
END
