;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
;
P486
LOCALS
JUMPS
GPL_SYSTEM_FILE		equ	1



;
;
;
;   GOMEZ PICTURE LIBRARY                                          v1.0
;
;
;
code32  segment para public use32
	assume cs:code32, ds:code32
	largestack


include gomez.inc
include gpl32.inc
include gplchunk.inc



;
;
;
;   GOMEZ PICTURE LIBRARY                              FILE I/O ROUTINES
;
;
;
;
;
; GPL_Alloc_Bitmap
;  Input:
;	EBX	- Width
;	ECX	- Height
;	EDX	- Depth
;  Output:
;	EAX	- DATA32 ptr to allocated texture header
;	[CF]	- error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GPL_Alloc_Bitmap
GPL_Alloc_Bitmap PROC NEAR
	push	ds
	push	es
	push	edi

	cld
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]

	mov	ds:[@@width],ebx
	mov	ds:[@@height],ecx
	mov	ds:[@@depth],edx
	;
	add	edx,7
	shr	edx,3
	imul	ecx,ebx				;ECX = width*height
	imul	ecx,edx
	add	ecx,GPL_BITMAP_SIZE
	call	Malloc
	jc	@@Err
	mov	edi,eax
	mov	ecx,GPL_BITMAP_SIZE/4
	xor	eax,eax
	rep	stosd
	sub	edi,GPL_BITMAP_SIZE
	;
	mov	ebx,ds:[@@width]
	mov	ecx,ds:[@@height]
	mov	edx,ds:[@@depth]
	mov	ds:[edi+Bitmap_Width],bx
	mov	ds:[edi+Bitmap_Height],cx
	mov	ds:[edi+Bitmap_Depth],dl
	mov	ds:[edi+Bitmap_Magic],edi
	mov	ds:[edi+Bitmap_Type],GPL_TYP_BITMAP
	mov	eax,edi				;EAX = return address
	clc
	;
@@Err:	pop	edi
	pop	es
	pop	ds
	retn

		ALIGN	DWORD
@@width		dd	?
@@height	dd	?
@@depth		dd	?
GPL_Alloc_Bitmap ENDP


;
;
; GPL_Open_Library:
;  Input:
;	EAX   	- ptr to world-header
;  Output:
;	CF	- error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GPL_Open_Library
GPL_Open_Library PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]


@@End:	clc
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
GPL_Open_Library ENDP


;
;
; GPL_Close_Library:
;  Input:
;	EAX   	- ptr to world-header
;  Output:
;	CF	- error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GPL_Close_Library
GPL_Close_Library PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]


@@End:	clc
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
GPL_Close_Library ENDP


;
;
; GPL_Load_Picture:
;  Input:
;	EAX   	- ptr to world-header
;  Output:
;	CF	- error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GPL_Load_Picture
GPL_Load_Picture PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]


@@End:	clc
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
GPL_Load_Picture ENDP
CODE32 ends
END