/***************************************************************************
 **
 ** (c) 1993,1994,1995 by Marc van Shaney , aka Kaya Memisoglu
 **
 ** This Source-Code was written by and is copyrighted by Kaya Memisoglu
 ** You may use the whole code or only parts of it in your own programs
 ** whether they are commercial or not. BUT you must give credits for these
 ** parts to me (Kaya Memisoglu  or  Marc van Shaney).
 ** I am not responsible for any damage or loss caused by this program, so
 ** if you success in erasing your harddisk with this code, then it is your
 ** own fault and you should not claim me to be responsible...
 ** I would be very pleased if you also sent me a postcard or even a letter
 ** if you can use this code. My address:
 **
 **        Kaya Memisoglu
 **        Reichenberger Ring 50
 **        63512 Hainburg
 **        Germany
 **
 ** You can also leave a message for Marc van Shaney on the Nirvana BBS:
 **
 **              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza
 **
 **
 **/


#include <dos.h>
#include <io.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <conio.h>




void Extract_File(char *fname,char *ename,long start,long end)
{
 int n,h;
 char *buf;
 long size_to_read;
 int size_read;

 if ((h=_open(fname,O_RDONLY))==-1)
	{
	 printf("\nERROR: Cannot open %s !!!\n",fname);
	 exit(-1);
	}
 lseek(h,start,SEEK_SET);


 printf("Extracting %s . . .\n",ename);
 if ((n=_creat(ename,0))==NULL)
	{
	 printf("\nERROR: Cannot create %s.\n",ename);
	 _close(h);
	 exit(-1);
	}

 size_to_read=end-start+1;
 buf=malloc(16000);
 while(size_to_read)
	{
	 if (size_to_read>16000L)
		size_read=16000;
	 else
		size_read=(unsigned int)size_to_read;
	 _read(h,buf,size_read);
	 _write(n,buf,size_read);
	 size_to_read-=(unsigned long)size_read;
	}
 _close(n);
 _close(h);
 free(buf);
 exit(1);
}





void main (void)
{
 long s,e;
 printf("\nFile GRABber                            (c)1995 by Marc van Shaney (CyberDyne)\n");
 if (_argc<3)
	{
	 printf("GRAB [srcname] [destname]\n");
	 printf("    [srcname] is the name of the file\n");
	 printf("    [destname] is the name of the file to be created\n");
	 exit(1);
	}
 printf("Start position (HEX):");
 scanf("%lX",&s);
 printf("End position (HEX):");
 scanf("%lX",&e);
 Extract_File(_argv[1],_argv[2],s,e);
}