;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
;
;
;
;   GOMEZ VIDEO INTERFACE
;
;
;
GVI_VERSION		equ	100h
GVI_FILE_VERSION	equ	100h
GVI_BUFFER_SIZE		equ	128
GVI_DOS_BUFFER		equ	1


GVI_MOVIE STRUC
	Movie_Name		db	32 dup (?)
	Movie_Width		dw	?
	Movie_Height		dw	?
	Movie_Depth		db	?,?,?,?
	Movie_Flags		dd	?
	Movie_Compression	dd	?
	Movie_Speed		dd	?
	Movie_Frames		dd	?
	Movie_Data_Rate		dd	?
	Movie_Wave_Rate		dd	?
	Movie_Wave_Depth	db	?
	Movie_Wave_Channels	db	?,?,?
				dd	14 dup (?)
	Movie_Palette		dd	?
	Movie_Current_Position	dd	?
	Movie_Current_Frame	dd	?
	Movie_Frame_Buffer	dd	?
	Movie_Handle		dd	?
	Movie_Film_Start	dd	?
	Movie_Index_Start	dd	?
	Movie_Compressor	dd	?
	Movie_DeCompressor	dd	?
GVI_MOVIE ENDS



GVI_BITMAP STRUC
	Bitmap_Name		db	32 dup (?)
	Bitmap_Magic		dd	?
	Bitmap_Type		dd	?
	Bitmap_Width		dw	?
	Bitmap_Height		dw	?
	Bitmap_Depth		db	?,?,?,?
	Bitmap_Flags		dd	?
	Bitmap_Palette		dd	?
				dd	2 dup (?)
GVI_BITMAP ENDS



GVI_BITMAP_SIZE		equ	(SIZE GVI_BITMAP)
GVI_MOVIE_SIZE		equ	(SIZE GVI_MOVIE)
GVI_PALETTE_SIZE	equ	(256*4)

GVI_FILE_MOVIE_SIZE	equ	(32*4)
GVI_FILE_BITMAP_SIZE	equ	(16*4)
GVI_FILE_PALETTE_SIZE	equ	(256*4)

GVI_TYP_BITMAP		equ	'PMB'
GVI_TYP_FRAME_BUFFER	equ	'MARF'


;
;
;
;   GOMEZ VIDEO INTERFACE                                        FLI-stuff
;
;
;

FLI_FILE_MAGIC       	equ	0af11h
FLC_FILE_MAGIC		equ	0af12h
FLI_FRAME_FILE_MAGIC   	equ	0f1fah
FLI_PREFIX_FILE_MAGIC 	equ	0f100h

FLI_CHUNK_PAL18         equ  	11
FLI_CHUNK_DELTA_FLI     equ 	12
FLI_CHUNK_PAL24		equ	4
FLI_CHUNK_DELTA_FLC	equ	7
FLI_CHUNK_PSTAMP	equ	18
FLI_CHUNK_BLACK         equ  	13
FLI_CHUNK_BRUN          equ  	15
FLI_CHUNK_COPY          equ 	16


FLI_MAIN_HEADER STRUC
	FLI_Header_Size		dd	?
	FLI_Header_Magic	dw	?
	FLI_Header_Frames	dw	?
	FLI_Header_Width	dw	?
	FLI_Header_Height	dw	?
	FLI_Header_Depth	dw	?
	FLI_Header_Flags	dw	?
	FLI_Header_Speed	dd	?
				dw	?
				dd	?,?,?,?
	FLI_Header_Aspect_X	dw	?
	FLI_Header_Aspect_Y	dw	?
				db	38 dup (?)
	FLI_Header_First_Frame	dd	?
	FLI_Header_Second_Frame	dd	?
				dd	?
				db	36 dup (?)
FLI_MAIN_HEADER ENDS


FLI_FRAME_HEADER STRUC
	FLI_Frame_Size		dd	?
	FLI_Frame_Magic		dw	?
	FLI_Frame_Chunks	dw	?
				dd	?,?
FLI_FRAME_HEADER ENDS


FLI_CHUNK_HEADER STRUC
	FLI_Chunk_Size		dd	?
	FLI_Chunk_Type		dw	?
FLI_CHUNK_HEADER ENDS


FLI_PREFIX_HEADER STRUC
	FLI_Prefix_Size		dd	?
	FLI_Prefix_Magic	dw	?
	FLI_Prefix_Chunks	dw	?
				dd	?,?
FLI_PREFIX_HEADER ENDS


;
;
;
;   GOMEZ VIDEO INTERFACE                             function declarations
;
;
;
;
;
; These are just the normal function- and variable-definitions....
;
ifndef GVI_SYSTEM_FILE
extrn C Init_GVI:near
extrn C Exit_GVI:near
extrn C GVI_Get_Compressor:near
extrn C GVI_Compress_Frame:near
extrn C GVI_Seek_Frame:near
extrn C GVI_Next_Frame:near
extrn C GVI_Open_Video:near
extrn C GVI_Close_Video:near
extrn C GVI_Creat_Video:near
extrn C GVI_Finish_Video:near
endif