;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;͵
;                                                                           
; X-Mode Potions (C)opyright by:                                            
;                                                                           
;  MODEX.ASM - A Complete Mode X Library                                    
;                                                                           
;     Version 1.04 Release, 3 May 1993, By Matt Pritchard                   
;     With considerable input from Michael Abrash                           
;                                                                           
;     The following information is donated to the public domain in          
;     the hopes that save other programmers much frustration.               
;                                                                           
;     If you do use this code in a product, it would be nice if             
;     you include a line like "Mode X routines by Matt Pritchard"           
;     in the credits.                                                       
;                                                                           
;;
;
P486
LOCALS
JUMPS

code32  segment para public use32
	assume cs:code32, ds:code32
	largestack



Text_Mode	  	equ 	3
CRTC_Index        	equ 	3d4h
CRTC_Data         	equ 	3d5h
CRTC_Status       	equ 	3dah
Display_Enable    	equ 	01
Vertical_Sync     	equ 	08
__SVGA_System_File     	equ	1

;
;
;
;   SVGA-Unit                                                      v1.0
;
;
;
include gomez.inc
include svga.inc
include keys.inc

b	equ	byte ptr
w	equ	word ptr
d	equ	dword ptr

Free_and_Zero	MACRO a
	LOCAL J
	mov	ecx,a
	test	ecx,ecx
	jz	short J
	call	Free
	mov	a,0
J:	ENDM

Wait_Retrace MACRO
	LOCAL N1,N2
	mov 	dx,3dah
N1:	in 	al,dx
	test 	al,01h
	jnz 	short N1
N2:	in 	al,dx
	test 	al,08h
	jz 	short N2
	ENDM

VESA_Retrace MACRO
	push	ds
	mov	ebx,80h			;Set display during vertical
	xor	ecx,ecx
	xor	edx,edx
	mov	ds,ds:[vesa_pm_selector]
	call	cs:[vesa_pm_set_display]
	pop	ds
	ENDM

cwait 	MACRO
	LOCAL J1,J2,J3,J4
	jmp	short J3
J1:	jmp	short J4
J2:     jmp	short J1
J3:	jmp	short J2
J4:	ENDM





;
;
;
;   SVGA-Unit                                                    DATA-Area
;
;
;
ALIGN DWORD
PUBLIC C SVGA_Flags
PUBLIC C SVGA_Frame_Buffer
PUBLIC C SVGA_Old_Frame_Buffer
PUBLIC C SVGA_Display_Width
PUBLIC C SVGA_Display_Height
PUBLIC C SVGA_Display_Depth
PUBLIC C SVGA_Bytes_per_Line

SVGA_Frame_Buffer	dd ?
SVGA_Old_Frame_Buffer	dd ?
SVGA_Flags		dd ?
SVGA_Display_Width	dd ?
SVGA_Display_Height	dd ?
SVGA_Display_Depth	dd ?
SVGA_Bytes_per_Line	dd ?
;
palette_buffer		LABEL BYTE
VESA_Info             	db 1024 dup (?)
fbuffers		LABEL DWORD
fbuffer1		dd 0
fbuffer2		dd 0
			dd 14 dup (0)	;Support for 16 pages
current_draw_page	dd ?
current_display_page	dd ?
vesa_mapper      	dd ?
vesa_gran_offset 	dd ?
vesa_low_window  	dd ?
vesa_high_window 	dd ?
vesa_granularity 	db ?
vesa_bankswitch  	dd ?
vesa_palette		dd ?
vesa_ramp		dd ?
vesa_apperture		dd ?
vesa_memory		dd ?
vesa_pages		dd ?
vesa_pm_selector	dd ?
vesa_pm_set_palette	dd ?
vesa_pm_set_display	dd ?
vesa_pm_set_window	dd ?
fake_table		dd ?


mode_txt0		db	"   VESA  Mode "
std_modes		dd      320,200,8,10013h
			db	" Standard VGA 320x200x8bpp",0,0,0,0,0,0
			dd	640,350,4,20010h
			db	" Standard EGA 640x350x4bpp",0,0,0,0,0,0
			dd	640,480,4,20012h
			db	" Standard VGA 640x480x4bpp",0,0,0,0,0,0
			dd	320,200,8,40000h
			db	"  Mode-X  VGA 320x200x8bpp",0,0,0,0,0,0
			dd	320,240,8,40001h
			db	"  Mode-X  VGA 320x240x8bpp",0,0,0,0,0,0
			dd	320,400,8,40002h
			db	"  Mode-X  VGA 320x400x8bpp",0,0,0,0,0,0
			dd	320,480,8,40003h
			db	"  Mode-X  VGA 320x480x8bpp",0,0,0,0,0,0
			dd	360,200,8,40004h
			db	"  Mode-X  VGA 360x200x8bpp",0,0,0,0,0,0
			dd	360,240,8,40005h
			db	"  Mode-X  VGA 360x240x8bpp",0,0,0,0,0,0
			dd	360,400,8,40006h
			db	"  Mode-X  VGA 360x400x8bpp",0,0,0,0,0,0
			dd	360,480,8,40007h
			db	"  Mode-X  VGA 360x480x8bpp",0,0,0,0,0,0
			dd	320,080,16,80001h
			db	"  Orange  VGA 320x80x18bpp",0,0,0,0,0,0
			dd	320,160,16,80003h
			db	"  Orange  VGA 320x160x18bpp",0,0,0,0,0
			dd	360,080,16,80005h
			db	"  Orange  VGA 360x80x18bpp",0,0,0,0,0,0
			dd	360,160,16,80007h
			db	"  Orange  VGA 360x160x18bpp",0,0,0,0,0
			dd	160,200,15,100000h
			db	"  Fake-X  VGA 160x200x14bpp",0,0,0,0,0
			dd	160,240,15,100001h
			db	"  Fake-X  VGA 160x240x14bpp",0,0,0,0,0
			dd	160,400,15,100002h
			db	"  Fake-X  VGA 160x400x14bpp",0,0,0,0,0
			dd	160,480,15,100003h
			db	"  Fake-X  VGA 160x480x14bpp",0,0,0,0,0
			dd	180,200,15,100004h
			db	"  Fake-X  VGA 180x200x14bpp",0,0,0,0,0
			dd	180,240,15,100005h
			db	"  Fake-X  VGA 180x240x14bpp",0,0,0,0,0
			dd	180,400,15,100006h
			db	"  Fake-X  VGA 180x400x14bpp",0,0,0,0,0
			dd	180,480,15,100007h
			db	"  Fake-X  VGA 180x480x14bpp",0,0,0,0,0
			dd	0ffffh

header		db	"   Select the Resolution of Your Desire                       Marc van Shaney   "

opt_NoVGA	db	"/NOVGA",0
opt_NoVESA	db	"/NOVESA",0
opt_NoLinBuf	db	"/NOLINBUF",0
opt_NoTweak	db	"/NOTWEAK",0
opt_NoPages	db	"/NOPAGES",0
opt_NoVESAPM	db	"/NOVESAPM",0
opt_WaitRetrace	db	"/WAITRETRACE",0
opt_NoVBE2	db	"/NOVBE2",0
opt_BIOSPal	db	"/BIOSPAL",0
opt_Vmode	db	"/VMODE=~",0

;
;   SVGA-Unit                                              Tweak-Mode stuff
;
twk_320x200 LABEL WORD
	 dw 04109h                          ; cell height (2 scan lines)
	 dw 00014h                          ; dword mode off
	 dw 0e317h                          ; turn on byte mode
	 ; crtc setup data for 320 horz pixels
	 dw 05f00h                          ; horz total
	 dw 04f01h                          ; horz displayed
	 dw 05002h                          ; start horz blanking
	 dw 08203h                          ; end horz blanking
	 dw 05404h                          ; start h sync
	 dw 08005h                          ; end h sync
	 ; crtc setup data for 200/400 line modes
	 dw 0bf06h                          ; vertical total
	 dw 01f07h                          ; overflow
	 dw 09c10h                          ; v sync start
	 dw 08e11h                          ; v sync end/prot cr0 cr7
	 dw 08f12h                          ; vertical displayed
	 dw 09615h                          ; v blank start
	 dw 0b916h                          ; v blank end
	 dw 0
twk_320x240 LABEL WORD
	 dw 04109h                          ; cell height (2 scan lines)
	 dw 00014h                          ; dword mode off
	 dw 0e317h                          ; turn on byte mode
	 ; crtc setup data for 320 horz pixels
	 dw 05f00h                          ; horz total
	 dw 04f01h                          ; horz displayed
	 dw 05002h                          ; start horz blanking
	 dw 08203h                          ; end horz blanking
	 dw 05404h                          ; start h sync
	 dw 08005h                          ; end h sync
	 ; crtc setup data for 240/480 line modes
	 dw 00d06h                          ; vertical total
	 dw 03e07h                          ; overflow
	 dw 0ea10h                          ; v sync start
	 dw 08c11h                          ; v sync end/prot cr0 cr7
	 dw 0df12h                          ; vertical displayed
	 dw 0e715h                          ; v blank start
	 dw 00616h                          ; v blank end
	 dw 0                               ; end of crtc data for 240/480 lines
twk_320x400 LABEL WORD
	 dw 04009h                          ; cell height (1 scan line)
	 dw 00014h                          ; dword mode off
	 dw 0e317h                          ; turn on byte mode
	 ; crtc setup data for 320 horz pixels
	 dw 05f00h                          ; horz total
	 dw 04f01h                          ; horz displayed
	 dw 05002h                          ; start horz blanking
	 dw 08203h                          ; end horz blanking
	 dw 05404h                          ; start h sync
	 dw 08005h                          ; end h sync
	 ; crtc setup data for 200/400 line modes
	 dw 0bf06h                          ; vertical total
	 dw 01f07h                          ; overflow
	 dw 09c10h                          ; v sync start
	 dw 08e11h                          ; v sync end/prot cr0 cr7
	 dw 08f12h                          ; vertical displayed
	 dw 09615h                          ; v blank start
	 dw 0b916h                          ; v blank end
	 dw 0
twk_320x480 LABEL WORD
	 dw 04009h                          ; cell height (1 scan line)
	 dw 00014h                          ; dword mode off
	 dw 0e317h                          ; turn on byte mode
	 ; crtc setup data for 320 horz pixels
	 dw 05f00h                          ; horz total
	 dw 04f01h                          ; horz displayed
	 dw 05002h                          ; start horz blanking
	 dw 08203h                          ; end horz blanking
	 dw 05404h                          ; start h sync
	 dw 08005h                          ; end h sync
	 ; crtc setup data for 240/480 line modes
	 dw 00d06h                          ; vertical total
	 dw 03e07h                          ; overflow
	 dw 0ea10h                          ; v sync start
	 dw 08c11h                          ; v sync end/prot cr0 cr7
	 dw 0df12h                          ; vertical displayed
	 dw 0e715h                          ; v blank start
	 dw 00616h                          ; v blank end
	 dw 0                               ; end of crtc data for 240/480 lines
twk_360x200 LABEL WORD
	 dw 04109h                          ; cell height (2 scan lines)
	 dw 00014h                          ; dword mode off
	 dw 0e317h                          ; turn on byte mode
	 ; crtc setup data for 360 horz pixels
	 dw 06b00h                          ; horz total
	 dw 05901h                          ; horz displayed
	 dw 05a02h                          ; start horz blanking
	 dw 08e03h                          ; end horz blanking
	 dw 05e04h                          ; start h sync
	 dw 08a05h                          ; end h sync
	 ; crtc setup data for 200/400 line modes
	 dw 0bf06h                          ; vertical total
	 dw 01f07h                          ; overflow
	 dw 09c10h                          ; v sync start
	 dw 08e11h                          ; v sync end/prot cr0 cr7
	 dw 08f12h                          ; vertical displayed
	 dw 09615h                          ; v blank start
	 dw 0b916h                     	    ; v blank end
	 dw 0
twk_360x240 LABEL WORD
	 dw 04109h                          ; cell height (2 scan lines)
	 dw 00014h                          ; dword mode off
	 dw 0e317h                          ; turn on byte mode
	 ; crtc setup data for 360 horz pixels
	 dw 06b00h                          ; horz total
	 dw 05901h                          ; horz displayed
	 dw 05a02h                          ; start horz blanking
	 dw 08e03h                          ; end horz blanking
	 dw 05e04h                          ; start h sync
	 dw 08a05h                          ; end h sync
	 ; crtc setup data for 240/480 line modes
	 dw 00d06h                          ; vertical total
	 dw 03e07h                          ; overflow
	 dw 0ea10h                          ; v sync start
	 dw 08c11h                          ; v sync end/prot cr0 cr7
	 dw 0df12h                          ; vertical displayed
	 dw 0e715h                          ; v blank start
	 dw 00616h                          ; v blank end
	 dw 0                               ; end of crtc data for 240/480 lines
twk_360x400 LABEL WORD
	 dw 04009h                          ; cell height (1 scan line)
	 dw 00014h                          ; dword mode off
	 dw 0e317h                          ; turn on byte mode
	 ; crtc setup data for 360 horz pixels
	 dw 06b00h                          ; horz total
	 dw 05901h                          ; horz displayed
	 dw 05a02h                          ; start horz blanking
	 dw 08e03h                          ; end horz blanking
	 dw 05e04h                          ; start h sync
	 dw 08a05h                          ; end h sync
	 ; crtc setup data for 200/400 line modes
	 dw 0bf06h                          ; vertical total
	 dw 01f07h                          ; overflow
	 dw 09c10h                          ; v sync start
	 dw 08e11h                          ; v sync end/prot cr0 cr7
	 dw 08f12h                          ; vertical displayed
	 dw 09615h                          ; v blank start
	 dw 0b916h                     	    ; v blank end
	 dw 0
twk_360x480 LABEL WORD
	 dw 04009h                          ; cell height (1 scan line)
	 dw 00014h                          ; dword mode off
	 dw 0e317h                          ; turn on byte mode
	 ; crtc setup data for 360 horz pixels
	 dw 06b00h                          ; horz total
	 dw 05901h                          ; horz displayed
	 dw 05a02h                          ; start horz blanking
	 dw 08e03h                          ; end horz blanking
	 dw 05e04h                          ; start h sync
	 dw 08a05h                          ; end h sync
	 ; crtc setup data for 240/480 line modes
         dw 00d06h                          ; vertical total
	 dw 03e07h                          ; overflow
         dw 0ea10h                          ; v sync start
	 dw 08c11h                          ; v sync end/prot cr0 cr7
	 dw 0df12h                          ; vertical displayed
	 dw 0e715h                          ; v blank start
         dw 00616h                          ; v blank end
	 dw 0                               ; end of crtc data for 240/480 lines


tweak_table	LABEL DWORD
		dd	320,200,OFFSET twk_320x200,063h
		dd	320,240,OFFSET twk_320x240,0e3h
		dd	320,400,OFFSET twk_320x400,063h
		dd	320,480,OFFSET twk_320x480,0e3h
		dd	360,200,OFFSET twk_360x200,067h
		dd	360,240,OFFSET twk_360x240,0e7h
		dd	360,400,OFFSET twk_360x400,067h
		dd	360,480,OFFSET twk_360x480,0e7h


turn_screen_off MACRO
	mov 	dx,03dah
	in 	al,dx
	mov 	dx,03c0h
	mov 	al,0
	out 	dx,al
	ENDM

turn_screen_on MACRO
	mov 	dx,03dah
	in 	al,dx
	mov 	dx,03c0h
	mov 	al,20h
	out 	dx,al
	ENDM

attrib_ctrl     	equ 03c0h      ; vga attribute controller
gc_index        	equ 03ceh      ; vga graphics controller
sc_index        	equ 03c4h      ; vga sequencer controller
sc_data        	 	equ 03c5h      ; vga sequencer data port
crtc_index      	equ 03d4h      ; vga crt controller
crtc_data       	equ 03d5h      ; vga crt controller data
misc_output     	equ 03c2h      ; vga misc register
input_1         	equ 03dah      ; input status #1 register

pixel_pan_reg   	equ 033h       ; attrib index: pixel pan reg
map_mask        	equ 002h       ; sequ index: write map mask reg
read_map        	equ 004h       ; gc index: read map register
start_disp_hi   	equ 00ch       ; crtc index: display start hi
start_disp_lo   	equ 00dh       ; crtc index: display start lo

map_mask_plane1 	equ 00102h     ; map register + plane 1
map_mask_plane2 	equ 01102h     ; map register + plane 2
all_planes_on   	equ 00f02h     ; map register + all bit planes

chain4_off      	equ 00604h     ; chain 4 mode off
async_reset     	equ 00100h     ; (a)synchronous reset
sequ_restart    	equ 00300h     ; sequencer restart

latches_on      	equ 00008h     ; bit mask + data from latches
latches_off     	equ 0ff08h     ; bit mask + data from cpu

vert_retrace    	equ 08h        ; input_1: vertical retrace bit
all_planes      	equ 0fh        ; all bit planes selected
char_bits       	equ 0fh        ; bits 0-3 of character data



;
;
;
;   SVGA-Unit                                                    Init-Code
;
;
;
;
;
; SVGA_Scan_Modes
;   Input:
;	EAX	- Mode flags:
;		   bit 16  -  4bit modes
;		   bit 17  -  8bit modes
;		   bit 18  - 15bit modes
;		   bit 19  - 16bit modes
;		   bit 20  - 24bit modes
;		   bit 21  - 32bit modes
;   Output:
;	EAX	- DATA32 ptr to list with all modes
; 	[CF]	- Error flag
;
; Mode-List:
;   32 bytes	- VGA-Model name
;   1	dword	- Number of modes
;
;   Modes:
;	dword	  - Mode Width
;	dword	  - Mode Height
;	dword	  - Mode Depth
;	dword	  - Mode Number
;      32 bytes  - Mode text
;
PUBLIC C SVGA_Scan_Modes
SVGA_Scan_Modes PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	mov	ds:[@@flags],eax
	;
	mov	eax,OFFSET opt_NoTweak
	call	Scan_Argument
	jc	short @@17
	or	ds:[@@flags],SVGA_No_Tweak_Modes
@@17:	;
	mov	ecx,36
	call	Malloc
	jc	@@Err
	mov	ebp,eax			;EBP = Mode list
	mov	d ds:[ebp+32],0		;Set zero modes

	;
	;   Scan standard modes, fake and Orange modes
	;
	mov	eax,OFFSET opt_NoVGA
	call	Scan_Argument
	jnc	@@VESA

	mov	esi,OFFSET std_modes
@@L2:   mov	eax,ds:[esi]		;Get width
	cmp	ax,0ffffh
	je	@@VESA
	test	ds:[@@flags],SVGA_No_Tweak_Modes
	jz	short @@T9
	test	d ds:[esi+12],40000h+80000h+100000h
	jnz	@@Nxt2
	;
@@T9:	mov     eax,ds:[esi+8]		;EAX = colour depth
	cmp	al,4
	jne	short @@T6
		test	ds:[@@flags],SVGA_4bit_Modes
		jz	short @@Nxt2
		jmp	short @@Inf2
@@T6:	cmp	al,8
	jne	short @@T7
		test	ds:[@@flags],SVGA_8bit_Modes
		jz	short @@Nxt2
		jmp	short @@Inf2
@@T7:	cmp	al,15
	jne	short @@T8
		test	ds:[@@flags],SVGA_15bit_Modes
		jz	short @@Nxt2
		jmp	short @@Inf2
@@T8:	cmp	al,16
	jne	short @@Nxt2
		test	ds:[@@flags],SVGA_16bit_Modes
		jz	short @@Nxt2
		jmp	short @@Inf2
@@Inf2: ;
	mov	ebx,ebp			;EBX = ptr to mode-list
	mov	ecx,ds:[ebp+32]		;ECX = number of stored modes
	imul	ecx,32+16
	add	ecx,36+32+16
	call	Realloc
	jc	@@Err
	mov	ebp,eax			;EBP = ptr to new mode-list
	mov	ecx,ds:[eax+32]		;ECX = number of modes
	inc	dword ptr ds:[ebp+32]
	imul	ecx,32+16
	add	ecx,36
	lea	edi,[ebp+ecx]		;EDI = ptr to this mode entry
	mov	ecx,(32+16)/4		;ECX = entry-size
	rep	movsd
	jmp	@@L2
	;
@@Nxt2:	add	esi,32+16
	jmp	@@L2

	;
	;   Scan VESA modes
	;
@@VESA: mov	eax,OFFSET opt_NoVESA
	call	Scan_Argument
	jnc     @@Rdy

	mov	eax,ds:[DATA32_Address]
	add	eax,OFFSET VESA_Info
	mov	ebx,eax
	and	ebx,0fh
	shr	eax,4
	mov	ds:[v86_es],ax         	;Set ES to data-segment...
	mov	ds:[v86_eax],4f00h	; check for VESA adapter
	mov	ds:[v86_edi],ebx  	; answer goes here (a safe place)
	mov	eax,10h
	call	Invoke_Real_Int		; do it
	cmp	ds:[v86_ax],004fh	; successful response?
	jne	@@Rdy 			; nope.  Not a VESA adapter
	cmp	dword ptr ds:[VESA_Info],'ASEV'	; string == 'VESA'?
	jne	@@Rdy	 		; nope.  Not a VESA adapter
	;
	movzx	esi,word ptr ds:[VESA_Info+8]
	movzx	eax,word ptr ds:[VESA_Info+6]
	shl	esi,4
	add	esi,eax
	sub	esi,ds:[DATA32_Address]	;ESI = ptr to OEM-name
	mov	edi,ebp
	mov	ecx,32/4
	rep	movsd			;Copy name
	;
	movzx	eax,w ds:[VESA_Info+14]	;EAX = Offset of videomode-table
	movzx	esi,w ds:[VESA_Info+16]	;ESI = Segment
	shl	esi,4
	add	esi,eax
	sub	esi,ds:[DATA32_Address]	;ESI = ptr to mode-table
	;
@@L1:   movzx	eax,w ds:[esi]		;EAX = supported video-mode
	cmp	eax,0ffffh
	je	@@Rdy			;EAX = 0ffffh  ==> Ready
	;
	mov	edx,ds:[DATA32_Address]
	add	edx,OFFSET VESA_Info
	mov	ebx,edx
	and	ebx,0fh
	shr	edx,4
	mov	ds:[v86_es],dx        	;Set ES to data-segment...
	mov	ds:[v86_eax],4f01h	; ask about this video mode
	mov	ds:[v86_ecx],eax	;  this mode
	mov	ds:[v86_edi],ebx
	mov	eax,10h
	call	Invoke_Real_Int
	;
	test	ds:[VESA_Info],1
	jz	@@Nxt
	mov	al,b ds:[VESA_Info+25]	;AL = depth
	cmp	al,4
	jne	short @@T1
		test	ds:[@@flags],SVGA_4bit_Modes
		jnz	@@Info
		jmp	@@Nxt
@@T1:	cmp	al,8
	jne	short @@T2
		test	ds:[@@flags],SVGA_8bit_Modes
		jnz	@@Info
		jmp	@@Nxt
@@T2:	cmp	al,15
	jne	short @@T3
		test	ds:[@@flags],SVGA_15bit_Modes
		jnz	@@Info
		jmp	@@Nxt
@@T3:	cmp	al,16
	jne	short @@T4
		test	ds:[@@flags],SVGA_16bit_Modes
		jnz	@@Info
		jmp	@@Nxt
@@T4:	cmp	al,24
	jne	short @@T5
		test	ds:[@@flags],SVGA_24bit_Modes
		jnz	@@Info
		jmp	@@Nxt
@@T5:	cmp	al,32
	jne	@@Nxt
		test	ds:[@@flags],SVGA_32bit_Modes
		jnz	@@Info
		jmp	@@Nxt
	;
@@Info:	mov	ebx,ebp			;EBX = ptr to mode-list
	mov	ecx,ds:[ebp+32]		;ECX = number of stored modes
	imul	ecx,32+16
	add	ecx,36+32+16
	call	Realloc
	jc	@@Err
	mov	ebp,eax			;EBP = ptr to new mode-list
	mov	ecx,ds:[eax+32]		;ECX = number of modes
	inc	dword ptr ds:[ebp+32]
	imul	ecx,32+16
	add	ecx,36
	lea	edi,[ebp+ecx]		;EDI = ptr to this mode entry
	movzx	ecx,w ds:[esi]		;ECX = mode number
	mov	ds:[edi+12],ecx		;Save mode number
	;
	push	esi
	movzx	eax,w ds:[VESA_Info+18]	;EAX = width
	mov	ds:[edi],eax
	movzx	eax,w ds:[VESA_Info+20]	;EAX = height
	mov	ds:[edi+4],eax
	movzx	eax,b ds:[VESA_Info+25]	;EAX = depth
	mov	ds:[edi+8],eax
	add	edi,16			;EDI = ptr to mode text

	mov	esi,OFFSET mode_txt0
	mov	ecx,14
	rep	movsb
	movzx	edx,w ds:[VESA_Info+18]	;EDX = width
	call	Long2Text
	mov	al,'x'
	stosb
	movzx	edx,w ds:[VESA_Info+20]	;EDX = height
	call	Long2Text
	mov	al,'x'
	stosb
	movzx	edx,b ds:[VESA_Info+25]	;EDX = depth
	call	Long2Text
	mov	eax,'ppb'
	stosd
	pop	esi
	;
@@Nxt:	add	esi,2
	jmp	@@L1

	;
	;   The end
	;
@@Rdy:	mov	eax,ebp			;EAX = mode-list
@@End:	clc
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn

@@Err:	stc
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn

@@flags		dd	?
SVGA_Scan_Modes ENDP


;
;
; SVGA_Select_Mode
;   Input:
;	EAX	- DATA32 ptr to list with all modes
;   Output:
;	EAX	- Selected mode number
;	EBX	- Selected entry number
;	ECX	- DATA32 ptr to mode-lst entry
; 	[CF]	- Error flag	(set on ESC)
;
PUBLIC C SVGA_Select_Mode
SVGA_Select_Mode PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	mov	ds:[@@sel],0
	mov	ds:[@@pos0],0
	mov	ds:[@@List],eax
	;
	mov	edi,eax			;DS:EDI = list-ptr
	mov	eax,OFFSET opt_VMODE
	call	Scan_Argument		;Is there a /VMODE= on the
	jc	short @@Doit		;  command line ?
	lea	esi,[eax+7]		;ESI = ptr to first number
	call	Text2Long		;EAX = Video-Mode
	jc	@@Doit
	;
	xor	ebx,ebx			;EBX = Mode-entry counter
	mov	ecx,ds:[edi+32]		;ECX = number of modes
	lea	edi,[edi+36]		;EDI = ptr to first entry
	test	ecx,ecx                 ;No entries ???
	jz	@@Err
	@@L4:	cmp	ds:[edi+12],eax	;Is it this mode ?
		je	short @@This
		add	edi,32+16	;Skip to next entry
		inc	ebx		;EBX = Entry-number
		cmp	ebx,ecx
		jb	short @@L4
		jmp	@@Err
@@This:	mov	ecx,edi			;ECX = ptr to entry
	jmp	@@End2			;EAX = mode constant
@@Doit:	;
	mov 	ds:[v86_ax],Text_Mode
	mov	eax,10h
	call	Invoke_Real_Int		;Set 80x25 text mode
	;
	mov	edi,0b8000h
	sub	edi,ds:[DATA32_Address]
	mov	esi,OFFSET header
	mov	ecx,80
	mov	ah,3bh			;Background attribute
	@@L1:	lodsb
		stosw
		dec	ecx
		jnz	short @@L1
	;
@@Rdrw:	mov	edi,0b8000h+4*160+50
	sub	edi,ds:[DATA32_Address]
	mov	ebp,ds:[@@pos0]		;EBP = First position to display
	mov	esi,ds:[@@list]		;ESI = ptr to list
	mov	edx,ds:[esi+32]		;EDX = number of entries
	sub	edx,ebp			;EDX -= first entry
	cmp	edx,18
	jl	short @@J1
	mov	edx,17
@@J1:	imul	ecx,ebp,16+32

	lea	esi,[esi+ecx+36+16]	;ESI = ptr to first mode-text
@@L2:	push	edi
	push	esi
	mov	ah,0bh
	mov	ecx,80-50
	cmp	ebp,ds:[@@sel]
	jne	short @@L3
	mov	ah,3bh
	@@L3:	lodsb
		test	al,al
		jz	short @@Nxt
		stosw
		dec	ecx
		jmp	short @@L3
@@Nxt:	rep	stosw
	pop	esi
	pop	edi
	add	esi,32+16
	add	edi,160
	inc	ebp
	dec	edx
	jnz	short @@L2
	;
@@key:	GETKEY32
	test	eax,eax
	jz	@@key
	cmp	eax,Return
	je	@@End
	cmp	eax,Cursor_Up
	jne	short @@K1
		mov	eax,ds:[@@sel]
		dec	eax
		js	short @@key
		mov	ds:[@@sel],eax
		cmp	eax,ds:[@@pos0]
		jae	@@Rdrw
		mov	ds:[@@pos0],eax
		jmp	@@Rdrw
@@K1:	cmp	eax,Cursor_Down
	jne	short @@K2
		mov	eax,ds:[@@sel]
		mov	ebx,ds:[@@list]
		inc	eax
		cmp	eax,ds:[ebx+32]
		jae	@@key
		mov	ds:[@@sel],eax
		sub	eax,ds:[@@pos0]
		cmp	eax,17
		jl	@@rdrw
		inc	ds:[@@pos0]
		jmp	@@rdrw
@@K2:	cmp	eax,Escape
	jne	@@key
		jmp	@@Err
	;
@@End:  mov	ecx,ds:[@@list]		;ECX = ptr to list
	mov	ebx,ds:[@@sel]		;EBX = selected entry
	imul	edx,ebx,32+16
	lea	ecx,[edx+ecx+36]	;ECX = ptr to entry
	mov	eax,ds:[ecx+12]		;EAX = mode-number
@@End2:	clc
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn

@@Err:  xor	eax,eax
	xor	ebx,ebx
	xor	ecx,ecx
	stc
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn

@@sel		dd	?
@@pos0          dd	?
@@list		dd	?
SVGA_Select_Mode ENDP



;
;
; Init_SVGA:
;   Input:
;	EAX	- Mode number
;   Output:
;	[CF]	- error flag
;
PUBLIC C Init_SVGA
Init_SVGA PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi

	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	mov	edi,eax			;EDI = Mode-Number
	mov	ds:[SVGA_Flags],0
	;
	mov	eax,OFFSET opt_WaitRetrace
	call	Scan_Argument
	jc	short @@18
	or	ds:[SVGA_Flags],SVGA_Wait_Retrace
@@18:	;
	mov	eax,OFFSET opt_BIOSPal
	call	Scan_Argument
	jc	short @@19
	or	ds:[SVGA_Flags],SVGA_BIOS_Palette
@@19:	;
	test	edi,10000h		;Standard-VGA-Mode
	jnz	@@VGA
	test	edi,40000h+80000h+100000h
	jnz	@@Twk

	;
	;   Setup VESA modes
	;
	or	ds:[SVGA_Flags],SVGA_VESA_Mode
	mov	eax,ds:[DATA32_Address]
	add	eax,OFFSET VESA_Info
	mov	ebx,eax
	and	ebx,0fh
	shr	eax,4
	mov	ds:[v86_es],ax         	;Set ES to data-segment...
	mov	ds:[v86_eax],4f00h	; check for VESA adapter
	mov	ds:[v86_edi],ebx  	; answer goes here (a safe place)
	mov	eax,10h
	call	Invoke_Real_Int		; do it
	cmp	ds:[v86_ax],004fh	; successful response?
	jne	@@err 			; nope.  Not a VESA adapter
	cmp	dword ptr ds:[VESA_Info],'ASEV'	; string == 'VESA'?
	jne	@@err	 		; nope.  Not a VESA adapter
	;
	movzx	eax,w ds:[VESA_Info+18]	;EAX = number of 64k blocks on board
	shl	eax,16
	mov	ds:[vesa_memory],eax	;Save total memory
	;
	movzx	eax,w ds:[VESA_Info+14]	;EAX = Offset of videomode-table
	movzx	ebx,w ds:[VESA_Info+16]	;EBX = Segment
	shl	ebx,4
	add	ebx,eax
	sub	ebx,ds:[DATA32_Address]
	@@L1:   movzx	eax,w ds:[ebx]	;EAX = supported video-mode
		add	ebx,2
		cmp	eax,0ffffh
		je	@@Err
		cmp	eax,edi
		jne	short @@L1
	;
	test	ds:[VESA_Info+10],3
	jz	short @@17
	or	ds:[SVGA_Flags],SVGA_Wait_Retrace
@@17:	;
	mov	eax,ds:[DATA32_Address]
	add	eax,OFFSET VESA_Info
	mov	ebx,eax
	and	ebx,0fh
	shr	eax,4
	mov	ds:[v86_es],ax        	;Set ES to data-segment...
	mov	ds:[v86_eax],4f01h	; ask about this video mode
	mov	ds:[v86_ecx],edi	; this mode
	mov	ds:[v86_edi],ebx
	mov	eax,10h
	call	Invoke_Real_Int
	;
	movzx	eax,w ds:[VESA_Info+16]
	mov	ds:[SVGA_Bytes_per_Line],eax
	movzx	eax,w ds:[VESA_Info+18]
	mov	ds:[SVGA_Display_Width],eax
	movzx	eax,w ds:[VESA_Info+20]
	mov	ds:[SVGA_Display_Height],eax
	movzx	eax,b ds:[VESA_Info+25]
	mov	ds:[SVGA_Display_Depth],eax
	cmp	eax,8
	ja	short @@4
	or	ds:[SVGA_Flags],SVGA_Palette_Mode
@@4:    cmp	eax,8
	jbe	short @@5
	test	ds:[VESA_Info+39],1
	jz	short @@5
	or	ds:[SVGA_Flags],SVGA_Ramp_Mode
@@5:	movzx	eax,b ds:[VESA_Info+29]
	inc	eax
	mov	ds:[vesa_pages],eax
	mov	eax,d ds:[VESA_Info+40]
	mov	ds:[vesa_apperture],eax
	;
	test	w ds:[VESA_Info],1	;Mode supported
	jz	@@err
	test	w ds:[VESA_Info],32
	jz	short @@1
	or	ds:[SVGA_Flags],SVGA_VGA_Hardware
@@1:    mov	eax,OFFSET opt_NoLinBuf
	call	Scan_Argument
	jnc	@@banked_setup
	mov	eax,OFFSET opt_NoVBE2
	call	Scan_Argument
	jnc	@@banked_setup
	cmp	ds:[vesa_apperture],0
	je	@@banked_setup
	test	w ds:[VESA_Info],128
	jnz	@@Linear_Setup
	;
	;   Setup VESA modes with banked memory
	;
@@banked_Setup:
	and	edi,NOT 4000h
	mov	eax,edi
	call	set_vesa_mode
	jc	@@err
	call	get_vesa_pm_interface
	;
	call	set_vesa_mapping_func
	mov	ecx,dword ptr ds:[VESA_Info+12]	; get the Bank-switching routine
	mov	dword ptr ds:[vesa_bankswitch], ecx
	mov	ecx,dword ptr ds:[VESA_Info+4] 	; get the granularity
	cmp	cl,1			; ensure the divide won't blow out
	jb	nogoodvesamode		;  granularity == 0???
	mov	eax,64			;  ...
	div	cl			; divide 64K by granularity
	mov  	ds:[vesa_granularity],al	; multiply the bank number by this
nogoodvesamode:
	jmp	@@alloc_buffers
	;
	;   Setup VESA modes with linear addressable memory
	;
@@Linear_Setup:
	mov	eax,ds:[vesa_apperture]
	mov	ecx,ds:[vesa_memory]
	shr	ecx,12
	call	Map_Memory		;Map in memory
	jc	@@banked_setup
	mov	ds:[vesa_apperture],eax
	;
	or	edi,4000h		;Select linear frame memory
	mov	eax,edi
	call	set_vesa_mode
	jc	@@err
	call	get_vesa_pm_interface
	;
	or	ds:[SVGA_Flags],SVGA_Linear_Buffer
       ifdef 	SVGA_NoPages
	jmp	@@alloc_buffers
       else
	cmp	ds:[vesa_pages],3
	jb	@@alloc_buffers
	test	ds:[SVGA_Flags],SVGA_VESA_PM_Interface
	jz	@@alloc_buffers
	mov	eax,OFFSET opt_NoPages
	call	Scan_Argument
	jnc	@@alloc_buffers
	;
	;   Setup VESA modes with three video pages
	;
	mov	eax,ds:[vesa_apperture]
	mov	edx,ds:[vesa_pages]		;EDX = number of pages
	sub	eax,ds:[DATA32_Address]		;EAX = DATA32 address of frame
	cmp	edx,16				;More than 16 pages ???
	jbe	short @@16
	mov	edx,16				;Limit to 16 pages !
	mov	ds:[vesa_pages],edx
@@16:   mov	edi,OFFSET fbuffers		;EDI = ptr to buffers
	mov	ecx,ds:[SVGA_Bytes_per_Line]
	imul	ecx,ds:[SVGA_Display_Height]	;ECX = Size of one page
@@L17:	mov	ds:[edi],eax
	add	edi,4
	add	eax,ecx
	dec	edx
	jnz	short @@L17
	;
	mov	eax,ds:[fbuffers]		;EAX = First page
	mov	ebx,ds:[fbuffers+4]		;EBX = 2nd page
	mov	ds:[SVGA_Old_Frame_Buffer],eax
	mov	ds:[SVGA_Frame_Buffer],ebx
	or	ds:[SVGA_Flags],SVGA_Multi_Pages
	mov	ds:[current_draw_page],1
	mov	ds:[current_display_page],0
	;
	cli
	mov	eax,8
	mov	ebx,OFFSET Timer_IRQ
	call	Set_Flat_IRQ
	mov	ds:[Old_FLat_Timer],ebx	;Save old pm IRQ handler
	mov	eax,8
	call	Link_Real_IRQ
	mov	ds:[Old_Real_Timer],ebx	;Save old realmode IRQ handler
	mov	eax,8
	call	Enable_IRQ

	mov	al,0Ah
	out	70h,al			;Select Status A register of RTC
	cwait
	mov	al,01011001b		;Standard frequency (1024Hz)
	mov	al,26h
	out	71h,al
	cwait

	mov	al,0Bh
	out	70h,al
	cwait
	in	al,71h
	or	al,40h			;Enbale IRQ generation
	push	eax
	cwait

	mov	al,0Bh
	out	70h,al
	cwait
	pop	eax
	out	71h,al
	sti
	;
	mov	esi,40			;Do 40 retraces
	mov	ebp,10000h		;EBP = Min. number of ticks between retraces
@@Sync: VESA_Retrace
	mov	ds:[Sync_Counter],1000000h
	VESA_Retrace
	mov	eax,1000000h
	sub	eax,ds:[Sync_Counter]	;EAX = Number of ticks between retrace
	cmp	ebp,eax                 ;New tick-counter less than min. ???
	jbe	short @@15
	mov	ebp,eax			;set new min. tick-counter
@@15:	dec	esi			;Loop !
	jnz	short @@Sync

	mov	ds:[Video_Ticks],ebp
	VESA_Retrace
	mov	ds:[Sync_Counter],ebp
	jmp	@@Pal
       endif

	;
	;   Setup Standard VGA modes
	;
@@VGA:  cmp	di,13h
	jne	@@Err
	or	ds:[SVGA_Flags],SVGA_VGA_Mode or SVGA_Palette_Mode
	mov	ds:[SVGA_Bytes_per_Line],320
	mov	ds:[SVGA_Display_Width],320
	mov	ds:[SVGA_Display_Height],200
	mov	ds:[SVGA_Display_Depth],8
	mov	ds:[v86_eax],edi
	mov	eax,10h
	call	Invoke_Real_Int			;Set video-mode !
	jmp	@@alloc_buffers

	;
	;   Setup Tweak VGA modes
	;
@@Twk:	cmp	di,7
	ja	@@Err
	test	edi,80000h			;Orange 18bpp mode ???
	jz	short @@2
	or	ds:[SVGA_Flags],SVGA_Fake18_Mode or SVGA_Ramp_Mode
@@2:	test	edi,100000h			;Fake 14bpp mode ???
	jz	short @@3
	or	ds:[SVGA_Flags],SVGA_Fake14_Mode or SVGA_Ramp_Mode
@@3:	and	edi,0ffh
	shl	edi,4
	add	edi,OFFSET tweak_table
	or	ds:[SVGA_Flags],SVGA_Tweak_Mode or SVGA_Palette_Mode
	;
	mov	eax,ds:[edi]
	mov	ds:[SVGA_Display_Width],eax
	mov	ds:[SVGA_Bytes_per_Line],eax
	mov	eax,ds:[edi+4]
	mov	ds:[SVGA_Display_Height],eax
	mov	ds:[SVGA_Display_Depth],8
	;
	mov 	ds:[v86_eax],13h          	;start with mode 13h
	mov 	eax,10h                        	;bios int 10h
	call	Invoke_Real_Int

	turn_screen_off          	    	; prevent flicker

	mov	dx,sc_index
	mov	ax,chain4_off                   ; disable chain 4 mode
	out	dx,ax
	mov	ax,async_reset			; (a)synchronous reset
	out	dx,ax
	mov	dx,misc_output
	mov	al,ds:[edi+12]			; set new timing/size
	out	dx,al
	mov	dx,sc_index
	mov	ax,sequ_restart     	 	; restart sequencer ...
	out	dx,ax

	mov	dx,crtc_index
	mov	al,11h
	out	dx,al              		; select vert retrace end register
	inc 	dx                             	; point to data
	in 	al, dx                          ; get value, bit 7 = protect
	and 	al, 7fh                        	; mask out write protect
	out 	dx, al                         	; and send it back
	;
	mov 	dx, crtc_index                 	; vga crtc registers
	mov	esi,ds:[edi+8]
@@L5:	mov 	ax, ds:[esi]                    ; get crtc data from table
	add 	esi, 2                         	; advance pointer
	test	ax, ax                          ; at end of data table?
	jz 	@@twk_rdy                	; if so, exit & get next table
	out 	dx, ax                         	; reprogram vga crtc reg
	jmp 	short @@L5	              	; process next table entry
@@twk_rdy:
	mov	eax,ds:[SVGA_Bytes_per_Line]
	shr 	eax, 3                          ; offset value = bytes / 2
	mov 	ah, 13h                         ; crtc offset register index
	xchg 	al, ah                          ; switch format for out
	out 	dx, ax                          ; set vga crtc offset reg
	turn_screen_on
	;
	test	ds:[SVGA_Flags],SVGA_Fake14_Mode+SVGA_Fake18_Mode
	jz	@@alloc_buffers

	;
	;   Setup Palettes for Fake/Orange Modes
	;
	and	ds:[SVGA_Flags],NOT SVGA_Palette_Mode
	test	ds:[SVGA_Flags],SVGA_Fake18_Mode
	jz	@@P14
	shl	ds:[SVGA_Bytes_per_Line],1	;Adjust line-size
	mov	eax,ds:[SVGA_Display_Height]
	mov	ebx,3
	xor	edx,edx
	idiv	ebx
	mov	ds:[SVGA_Display_Height],eax
	mov	ds:[SVGA_Display_Depth],16
		xor	al,al			;Set 18bit pal
		mov 	dx,03c8h
		out 	dx,al
		inc 	dx
		xor	cl,cl
	@@P181:	mov	al,cl                   ;Set 64 shades of red
		out	dx,al
		xor	al,al
		out	dx,al
		out	dx,al
		inc	cl
		cmp	cl,64
		jb	short @@P181
		xor	cl,cl			;Set 64 shades of green
	@@P182: xor	al,al
		out	dx,al
		mov	al,cl
		out	dx,al
		xor	al,al
		out	dx,al
		inc	cl
		cmp	cl,64
		jb	short @@P182
		xor	cl,cl			;Set 64 shades of blue
	@@P183: xor	al,al
		out	dx,al
		out	dx,al
		mov	al,cl
		out	dx,al
		inc	cl
		cmp	cl,64
		jb	short @@P183

	mov	ecx,10000h*4
	call	Malloc
	jc	@@err
	mov	ds:[fake_table],eax		;EAX = Fake-LUT
	mov	edi,eax
	xor	ecx,ecx				;ECX = Counter
	@@P184:	mov	eax,ecx
		shr	eax,11
		shl	eax,1			;EAX = Red component
		mov	ds:[edi+4*ecx],al
		mov	eax,ecx
		shr	eax,5
		and	eax,111111b             ;EAX = Green
		add	eax,64
		mov	ds:[edi+4*ecx+1],al
		mov	eax,ecx
		and	eax,11111b
		shl	eax,1                   ;EAX = Blue
		add	eax,128
		mov	ds:[edi+4*ecx+2],al
		inc	ecx
		cmp	ecx,10000h
		jb	short @@P184


	jmp	@@alloc_buffers
	;
	@@P14:
	shr	ds:[SVGA_Display_Width],1	;Adjust line-size
	mov	ds:[SVGA_Display_Depth],15
		xor	al,al			;Set 14bit pal
		mov 	dx,03c8h
		out 	dx,al
		inc 	dx
		xor	ecx,ecx			;Set 1st 128 colours (RRRRRGG)
	@@141:	mov	eax,ecx
		shr	eax,2
		shl	eax,1
		out	dx,al			;Set Red
		mov	eax,ecx
		and	eax,11b
		shl	eax,4
		out	dx,al			;Set Green
		xor	eax,eax
		out	dx,al			;Set Blue
		inc	ecx
		cmp	ecx,128
		jb	short @@141

		xor	ecx,ecx			;Set 2nd 128 colours (GGGBBBB)
	@@142:	xor	eax,eax
		out	dx,al			;Set Red
		mov	eax,ecx
		shr	eax,4
		shl	eax,1
		out	dx,al			;Get Green
		mov	eax,ecx
		and	eax,1111b
		shl	eax,2
		out	dx,al			;Set Blue
		inc	ecx
		cmp	ecx,128
		jb	short @@142

	mov	ecx,8000h*2
	call	Malloc
	jc	@@err
	mov	ds:[fake_table],eax		;EAX = Fake-LUT
	mov	edi,eax
	xor	ecx,ecx				;ECX = Counter
	@@P144:	mov	eax,ecx
		shr	al,1
		or	al,80h
		mov	ds:[edi+2*ecx],ax
		inc	ecx
		cmp	ecx,8000h
		jb	short @@P144

	jmp     @@alloc_buffers


	;
	;   Buffer allocation for virtual screen in main memory
	;
@@alloc_buffers:
	or	ds:[SVGA_Flags],SVGA_Virtual_Buffers
	mov	ecx,ds:[SVGA_Bytes_per_Line]
	imul	ecx,ds:[SVGA_Display_Height]
	call	Malloc
	jc	@@Err
	mov	ds:[fbuffer2],eax
	mov	ds:[SVGA_Old_Frame_Buffer],eax
	mov	edi,eax
	xor	eax,eax
	mov	ecx,ds:[SVGA_Bytes_per_Line]
	imul	ecx,ds:[SVGA_Display_Height]
	shr	ecx,2
	rep	stosd
	mov	ecx,ds:[SVGA_Bytes_per_Line]
	imul	ecx,ds:[SVGA_Display_Height]
	call	Malloc
	jc	@@Err
	mov	ds:[fbuffer1],eax
	mov	ds:[SVGA_Frame_Buffer],eax
	mov	edi,eax
	xor	eax,eax
	mov	ecx,ds:[SVGA_Bytes_per_Line]
	imul	ecx,ds:[SVGA_Display_Height]
	shr	ecx,2
	rep	stosd

@@Pal:	;
	;   Palette routine setup
	;
	mov	ds:[vesa_palette],OFFSET $nopalette
	mov	ds:[vesa_ramp],OFFSET $noramp
	test	ds:[SVGA_Flags],SVGA_Palette_Mode
	jz	@@Rmp
	test	ds:[SVGA_Flags],SVGA_VESA_Mode
	jnz	short @@PVSA
	test	ds:[SVGA_FLags],SVGA_VGA_Mode or SVGA_Tweak_Mode
	jnz	short @@PVGA
	jmp	@@End
	;
@@PVGA:	mov	ds:[vesa_palette],OFFSET $palette1
	jmp	@@End
	;
@@PVSA:	test	ds:[SVGA_Flags],SVGA_24bit_Palette
	jnz	short @@PV24
	test	ds:[SVGA_Flags],SVGA_BIOS_Palette
	jz	short @@PVGA
	test	ds:[SVGA_Flags],SVGA_VESA_PM_Interface
	jz	short @@PV18PM
	mov	ds:[vesa_palette],OFFSET $palette2
	jmp	@@End
@@PV18PM:mov	ds:[vesa_palette],OFFSET $palette3
	jmp	@@End
@@PV24:	test	ds:[SVGA_Flags],SVGA_VESA_PM_Interface
	jz	short @@PV24PM
	mov	ds:[vesa_palette],OFFSET $palette4
	jmp	@@End
@@PV24PM:mov	ds:[vesa_palette],OFFSET $palette5
	jmp	@@End

@@Rmp:	;
	;   Colour Ramp setup
	;
	test	ds:[SVGA_Flags],SVGA_Ramp_Mode
	jz	@@End
	test	ds:[SVGA_Flags],SVGA_Fake18_Mode
	jnz	short @@RF18
	test	ds:[SVGA_Flags],SVGA_Fake14_Mode
	jnz	@@RF14
	test	ds:[SVGA_Flags],SVGA_VESA_Mode
	jnz	short @@RVSA
	jmp	@@End
	;
@@RVSA:	test	ds:[SVGA_Flags],SVGA_24bit_Palette
	jnz	short @@RV24
	test	ds:[SVGA_Flags],SVGA_VESA_PM_Interface
	jz	short @@RV18PM
	mov	ds:[vesa_ramp],OFFSET $ramp1
	jmp	@@End
@@RV18PM:mov	ds:[vesa_ramp],OFFSET $ramp2
	jmp	@@End
@@RV24:	test	ds:[SVGA_Flags],SVGA_VESA_PM_Interface
	jz	short @@RV24PM
	mov	ds:[vesa_ramp],OFFSET $ramp3
	jmp	@@End
@@RV24PM:mov	ds:[vesa_ramp],OFFSET $ramp4
	jmp	@@End
	;
@@RF18:	mov	ds:[vesa_ramp],OFFSET $ramp5
	jmp	@@End
	;
@@RF14:	mov	ds:[vesa_ramp],OFFSET $ramp6
	jmp	@@End

	;
	;   SVGA Init end
	;
@@End:	clc
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
	;
@@err:	stc
	pop	edi
	pop     esi
	pop	es
	pop	ds
	retn
Init_SVGA ENDP
;
;
; Exit_SVGA:
;   Input:
;	Nothing
;   Output:
;	[CF]	- error flag
;
PUBLIC C Exit_SVGA
Exit_SVGA PROC NEAR
	push	ds
	mov	ds,cs:[DATA32_Selector]

	test	ds:[SVGA_Flags],SVGA_Multi_Pages
	jz	short @@1

	;
	cli
	mov	al,0Ah
	out	70h,al			;Select Status A register of RTC
	cwait
	mov	al,01011001b		;Standard frequency
	out	71h,al

	mov	al,0Bh
	out	70h,al
	cwait
	in	al,71h
	and	al,NOT 01001000b		;Disbale IRQ generation
	push	eax

	mov	al,0Bh
	out	70h,al
	cwait
	pop	eax
	out	71h,al

	mov	eax,8
	mov	ebx,ds:[Old_Real_Timer]
	call	Unlink_Real_IRQ
	mov	eax,8
	mov	ebx,ds:[Old_FLat_Timer]
	call	Set_Flat_IRQ
	sti
@@1:	;
	test	ds:[SVGA_Flags],SVGA_VESA_PM_Interface
	jz	short @@2
	mov	eax,ds:[vesa_pm_selector]
	call	Free_Selector
@@2:	;
	mov 	ds:[v86_ax],Text_Mode
	mov	eax,10h
	call	Invoke_Real_Int
	Free_and_Zero	ds:[fbuffer1]
	Free_and_Zero	ds:[fbuffer2]
	Free_and_Zero	ds:[Fake_Table]

	mov	ds:[SVGA_Flags],0

	clc
	pop	ds
	retn
Exit_SVGA ENDP
;
;
; SVGA_Switch_Frame:
;   Displays the current frame buffer and performs a buffer switch.
;   Input:
;	Nothing
;   Output:
;	[CF]	- error flag
;      EAX	- new frame-buffer
;	EBX	- old frame-buffer
;
PUBLIC C SVGA_Switch_Frame
SVGA_Switch_Frame PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	test	ds:[SVGA_Flags],SVGA_Multi_Pages
	jnz	short @@mp
	mov	esi,ds:[SVGA_Frame_Buffer]	;ESI = ptr to source
	;
	mov	eax,ds:[fbuffer1]		;EAX = New buffer
	mov	ebx,ds:[fbuffer2]		;EBX = old buffer
	test	ds:[SVGA_Flags],SVGA_Buffer_Flag
	jnz	short @@J2
	xchg	eax,ebx
@@J2:	mov	ds:[SVGA_Frame_Buffer],eax
	mov	ds:[SVGA_Old_Frame_Buffer],ebx
	xor	ds:[SVGA_Flags],SVGA_Buffer_Flag
	jmp 	fput
	;
@@mp:   mov	eax,ds:[current_draw_page]
	mov	ebx,ds:[fbuffers+4*eax]		;EBX = old frame buffer
	inc	eax				;Increment draw page
	cmp	eax,ds:[vesa_pages]             ;Check for max.
	jb	short @@1
	xor	eax,eax
@@1:	cmp	eax,ds:[current_display_page]	;Avoid switching to displayed
	je	short @@1			;    page
	mov	ds:[current_draw_page],eax
	mov	eax,ds:[fbuffers+4*eax]		;EAX = new frame buffer
	mov	ds:[SVGA_Old_Frame_Buffer],ebx
	mov	ds:[SVGA_Frame_Buffer],eax	;Save both buffers

	clc
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
SVGA_Switch_Frame ENDP
;
;
; SVGA_Put_Frame:
;   Displays the current frame buffer without a buffer switch.
;   Input:
;	Nothing
;   Output:
;	[CF]	- error flag
;      EAX	- new frame-buffer
;	EBX	- old frame-buffer
;
PUBLIC C SVGA_Put_Frame
SVGA_Put_Frame PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	esi,ds:[SVGA_Frame_Buffer]	;ESI = ptr to source
	;
fput:	test	ds:[SVGA_Flags],SVGA_Linear_Buffer
	jnz	short @@LinBuff
	test	ds:[SVGA_Flags],SVGA_VGA_Mode
	jnz	@@VGA
	test	ds:[SVGA_Flags],SVGA_Tweak_Mode
	jnz	@@TWK
	test	ds:[SVGA_Flags],SVGA_Multi_Pages
	jnz	@@MPages

	;
	;   Copy virtual buffer into banked memory of VESA card
	;
	mov	eax,ds:[SVGA_Bytes_per_Line]
	imul	ds:[SVGA_Display_Height]
	shr	eax,2				;
	mov	ebp,eax				;EBP = dwords to copy
	xor	edi,edi				;EDI = current bank
@@L1:  	mov	eax,edi				;EAX = bank number
	call 	dword ptr ds:[vesa_mapper]
	mov	es,ds:[LIN_Selector]
	mov	ecx,ebp
	cmp	ecx,4000h
	jb	short @@J1
	mov	ecx,4000h
@@J1:   inc	edi				;EDI = Next bank
	push	edi
	mov	edi,0a0000h                     ;EDI = frame-address
	sub	ebp,ecx				;EBP -= this number of dwords
	rep	movsd				;Copy bank
	pop	edi
	jnz	short @@L1
	jmp	@@End

	;
	;   Copy virtual buffer into linear memory of VESA card
	;
@@LinBuff:
	test	ds:[SVGA_Flags],SVGA_Multi_Pages
	jnz	short @@MPages
	mov	es,ds:[LIN_Selector]
	mov	ecx,ds:[SVGA_Bytes_per_Line]
	imul	ecx,ds:[SVGA_Display_Height]
	shr	ecx,2				;
	mov	esi,ds:[SVGA_Frame_Buffer]	;ESI = ptr to source
	mov	edi,ds:[vesa_apperture]
	rep	movsd				;Copy bank
	jmp	@@End

	;
	;   Switch pages of  VESA card
	;
@@MPages:
	jmp	@@End

	mov	ds:[v86_eax],4f07h
	mov	ds:[v86_ebx],80h
	mov	ds:[v86_ecx],0
	xor	edx,edx
	test	ds:[SVGA_Flags],SVGA_Buffer_Flag
	jnz	short @@J2
	mov	edx,ds:[SVGA_Display_Height]
@@J2:	mov	ds:[v86_edx],edx
	mov	eax,10h
	call	Invoke_Real_Int
	jmp	@@End

	;
	;   Copy virtual buffer into standard VGA memory
	;
@@VGA:	mov	es,ds:[LIN_Selector]
	mov	ecx,ds:[SVGA_Bytes_per_Line]
	imul	ecx,ds:[SVGA_Display_Height]
	shr	ecx,2				;
	mov	esi,ds:[SVGA_Frame_Buffer]	;ESI = ptr to source
	mov	edi,0a0000h
	rep	movsd				;Copy bank
	jmp	@@End

	;
	;   Copy virtual buffer into tweaked VGA memory
	;
@@TWK:  test	ds:[SVGA_Flags],SVGA_Fake18_Mode
	jnz	@@F18
	test	ds:[SVGA_Flags],SVGA_Fake14_Mode
	jnz	@@F14
	mov	es,ds:[LIN_Selector]
	mov	ebp,ds:[SVGA_Display_Height]	;EBP = Line counter
	shr	ebp,2
	mov	esi,ds:[SVGA_Frame_Buffer]
	mov	edi,0a0000h
@@TL1:	mov	ebx,3				;EBX = Active bank number
	;
@@TL2:	push	esi
	push	edi
	add	esi,ebx
	mov	dx,sc_index
	mov	cl,bl				; CL = active plane
	mov 	ax, map_mask_plane1             ; map mask & plane select register
	and 	cl, 3	                  	; get plane bits
	shl 	ah, cl                          ; get plane select value
	out	dx, ax                		; select plane

	mov	ecx,ds:[SVGA_Bytes_per_Line]
	shr	ecx,3
	@@TL3:	mov	al,ds:[esi]
		mov	dl,ds:[esi+16]
		mov	ah,ds:[esi+4]
		mov	dh,ds:[esi+20]
		shl	eax,16
		shl	edx,16
		mov	al,ds:[esi+8]
		mov	dl,ds:[esi+24]
		mov	ah,ds:[esi+12]
		mov	dh,ds:[esi+28]
		rol	eax,16
		rol	edx,16
		add	esi,32
		stosd
		mov	eax,edx
		stosd
		dec	ecx
		jnz	short @@TL3

	pop	edi
	pop	esi
	dec	ebx
	jns	short @@TL2
	;
	mov	eax,ds:[SVGA_Bytes_per_Line]
	add	edi,ds:[SVGA_Bytes_per_Line]
	shl	eax,2
	add	esi,eax
	dec	ebp
	jnz	short @@TL1

	jmp	@@End

	;
	;   Copy virtual buffer into Orange-Modes (18 bpp)
	;
@@F18:	mov	es,ds:[LIN_Selector]
	mov	ebp,ds:[SVGA_Display_Height]	;EBP = Line counter
	mov	esi,ds:[SVGA_Frame_Buffer]
	mov	edi,0a0000h
	sub	edi,ds:[DATA32_Address]
@@FL1:  push	ebp
	mov	ebp,ds:[Fake_Table]
	mov	ebx,3				;EBX = Active bank number
	;
@@FL2:  push	esi
	push	edi
	push	ebx

	lea	esi,[esi+2*ebx]
	mov	dx,sc_index
	mov	cl,bl				; CL = active plane
	mov 	ax, map_mask_plane1             ; map mask & plane select register
	and 	cl, 3	                  	; get plane bits
	shl 	ah, cl                          ; get plane select value
	out	dx, ax                		; select plane

	mov	ecx,ds:[SVGA_Display_Width]
	xor	eax,eax
	xor	edx,edx
	mov	ebx,ecx
	shr	ecx,3
	shr	ebx,2
	@@FL3:	mov	ax,ds:[esi]		;AX = 16bit RGB value
		mov	dx,ds:[esi+8]
		mov	eax,ds:[ebp+4*eax]
		mov	edx,ds:[ebp+4*edx]
		mov	ds:[edi],al
		mov	ds:[edi+1],dl
		mov	ds:[edi+ebx],ah
		mov	ds:[edi+ebx+1],dh
		shr	eax,16
		shr	edx,16
		mov	ds:[edi+2*ebx],al
		mov	ds:[edi+2*ebx+1],dl
		add	edi,2
		add	esi,16
		dec	ecx
		jnz	short @@FL3

	pop	ebx
	pop	edi
	pop	esi
	dec	ebx
	jns	short @@FL2
	;
	mov	eax,ds:[SVGA_Display_Width]
	pop	ebp
	shr	eax,2
	add	esi,ds:[SVGA_Bytes_per_Line]
	lea	eax,[eax+2*eax]
	add	edi,eax				;EDI += 3*Width
	dec	ebp
	jnz	@@FL1

	jmp	@@End

	;
	;   Copy virtual buffer into Fake-Modes (14bpp)
	;
@@F14:	mov	es,ds:[LIN_Selector]
	mov	ebp,ds:[SVGA_Display_Height]	;EBP = Line counter
	shr	ebp,2
	mov	esi,ds:[SVGA_Frame_Buffer]
	mov	edi,0a0000h
@@FL6:  push	ebp
	mov	ebx,3				;EBX = Active bank number
	mov	ebp,ds:[Fake_Table]
	;
@@FL7:	push	edi
	push	esi
	lea	esi,[esi+ebx-1]
	mov	dx,sc_index
	mov	cl,bl				; CL = active plane
	mov 	ax, map_mask_plane1             ; map mask & plane select register
	and 	cl, 3	                  	; get plane bits
	shl 	ah, cl                          ; get plane select value
	out	dx, ax                		; select plane
	mov	ecx,ds:[SVGA_Display_Width]
	@@FL8:  xor	eax,eax
		xor	edx,edx
		mov	ax,ds:[esi]
		mov	dx,ds:[esi+4]
		mov	al,ds:[ebp+2*eax]	;AL = Low-byte to put out
		mov	ah,ds:[ebp+2*edx]	;AH = Low-byte to put out
		add	esi,8
		stosw
		dec	ecx
		jnz	short @@FL8

	mov	esi,ss:[esp]
	mov	edi,ss:[esp+4]
	mov	cl,bl				; CL = active plane
	lea	esi,[esi+ebx-1]
	mov	dx,sc_index
	dec	cl
	mov 	ax, map_mask_plane1             ; map mask & plane select register
	and 	cl, 3	                  	; get plane bits
	shl 	ah, cl                          ; get plane select value
	out	dx, ax                		; select plane
	mov	ecx,ds:[SVGA_Display_Width]
	@@FL9:  xor	eax,eax
		xor	edx,edx
		mov	ax,ds:[esi]
		mov	dx,ds:[esi+4]
		mov	al,ds:[ebp+2*eax+1]	;AL = Low-byte to put out
		mov	ah,ds:[ebp+2*edx+1]	;AH = Low-byte to put out
		add	esi,8
		stosw
		dec	ecx
		jnz	short @@FL9

	pop	esi
	pop	edi
	sub	ebx,2
	jns	@@FL7
	;
	pop	ebp
	mov	eax,ds:[SVGA_Bytes_per_Line]
	add	edi,ds:[SVGA_Bytes_per_Line]
	shl	eax,2
	add	esi,eax
	dec	ebp
	jnz	@@FL6

	jmp	@@End

	;
	;   The end
	;
@@End:	mov	eax,ds:[SVGA_Frame_Buffer]
	mov	ebx,ds:[SVGA_Old_Frame_Buffer]

	clc
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
SVGA_Put_Frame ENDP
;
;
; SVGA_Get_Video_Address
;  Input:
;	Nothing
;  Output:
;	EAX	- LINEAR ptr to active video-memory
;	[CF]	- Error flag
;
PUBLIC C SVGA_Get_Video_Address
SVGA_Get_Video_Address PROC NEAR
	push	ds

	mov	ds,cs:[DATA32_Selector]
	test	ds:[SVGA_Flags],SVGA_Multi_Pages
	jnz	@@MPag
	test	ds:[SVGA_Flags],SVGA_Linear_Buffer
	jnz	short @@Lin
	test	ds:[SVGA_Flags],SVGA_VGA_Mode
	jnz	@@VGA
	xor	eax,eax
	stc
	jmp	@@End
	;
@@Lin:	mov	eax,ds:[vesa_apperture]
	clc
	jmp	@@End
	;
@@MPag:	mov	eax,ds:[current_display_page]
	mov	eax,ds:[fbuffers+4*eax]		;EAX = frame buffer
	add	eax,ds:[DATA32_Address]
	clc
	jmp	@@End
	;
@@VGA:	mov	eax,0a0000h
	clc
	;
@@End:	pop	ds
	retn
SVGA_Get_Video_Address ENDP
;
;
; SVGA_Set_Palette
;  Input:
;	EAX	- DATA32 ptr to palette
;	EBX	- First entry to update
;	ECX	- Number of colours to update
;  Output:
;	[CF]	- Error flag
;
PUBLIC C SVGA_Set_Palette
SVGA_Set_Palette PROC NEAR
	push	ds

	mov	ds,cs:[DATA32_Selector]
	call	ds:[vesa_palette]

	pop	ds
	retn
SVGA_Set_Palette ENDP
;
;
; SVGA_Set_Ramp
;  Input:
;	EAX	- DATA32 ptr to palette
;  Output:
;	[CF]	- Error flag
;
PUBLIC C SVGA_Set_Ramp
SVGA_Set_Ramp PROC NEAR
	push	ds

	mov	ds,cs:[DATA32_Selector]
	xor	ebx,ebx
	mov	ecx,256
	call	ds:[vesa_ramp]

	pop	ds
	retn
SVGA_Set_Ramp ENDP
;
; SVGA-Unit                                                  Palette-code
;
;
$palette1:
	;Used for Std-VGA Modes with hardware
	push	esi
	mov	esi,eax
	test	ds:[SVGA_Flags],SVGA_Wait_Retrace
	jz	short $p2_1
	Wait_Retrace
$p2_1:	mov	al,bl
	mov 	dx,03c8h
	out 	dx,al
	inc 	dx
	mov	ebx,ecx
@@L1:	lodsd
	shr	eax,2
	and	eax,3f3f3fh
	out	dx,al
	shr	eax,8
	out	dx,al
	shr	eax,8
	out	dx,al
	dec	ebx
	jnz	short @@L1
	pop	esi
	retn
;
$ramp1:
$palette2:
	;Used for VESA 18bit Modes with PM interface
	jmp	$palette1
	push	es
	push	ds
	push	esi
	push	edi
	mov	es,ds:[DATA32_Selector]
	mov	esi,eax			;ESI = src-palette
	mov	edx,ecx			;EDX = number of entries
	mov	edi,o palette_buffer
@@L1:	mov	eax,ds:[esi+4*edx-4]
	bswap	eax
	shr	eax,10
	and	eax,3f3f3fh
	mov	ds:[edi+4*edx-4],eax
	dec	edx
	jnz	short @@L1
	;
	mov	edx,ebx			;EDX = First colour
	mov	edi,o palette_buffer	;EDI = palette
	xor	bl,bl			;BL  = function
	test	ds:[SVGA_Flags],SVGA_Wait_Retrace
	jz	short @@1
	or	bl,80h
@@1:    mov	eax,4f09h
	mov	ds,ds:[vesa_pm_selector]
	call	cs:[vesa_pm_set_palette]
	pop	edi
	pop	esi
	pop	ds
	pop	es
	retn
;
$ramp2:
$palette3:
	;Used for VESA 18bit Modes without PM interface
	push	esi
	push	edi
	mov	esi,eax			;ESI = src-palette
	mov	edx,ecx			;EDX = number of entries
	mov	edi,OFFSET palette_buffer
@@L1:	mov	eax,ds:[esi+4*edx-4]
	bswap	eax
	shr	eax,10
	and	eax,3f3f3f3fh
	mov	ds:[edi+4*edx-4],eax
	dec	edx
	jnz	short @@L1
	;
	mov	ds:[v86_edx],ebx	;EDX = First colour
	mov	ds:[v86_ecx],ecx
	mov	eax,ds:[DATA32_Address]
	add	eax,OFFSET palette_buffer
	mov	ebx,eax
	shr	eax,4
	and	ebx,0fh
	mov	ds:[v86_es],ax		;ES  = segment of palette
	mov	ds:[v86_edi],ebx	;EDI = palette
	xor	bl,bl			;BL  = function
	test	ds:[SVGA_Flags],SVGA_Wait_Retrace
	jz	short @@1
	or	bl,80h
@@1:    mov	ds:[v86_eax],4f09h
	mov	ds:[v86_ebx],ebx
	mov	eax,10h
	call	Invoke_Real_Int
	pop	edi
	pop	esi
	retn
;
$ramp3:
$palette4:
	;Used for VESA 24bit Modes with PM interface
	jmp	$palette1
	push	ds
	push	es
	push	edi
	mov	es,ds:[DATA32_Selector]
	mov	edx,ebx
	mov	edi,eax
	xor	bl,bl
	test	ds:[SVGA_Flags],SVGA_Wait_Retrace
	jz	short @@1
	or	bl,80h
@@1:    mov	ds,ds:[vesa_pm_selector]
	call	cs:[vesa_pm_set_palette]
	pop	edi
	pop	es
	pop	ds
	retn
;
$ramp4:
$palette5:
	;Used for VESA 24bit Modes without PM interface
	jmp	$palette1
	push	es
	push	esi
	push	edi
	mov	es,ds:[DATA32_selector]
	mov	esi,eax			;ESI = src-palette
	mov	edx,ecx			;EDX = number of entries
	mov	edi,OFFSET palette_buffer
	rep	movsd
	;
	mov	ds:[v86_ecx],edx
	mov	ds:[v86_edx],ebx	;EDX = First colour
	mov	eax,ds:[DATA32_Address]
	add	eax,OFFSET palette_buffer
	mov	ebx,eax
	shr	eax,4
	and	ebx,0fh
	mov	ds:[v86_es],ax		;ES  = segment of palette
	mov	ds:[v86_edi],ebx	;EDI = palette
	xor	bl,bl			;BL  = function
	test	ds:[SVGA_Flags],SVGA_Wait_Retrace
	jz	short @@1
	or	bl,80h
@@1:    mov	ds:[v86_eax],4f09h
	mov	ds:[v86_ebx],ebx
	mov	eax,10h
	call	Invoke_Real_Int
	pop	edi
	pop	esi
	pop	es
	retn
;
$ramp5:
	;Used for Orange 18bit fake modes with hardware
	retn
;
$ramp6:
	;Used for 14bit fake modes with hardware
	retn
;
$nopalette:
$noramp:
	retn

;
; SVGA-Unit                                            Bankswitching-code
;
;
$vesa1:	pushad

	mul	ds:[vesa_granularity]	; Adjust for the granularity factor
	mov	ds:[v86_edx],eax	; Select window position
	mov	ds:[v86_ebx],0		; select window (bank) sub-command
	mov	eax,ds:[vesa_bankswitch]
	call	Call_Real_Proc

	popad
	retn
;
$vesa2:	pushad				; VESA bank switching

	mul	ds:[vesa_granularity]	; Adjust for the granularity factor
	mov	ds:[v86_edx],eax	; Select window position
	push	eax
	mov	ds:[v86_ebx],0		; select window (bank) sub-command
	mov	eax,ds:[vesa_bankswitch]
	call	Call_Real_Proc

	pop	ds:[v86_edx]
	mov	ds:[v86_ebx],1		; select window (bank) sub-command
	mov	eax,ds:[vesa_bankswitch]
	call	Call_Real_Proc

	popad
	retn
;
$vesa3:	pushad				; VESA bank switching

	mul	ds:[vesa_granularity]	; Adjust for the granularity factor
	mov	ds:[v86_edx],eax	; Select window position
	push	eax
	mov	eax,ds:[vesa_low_window]	; select window (bank) sub-command
	mov	ds:[v86_ebx],eax
	mov	eax,ds:[vesa_bankswitch]
	call	Call_Real_Proc

	pop	edx
	add	edx,ds:[vesa_gran_offset]	; 2nd window is at 32K offset from 1st
	mov	ds:[v86_edx],edx	; Select window position
	mov	eax,ds:[vesa_high_window]	; select window (bank) sub-command
	mov	ds:[v86_ebx],eax
	mov	eax,ds:[vesa_bankswitch]
	call	Call_Real_Proc

	popad
	retn
;
$vesa_nullbank: 	; null routine for vesa_bankswitch when unknown
	retn
;
set_vesa_mapping_func proc near
	mov 	ds:[vesa_granularity],1	; say use 64K granules
	mov	ecx,dword ptr ds:[VESA_Info+2]
	and	ecx,0707h
	cmp	ecx,0305h
	je	use_vesa2
	cmp	ecx,0503h
	je	use_vesa2
	test	ch,01h
	jz	use_vesa1
	cmp	word ptr ds:[VESA_Info+6],32	 ; None of the above -- 2 32K R/W?
	jne	use_vesa1		 	;    if not, use original 1 64K R/W!
	mov	dword ptr ds:[vesa_mapper],offset $vesa3
	mov	eax,32
	div	byte ptr ds:[VESA_Info+4]	; Get number of pages in 32K
	mov	ds:[vesa_gran_offset],eax 	; Save it for mapping function
	xor	edx,edx
	mov	al,1
	test	word ptr ds:[VESA_Info+8], 00800h
	jz	low_high_seq
	xchg	eax,edx
low_high_seq:
	mov	ds:[vesa_low_window],edx  ; Window number at A000-A7FF
	mov	ds:[vesa_high_window],eax ; Window number at A800-AFFF
	jmp	short vesamapselected
use_vesa2:
	mov	dword ptr ds:[vesa_mapper],offset $vesa2
	jmp	short vesamapselected
use_vesa1:
	mov	dword ptr ds:[vesa_mapper],offset $vesa1
vesamapselected:
	retn
set_vesa_mapping_func endp
;
set_vesa_mode proc near
	mov 	ds:[v86_eax],4f02h
	mov 	ds:[v86_ebx],eax	;EAX = mode number
	mov	eax,10h
	call	Invoke_Real_Int
	cmp	ds:[v86_ax],4fh
	jne	short @@err

	test	ds:[SVGA_Flags],SVGA_Palette_Mode
	jz	short @@end
	mov	ds:[v86_eax],4f08h      ;Set palette format
	mov	ds:[v86_ebx],800h	;8bits per primary colour
	mov	eax,10h
	call	Invoke_Real_Int
	cmp	ds:[v86_ax],4fh
	jne	short @@end
	cmp	ds:[v86_bh],6
	je	short @@end
	or	ds:[SVGA_Flags],SVGA_24bit_Palette
@@end:  clc
	retn
@@err:	stc
	retn
set_vesa_mode endp
;
get_vesa_pm_interface PROC NEAR
	mov	eax,OFFSET opt_NoVESAPM
	call	Scan_Argument
	jnc	@@nopm
	mov	eax,OFFSET opt_NoVBE2
	call	Scan_Argument
	jnc	@@nopm
	;
	mov 	ds:[v86_eax],4f0ah	;Get protected mode interface
	mov 	ds:[v86_ebx],0
	mov	eax,10h
	call	Invoke_Real_Int		; do it
	cmp	ds:[v86_ax],4fh
	jne	@@nopm
	;
	movzx	eax,ds:[v86_es]
	shl	eax,4			;EAX = linear address of VESA-segment
	call	Alloc_Selector
	jc	@@nopm
	mov	ds:[vesa_pm_selector],eax
	mov	ebx,0ffffh
	call	Set_Selector_Limit
	jc	@@nopm
	mov	eax,ds:[vesa_pm_selector]
	mov	ebx,0100000010010010b
	call	Set_Selector_Rights	;EAX = data selector for VESA pm functions
	jc	@@nopm
	;
	movzx	edx,ds:[v86_es]
	shl	edx,4
	movzx	ebx,ds:[v86_di]		;EBX = offset of table
	add	edx,ebx
	sub	edx,ds:[DATA32_Address]	;DS:EDX = pointer to pm-table
	movzx	eax,word ptr ds:[edx]
	add	eax,edx			;EAX = ptr to Window-Call
	mov	ds:[vesa_pm_set_window],eax
	movzx	eax,word ptr ds:[edx+2]
	add	eax,edx			;EAX = ptr to Display-Call
	mov	ds:[vesa_pm_set_display],eax
	movzx	eax,word ptr ds:[edx+4]
	add	eax,edx			;EAX = ptr to Palette-Call
	mov	ds:[vesa_pm_set_palette],eax
	;
	or	ds:[SVGA_Flags],SVGA_VESA_PM_Interface
	clc
	retn

@@nopm:	stc
	retn
get_vesa_pm_interface ENDP

;
; SVGA-Unit                                              Timer interrupt
;
Timer_IRQ PROC NEAR
	push	ds
	push	eax
	mov	ds,cs:[DATA32_Selector]

	mov	al,20h
	out	0a0h,al
	out	020h,al				;Send EOIs to PICs

	mov	al,0Ch
	out	70h,al
	cwait
	in	al,71h
	test	al,80h				;Get IRQ source
	jz	short @@EOI
	;
	test	ds:[SVGA_Flags],SVGA_IRQ_Busy
	jnz	short @@EOI
	or	ds:[SVGA_Flags],SVGA_IRQ_Busy	;Avoid reentrance
	;
	dec	ds:[Sync_Counter]
	jns	short @@1

	mov	eax,ds:[current_display_page]
	inc	eax				;EAX = Next display page
	cmp	eax,ds:[vesa_pages]		;Is EAX in range ???
	jb	short @@3
	xor	eax,eax				;Adjust page if overflow occured
@@3:	cmp	eax,ds:[current_draw_page]	;Is next page being drawn to ?
	je	short @@2			;Yes ==> No frame switch
	;
	sti					;Enable interrupts again
	push	ds
	push	es
	push	fs
	push	gs
	pushad					;Save all registers
	mov	ds:[current_display_page],eax	;Set new display page
	mov	ebx,80h				;EBX = subcommand
	xor	ecx,ecx				;ECX = first pixel in a row
	mov	edx,ds:[SVGA_Display_Height]
	imul	edx,eax				;EDX = first row to display
	mov	ds,ds:[vesa_pm_selector]
	call	cs:[vesa_pm_set_display]
	popad
	pop	gs
	pop	fs
	pop	es
	pop	ds
	;
@@2:	mov	eax,ds:[Video_Ticks]
	mov	ds:[Sync_Counter],eax
@@1:	;
	and	ds:[SVGA_Flags],NOT SVGA_IRQ_Busy
@@EOI:	pop	eax
	pop	ds
	iretd
Timer_IRQ ENDP



Old_Real_Timer	dd	?
Old_FLat_Timer	dd	?
Sync_Counter	dd	?
Video_Ticks	dd	?

;
; SVGA-Unit                                                  Misc. code
;
;
;Long2Text:
;  Input:
;	EDX	- Number to convert
;	EDI	- ptr to string
;  Output:
;	EDI	- ptr to terminating 0
;  Destroys:
;	EAX,EBBX,ECX,EDX
;
Long2Text PROC NEAR
	test 	edx,edx
	jnz 	@@NotZ
	mov	ax,'0'
	stosw
	retn

@@NotZ:	test 	edx,edx
	jns 	short @@NoS
	mov 	byte ptr ds:[edi],'-'
	inc 	edi
	neg 	edx

@@NoS:  push	ebp
	mov	ebp,edi
	mov 	ebx,edx
	mov 	ecx,10000000
@@1:    xor 	edx,edx
	mov 	eax,ebx
	div 	ecx
	test 	al,al
	jnz 	short @@4
	cmp 	edi,ebp
	je 	short @@2
@@4:	add 	al,'0'
	stosb
@@2:	mov 	ebx,edx
	xor 	edx,edx
	mov 	eax,ecx
	mov 	ecx,10
	div 	ecx
	test 	eax,eax
	jz 	short @@3
	mov 	ecx,eax
	jmp 	short @@1

@@3:	mov 	byte ptr ds:[edi],0
	pop	ebp
	retn
Long2Text ENDP

;
;Text2Long:
;  Input:
;	ESI	- ptr to string
;  Output:
;	EAX	- number
;  Destroys:
;	EBX,ECX,EDX
;
Text2Long PROC NEAR
	xor	ecx,ecx
	xor	eax,eax
@@L1:	movzx	ebx,byte ptr ds:[esi+ecx]
	test	ebx,ebx
	jz	short @@End
	cmp	bl,'9'
	ja	short @@1
	cmp	bl,'0'
	jb	short @@Err
	sub	bl,'0'
	shl	eax,4
	or	eax,ebx
	inc	ecx
	jmp	short @@L1

@@1:    and	bl,NOT 20h		;BL = letter (Uppercase)
	cmp	bl,'F'
	ja	short @@Err
	cmp	bl,'A'
	jb	short @@Err
	sub	bl,'A'-10
	shl	eax,4
	or	eax,ebx
	inc	ecx
	jmp	short @@L1

@@End:	clc
	retn

@@Err:  xor	eax,eax
	stc
	retn
Text2Long ENDP

CODE32 ENDS
END