;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
P486
LOCALS
JUMPS

;
;
;
;   GOMEZ VECTOR ENGINE                                        3D-EDITOR
;
;
;
code32  segment para public use32
	assume cs:code32, ds:code32
	largestack

include gve32.inc
include gomez.inc
include gwm32.inc
include svga.inc
include gmi32.inc
include devices.inc


;
;   GOMEZ VECTOR ENGINE   3D-EDITOR         DATA AREA
;
WorldName	db 	16 dup (0)
PalName		db 	16 dup (0)
TexName		db 	16 dup (0)
LigName		db	16 dup (0)
BumpName	db	16 dup (0)
ObjName		db	16 dup (0)
VidName		db	16 dup (0)
SongName	db	16 dup (0)
Dir_Mask	db	"*.GVE",0,0,0
		db	"*.PAL",0,0,0
		db	"*.PCX",0,0,0
		db	"*.PCX",0,0,0
		db	"*.PCX",0,0,0
		db	"*.3DS",0,0,0
		db	"*.VID",0,0,0
		db	"*.XM",0,0,0,0


ALIGN 4
World_Ptr	dd	?
Song_Ptr	dd	?
Object_Ptr	dd	?
Light_Ptr	dd	?
Camera_Ptr	dd	?
Record_Flags	dd	0



;
;   GOMEZ VECTOR ENGINE                                   WINDOW-DEFINITIONS
;
WinS	LABEL BYTE
	CREATE_WINDOW 		220,220,220,90,"GOMEZ VECTOR ENGINE"
	ADD_WINDOW_TEXT		4,4,"(C)opyright 1996 by"
	ADD_WINDOW_TEXT		32,18,"Marc van Shaney"
	ADD_WINDOW_TEXT		32,32,"aka Kaya Memisoglu"
	ADD_WINDOW_BUTTON	90,52,"Ok",WS_Start,Return
	TERMINATE_WINDOW

Win0	LABEL BYTE		;Main window
	CREATE_WINDOW		0,452,640,26,""
	ADD_WINDOW_BUTTON	4,4,"File",WS_Open_Files
	ADD_WINDOW_BUTTON	54,4,"Camera",WS_Open_Camera
	ADD_WINDOW_BUTTON	120,4,"Object",WS_Open_Object
	ADD_WINDOW_BUTTON	186,4,"Light",WS_Open_Light
	ADD_WINDOW_BUTTON	244,4,"Surface",WS_Open_Surface
	ADD_WINDOW_BUTTON	318,4,"Flags",WS_Open_Options
	ADD_WINDOW_TEXT		444,7,"Mem:     kB"
FMEM:	ADD_WINDOW_INTEGER	476,7
	ADD_WINDOW_BUTTON	548,4,"Rec",WS_Open_Recorder
	ADD_WINDOW_BUTTON	590,4,"Exit",WS_Exit
	TERMINATE_WINDOW

Win2	LABEL BYTE
	CREATE_WINDOW		148,240,276,200,"Files"
	ADD_WINDOW_BUTTON       8,4 ," Load ",FILE_Load
	ADD_WINDOW_BUTTON	8,24," Save ",FILE_Save
	ADD_WINDOW_BUTTON	80,4," New ",FILE_New
	ADD_WINDOW_BUTTON	80,24," Del ",FILE_Delete
FNAM:	ADD_WINDOW_STRINPUT	8,160,FILE_Name
FTYP:	ADD_WINDOW_SELECT_BOX	8,48,FILE_Type
FADR:   ADD_WINDOW_LIST_BOX	140,4,FILE_Select
	TERMINATE_WINDOW

Win3	LABEL BYTE
	CREATE_WINDOW           148,0,344,80,"Flags"
WFL1:	ADD_WINDOW_SWITCH	4  ,4 ,"Soften vertical",?,3
WFL2:	ADD_WINDOW_SWITCH	4  ,20,"Soften horizontal",?,2
WFL3:	ADD_WINDOW_SWITCH	4  ,36,"No sorting",?,1
WFL4:	ADD_WINDOW_SWITCH	4  ,52,"Clear frame",?,5
WFL5:	ADD_WINDOW_SWITCH	160,4 ,"Motion trace",?,4
WFL6:	ADD_WINDOW_SWITCH	160,20,"Motion blurr",?,0
WFL7:	ADD_WINDOW_SWITCH	160,36,"Feed back",?,6
	TERMINATE_WINDOW

Win4	LABEL BYTE
	CREATE_WINDOW		496,0,144,428,"Light"
LADR:	ADD_WINDOW_LIST_BOX	6,4,LIGHT_Select
LTXT:	ADD_WINDOW_STRINPUT	8,181,LIGHT_Edit_Name
	ADD_WINDOW_BUTTON	12,202,"Delete",LIGHT_Delete
	ADD_WINDOW_BUTTON	92,202,"New",LIGHT_New
	ADD_WINDOW_TEXT		4,228,"Colour:"
	ADD_WINDOW_TEXT		12,242,"Red   :"
	ADD_WINDOW_TEXT		12,260,"Green :"
	ADD_WINDOW_TEXT		12,278,"Blue  :"
LRED:	ADD_WINDOW_INTINPUT	78,240,0,255,PAL_Red
LGRN:	ADD_WINDOW_INTINPUT	78,258,0,255,PAL_Green
LBLU:	ADD_WINDOW_INTINPUT	78,276,0,255,PAL_Blue

	ADD_WINDOW_TEXT		4,298,"Rotation:"
	ADD_WINDOW_BUTTON	12,312,"X +",LIGHT_Inc_RotX
	ADD_WINDOW_BUTTON	12,331,"X -",LIGHT_Dec_RotX
	ADD_WINDOW_BUTTON	52,312,"Y +",LIGHT_Inc_RotY
	ADD_WINDOW_BUTTON	52,331,"Y -",LIGHT_Dec_RotY
	ADD_WINDOW_BUTTON	92,312,"Z +",LIGHT_Inc_RotZ
	ADD_WINDOW_BUTTON	92,331,"Z -",LIGHT_Dec_RotZ
	ADD_WINDOW_TEXT		4,355,"Translation:"
	ADD_WINDOW_BUTTON	12,369,"X +",LIGHT_Inc_TransX
	ADD_WINDOW_BUTTON	12,388,"X -",LIGHT_Dec_TransX
	ADD_WINDOW_BUTTON	52,369,"Y +",LIGHT_Inc_TransY
	ADD_WINDOW_BUTTON	52,388,"Y -",LIGHT_Dec_TransY
	ADD_WINDOW_BUTTON	92,369,"Z +",LIGHT_Inc_TransZ
	ADD_WINDOW_BUTTON	92,388,"Z -",LIGHT_Dec_TransZ
	TERMINATE_WINDOW

Win5	LABEL BYTE
	CREATE_WINDOW		496,0,144,440,"Objects"
OADR:	ADD_WINDOW_LIST_BOX	6,4,OBJECT_Select
OTXT:	ADD_WINDOW_STRINPUT	8,181,OBJECT_Edit_Name
OFL1:	ADD_WINDOW_SWITCH	8,200,"Normal calcs.",?,7
OFL2:	ADD_WINDOW_SWITCH	8,216,"Vertex shading",?,8
OFL3:	ADD_WINDOW_SWITCH	8,232,"Back culling",?,0
OFL4:	ADD_WINDOW_SWITCH	8,248,"Hide object",?,9
	ADD_WINDOW_BUTTON	8,266,"Normals",OBJECT_Normals
	ADD_WINDOW_BUTTON	96,266,"Del",OBJECT_Delete
	ADD_WINDOW_BUTTON	8,286,"Make Triangles",OBJECT_Triangles

	ADD_WINDOW_TEXT		4,312,"Rotation:"
	ADD_WINDOW_BUTTON	12,327,"X +",OBJECT_Inc_RotX
	ADD_WINDOW_BUTTON	12,346,"X -",OBJECT_Dec_RotX
	ADD_WINDOW_BUTTON	52,327,"Y +",OBJECT_Inc_RotY
	ADD_WINDOW_BUTTON	52,346,"Y -",OBJECT_Dec_RotY
	ADD_WINDOW_BUTTON	92,327,"Z +",OBJECT_Inc_RotZ
	ADD_WINDOW_BUTTON	92,346,"Z -",OBJECT_Dec_RotZ
	ADD_WINDOW_TEXT		4,370,"Translation:"
	ADD_WINDOW_BUTTON	12,385,"X +",OBJECT_Inc_TransX
	ADD_WINDOW_BUTTON	12,404,"X -",OBJECT_Dec_TransX
	ADD_WINDOW_BUTTON	52,385,"Y +",OBJECT_Inc_TransY
	ADD_WINDOW_BUTTON	52,404,"Y -",OBJECT_Dec_TransY
	ADD_WINDOW_BUTTON	92,385,"Z +",OBJECT_Inc_TransZ
	ADD_WINDOW_BUTTON	92,404,"Z -",OBJECT_Dec_TransZ
	TERMINATE_WINDOW

Win6	LABEL BYTE
	CREATE_WINDOW		0,0,144,238,"Surface"
SADR:	ADD_WINDOW_LIST_BOX	8,4,SRFC_Select
	ADD_WINDOW_BUTTON	12,182,"Colour",WS_Open_Colour
	ADD_WINDOW_BUTTON	78,182,"Phong",WS_Open_Phong
	ADD_WINDOW_BUTTON	12,202,"Texture",WS_Open_Texture
	ADD_WINDOW_BUTTON	86,202,"Bump",WS_Open_Bump
	TERMINATE_WINDOW


Win7	LABEL BYTE
	CREATE_WINDOW		496,0,144,360,"Camera"
CADR:	ADD_WINDOW_LIST_BOX	6,4,CAMERA_Select
CTXT:	ADD_WINDOW_STRINPUT	8,181,CAMERA_Edit_Name
	ADD_WINDOW_BUTTON	12,202,"Delete",CAMERA_Delete
	ADD_WINDOW_BUTTON	92,202,"New",CAMERA_New
	ADD_WINDOW_TEXT		4,230,"Rotation:"
	ADD_WINDOW_BUTTON	12,244,"X +",CAMERA_Inc_RotX
	ADD_WINDOW_BUTTON	12,263,"X -",CAMERA_Dec_RotX
	ADD_WINDOW_BUTTON	52,244,"Y +",CAMERA_Inc_RotY
	ADD_WINDOW_BUTTON	52,263,"Y -",CAMERA_Dec_RotY
	ADD_WINDOW_BUTTON	92,244,"Z +",CAMERA_Inc_RotZ
	ADD_WINDOW_BUTTON	92,263,"Z -",CAMERA_Dec_RotZ
	ADD_WINDOW_TEXT		4,287,"Translation:"
	ADD_WINDOW_BUTTON	12,301,"X +",CAMERA_Inc_TransX
	ADD_WINDOW_BUTTON	12,320,"X -",CAMERA_Dec_TransX
	ADD_WINDOW_BUTTON	52,301,"Y +",CAMERA_Inc_TransY
	ADD_WINDOW_BUTTON	52,320,"Y -",CAMERA_Dec_TransY
	ADD_WINDOW_BUTTON	92,301,"Z +",CAMERA_Inc_TransZ
	ADD_WINDOW_BUTTON	92,320,"Z -",CAMERA_Dec_TransZ
	TERMINATE_WINDOW

Win8	LABEL BYTE
	CREATE_WINDOW		0,240,144,200,"Texture"
TNUM:   ADD_WINDOW_INTINPUT	12,6,0,255,TXT_Select
	ADD_WINDOW_BUTTON	92,5,"Del",TXT_Delete
TADR:	ADD_WINDOW_TEXTURE	8,28,TXT_Nothing
	ADD_WINDOW_BUTTON	12,164,"Retexture Obj",TXT_Retexture
	TERMINATE_WINDOW

Win9	LABEL BYTE
	CREATE_WINDOW		0,240,144,200,"Colour"
	ADD_WINDOW_TEXT		8,6,"Colour :"
CNUM:  	ADD_WINDOW_INTINPUT	76,4,0,255,COL_Colour
CBUT:	ADD_WINDOW_BUTTON	20,23, "255 colours",COL_Mode
	ADD_WINDOW_TEXT		8,57,"Red   :"
	ADD_WINDOW_TEXT		8,77,"Green :"
	ADD_WINDOW_TEXT		8,97,"Blue  :"
CRED:  	ADD_WINDOW_INTINPUT	76,55,0,255,COL_Red
CGRN:  	ADD_WINDOW_INTINPUT	76,75,0,255,COL_Green
CBLU:  	ADD_WINDOW_INTINPUT	76,95,0,255,COL_Blue
	ADD_WINDOW_TEXT		8,143,"Phong :"
PEXP:	ADD_WINDOW_INTINPUT	76,141,1,16,COL_Phong
	ADD_WINDOW_BUTTON	12,164,"Palette . . .",COL_Palette
	TERMINATE_WINDOW

Win10	LABEL BYTE
	CREATE_WINDOW           148,0,344,142,"Palette"
	ADD_WINDOW_TEXT		8,6,"Light:"
	ADD_WINDOW_TEXT		12,26,"Darkness  :"
	ADD_WINDOW_TEXT		12,46,"Brightness:"
	ADD_WINDOW_TEXT		12,66,"Red   :"
	ADD_WINDOW_TEXT		12,86,"Green :"
	ADD_WINDOW_TEXT		12,106,"Blue  :"
PDARK:	ADD_WINDOW_INTINPUT	110,24,0,64,PAL_Darkness
PBRIT:	ADD_WINDOW_INTINPUT	110,44,0,64,PAL_Brightness

	ADD_WINDOW_BUTTON	180,44, "Make colour shades",PAL_Shad
	ADD_WINDOW_BUTTON	180,64, " Create Bump  LUT ",PAL_BLUT
	ADD_WINDOW_BUTTON	180,84, "Create Shading LUT",PAL_SLUT
	ADD_WINDOW_BUTTON	180,104," Create Glass LUT ",PAL_GLUT
	TERMINATE_WINDOW

Win11	LABEL BYTE
	CREATE_WINDOW           0,0,144,210,"Recorder"
	ADD_WINDOW_TEXT		8  ,10 ,"Frame:"
	ADD_WINDOW_BUTTON	10 ,34 ,"  Grab Frame ",REC_Grab
	ADD_WINDOW_BUTTON	10 ,54 ,"Predict Frame",REC_Predict
	ADD_WINDOW_BUTTON	10 ,74 ,"  View Frame ",REC_View
	ADD_WINDOW_BUTTON	18 ,100 ,"Play script",REC_Play
RFRM:	ADD_WINDOW_INTINPUT     72 ,8  ,0,9999,REC_Frame
	ADD_WINDOW_SWITCH	16 ,126,"Lock objects",Record_Flags,0
	ADD_WINDOW_SWITCH       16 ,142,"Edit all",Record_Flags,1
	ADD_WINDOW_SWITCH       16 ,158,"Auto grab",Record_Flags,2
	ADD_WINDOW_SWITCH       16 ,174,"Auto predict",Record_Flags,3
	TERMINATE_WINDOW

Win12	LABEL BYTE
	CREATE_WINDOW		0,240,144,200,"Phong-Map"
PNUM:   ADD_WINDOW_INTINPUT	12,6,0,255,PNG_Select
	ADD_WINDOW_BUTTON	92,5,"Del",PNG_Delete
PADR:	ADD_WINDOW_TEXTURE	8,28,PNG_Nothing
	TERMINATE_WINDOW

Win13	LABEL BYTE
	CREATE_WINDOW		0,240,144,200,"Bump-Map"
BNUM:   ADD_WINDOW_INTINPUT	12,6,0,255,BUMP_Select
	ADD_WINDOW_BUTTON	92,5,"Del",BUMP_Delete
BADR:	ADD_WINDOW_TEXTURE	8,28,BUMP_Nothing
	TERMINATE_WINDOW

Win14	LABEL BYTE
	CREATE_WINDOW		50,452,540,26,""
	ADD_WINDOW_BUTTON	4, 4,"<<<",PLAY_FastBackward
	ADD_WINDOW_BUTTON	44,4,"<<",PLAY_Backward
	ADD_WINDOW_BUTTON	76,4,"<" ,PLAY_SlowBackward
PFRM:	ADD_WINDOW_INTEGER	100,7
	ADD_WINDOW_TEXT		132,7,":"
PTCK:	ADD_WINDOW_INTEGER	140,7
	ADD_WINDOW_BUTTON	166,4,">" ,PLAY_SlowForward
	ADD_WINDOW_BUTTON	190,4,">>" ,PLAY_Forward
	ADD_WINDOW_BUTTON	222,4,">>>" ,PLAY_FastForward
	ADD_WINDOW_BUTTON	266,4,"  " ,PLAY_Stop
	ADD_WINDOW_TEXT		336,7,"Speed:"
PSPD:	ADD_WINDOW_INTINPUT	386,4,1,100,PLAY_Speed
	ADD_WINDOW_BUTTON	488,4,"Exit",PLAY_Exit
	TERMINATE_WINDOW

ALIGN 16
Shading_List LABEL DWORD
	dd	38,0,0,0
	db	"Vertices     ",0,VOBJ_POINT,0
	db	"Wire frame   ",0,VOBJ_WIRE_POLY,0
	db	"  Smoothed   ",0,VOBJ_SOFT_WIRE,0
	db	"  Transparent",0,VOBJ_GLASS_WIRE,0
	db	"Filled       ",0,VOBJ_FILLED_POLY,0
	db	"  Lambert    ",0,VOBJ_LAMBERT_POLY,0
	db	"  Gouraud    ",0,VOBJ_GOURAUD_POLY,0
	db	"  Fast Phong ",0,VOBJ_FAST_PHONG,0
	db	"  Phong      ",0,VOBJ_PHONG_POLY,0
	db	"Transparent  ",0,VOBJ_GLASS_POLY,0
	db	"  Lambert    ",0,VOBJ_LAMBERT_GLASS,0
	db	"  Gouraud    ",0,VOBJ_GOURAUD_GLASS,0
	db	"  Fast Phong ",0,VOBJ_PHONG_GLASS,0
	db	"Texture      ",0,VOBJ_FAST_TEXTURE,0
	db	"  Lambert    ",0,VOBJ_LAMBERT_TEXTURE,0
	db	"  Gouraud    ",0,VOBJ_GOURAUD_TEXTURE,0
	db	"  Fast Phong ",0,VOBJ_PHONG_TEXTURE,0
	db	"  Transparent",0,VOBJ_GLASS_TEXTURE,0
	db	"  Lightmap   ",0,VOBJ_LIGHTMAP_TEXTURE,0
	db	"  Chrome     ",0,VOBJ_CHROME_TEXTURE,0
	db	"  Bump       ",0,VOBJ_BUMP_TEXTURE,0
	db	"Chrome       ",0,VOBJ_CHROME_POLY,0
	db	"  Lambert    ",0,VOBJ_LAMBERT_CHROME,0
	db	"  Gouraud    ",0,VOBJ_GOURAUD_CHROME,0
	db	"  Fast Phong ",0,VOBJ_PHONG_CHROME,0
	db	"  Transparent",0,VOBJ_GLASS_CHROME,0
	db	"  Bump       ",0,VOBJ_BUMP_CHROME,0
	db	"Bump         ",0,VOBJ_BUMP_POLY,0
	db	"  Lambert    ",0,VOBJ_LAMBERT_BUMP,0
	db	"  Gouraud    ",0,VOBJ_GOURAUD_BUMP,0
	db	"  Fast Phong ",0,VOBJ_PHONG_BUMP,0
	db	"  Transparent",0,VOBJ_GLASS_BUMP,0
	db	"  Lightmap   ",0,VOBJ_LIGHTMAP_BUMP,0
	db	"Carva        ",0,VOBJ_CARVA_POLY,0
	db	"  Lambert    ",0,VOBJ_LAMBERT_CARVA,0
	db	"  Gouraud    ",0,VOBJ_GOURAUD_CARVA,0
	db	"  Fast Phong ",0,VOBJ_PHONG_CARVA,0
	db	"  Transparent",0,VOBJ_GLASS_CARVA,0


File_List LABEL DWORD
	dd	7,0,0,0
	db	"Scene    [GVE]",0,0
	db	"Palette  [PAL]",0,0
	db	"Texture  [PCX]",0,0
	db	"PhongMap [PCX]",0,0
	db	"BumpMap  [PCX]",0,0
	db	"Object   [3DS]",0,0
	db	"Video    [VID]",0,0
	db	"Module    [XM]",0,0




;
;
;
;   GOMEZ VECTOR ENGINE                                    STARTUP ROUTINE
;
;
;
;
;
; This is the main routine
;
PUBLIC C main
main PROC NEAR
	call	dword ptr ds:[GUS_Driver+40]
	mov	eax,OFFSET GUS_Driver
	jnc	short @@Doit
	call	dword ptr ds:[SBDMA_Driver+40]
	mov	eax,OFFSET SBDMA_Driver
	jnc	short @@Doit
	mov	eax,OFFSET SILENT_Driver
	;
@@Doit:	mov	ebx,GMI_USE_STEREO or GMI_USE_16BIT
	mov	ecx,22000
	call	Init_GMI
	jc	@@Err
	;
	call	Init_GWM
	jc	@@Err
	mov	eax,DISPLAY_Width
	mov	ebx,DISPLAY_Height
	mov	ecx,DISPLAY_Depth
	call	Init_GVE
	jc	@@Err
	mov	eax,SVGA_MOde_640x480x256
	call	Init_SVGA
	jc	@@Err
	;
	mov	ecx,512*16		;Room for directory
	call	Malloc
	mov	dword ptr ds:[FADR+12],eax
	mov	edx,eax
	mov	ebx,OFFSET Dir_Mask
	call	GWM_Read_Directory
	;
	mov	ecx,128*16		;Room for object list
	call	Malloc
	mov	dword ptr ds:[OADR+12],eax

	mov	ecx,32*16		;Room for light list
	call	Malloc
	mov	dword ptr ds:[LADR+12],eax

	mov	ecx,32*16		;Room for camera list
	call	Malloc
	mov	dword ptr ds:[CADR+12],eax

	mov	eax,OFFSET Shading_List
	mov	dword ptr ds:[SADR+12],eax

	mov	eax,OFFSET WorldName
	mov	dword ptr ds:[FNAM+12],eax

	mov	eax,OFFSET File_List
	mov	dword ptr ds:[FTYP+12],eax

	call	GVE_Alloc_World
	mov	ds:[World_Ptr],eax
	call	GVE_Alloc_Light
	mov	eax,ds:[World_Ptr]
	call	GVE_Alloc_Object
	mov	eax,ds:[World_Ptr]
	call	GVE_Alloc_Camera
	call	Init_World
	;
	mov	eax,OFFSET WinS
	call	GWM_Open_Window

@@L1:   call	Coreleft
	shr	eax,10
	mov	dword ptr ds:[FMEM+8],eax
	call	GVE_Transform_World
	mov	eax,ds:[World_Ptr]
	mov	ebx,ds:[Camera_Ptr]
	mov	ecx,ds:[SVGA_Old_Frame_Buffer]
	mov	edx,ds:[SVGA_Frame_Buffer]
	call	GVE_Draw_World
	call	GWM_Refresh_Desktop
	jmp	@@L1
	;
	call	Exit_GWM
	call	Exit_GVE
	call	Exit_SVGA
	call	Exit_GMI
@@Err:	jmp	Exit_PMODE32
main ENDP


;
;
;
;   GOMEZ VECTOR ENGINE   KEY-FRAMER         WINDOW-FUNCTIONS
;
;
;
WS_Start:
	mov	eax,OFFSET WinS
	call	GWM_Close_Window
	mov	eax,OFFSET Win0
	jmp 	GWM_Open_Window
WS_Open_Files:
	mov	eax,OFFSET Win2
	call	GWM_Flip_Window
	jmp	GWM_Wait_Mouse
WS_Exit:
	call	GMI_Stop_Song
	mov	eax,ds:[Song_Ptr]
	call	GMI_Free_Song
	mov	eax,ds:[World_Ptr]
	call	GVE_Free_World
	call	Exit_GWM
	call	Exit_SVGA
	call	Exit_GVE
	call	Exit_GMI
	jmp	Exit_PMODE32
WS_Open_Colour:
	mov	eax,OFFSET Win12
	call	GWM_Close_Window
	mov	eax,OFFSET Win13
	call	GWM_Close_Window
	mov	eax,OFFSET Win8
	call	GWM_Close_Window
	mov	eax,OFFSET Win10
	call	GWM_Close_Window
	mov	eax,OFFSET Win9
	call	GWM_Flip_Window
	jmp 	GWM_Wait_Mouse
WS_Open_Texture:
	mov	eax,OFFSET Win9
	call	GWM_Close_Window
	mov	eax,OFFSET Win12
	call	GWM_Close_Window
	mov	eax,OFFSET Win10
	call	GWM_Close_Window
	mov	eax,OFFSET Win13
	call	GWM_Close_Window
	mov	eax,OFFSET Win8
	call	GWM_Flip_Window
	jmp 	GWM_Wait_Mouse
WS_Open_Phong:
	mov	eax,OFFSET Win9
	call	GWM_Close_Window
	mov	eax,OFFSET Win8
	call	GWM_Close_Window
	mov	eax,OFFSET Win10
	call	GWM_Close_Window
	mov	eax,OFFSET Win13
	call	GWM_Close_Window
	mov	eax,OFFSET Win12
	call	GWM_Flip_Window
	jmp 	GWM_Wait_Mouse
WS_Open_Bump:
	mov	eax,OFFSET Win9
	call	GWM_Close_Window
	mov	eax,OFFSET Win8
	call	GWM_Close_Window
	mov	eax,OFFSET Win10
	call	GWM_Close_Window
	mov	eax,OFFSET Win12
	call	GWM_Close_Window
	mov	eax,OFFSET Win13
	call	GWM_Flip_Window
	jmp 	GWM_Wait_Mouse
WS_Open_Camera:
	mov	eax,OFFSET Win4
	call	GWM_Close_Window
	mov	eax,OFFSET Win5
	call	GWM_Close_Window
	mov	eax,OFFSET Win7
	call	GWM_Flip_Window
	jmp 	GWM_Wait_Mouse
WS_Open_Object:
	mov	eax,OFFSET Win4
	call	GWM_Close_Window
	mov	eax,OFFSET Win7
	call	GWM_Close_Window
	mov	eax,OFFSET Win5
	call	GWM_Flip_Window
	jmp 	GWM_Wait_Mouse
WS_Open_Surface:
	mov	eax,OFFSET Win8
	call	GWM_Close_Window
	mov	eax,OFFSET Win9
	call	GWM_Close_Window
	mov	eax,OFFSET Win10
	call	GWM_Close_Window
	mov	eax,OFFSET Win11
	call	GWM_Close_Window
	mov	eax,OFFSET Win12
	call	GWM_Close_Window
	mov	eax,OFFSET Win13
	call	GWM_Close_Window
	mov	eax,OFFSET Win6
	call	GWM_Flip_Window
	jmp 	GWM_Wait_Mouse
WS_Open_Light:
	mov	eax,OFFSET Win5
	call	GWM_Close_Window
	mov	eax,OFFSET Win7
	call	GWM_Close_Window
	mov	eax,OFFSET Win4
	call	GWM_Flip_Window
	jmp	GWM_Wait_Mouse
WS_Open_Options:
	mov	eax,OFFSET Win10
	call	GWM_Close_Window
	mov	eax,OFFSET Win3
	call	GWM_Flip_Window
	jmp	GWM_Wait_Mouse
WS_Open_Recorder:
	mov	eax,OFFSET Win8
	call	GWM_Close_Window
	mov	eax,OFFSET Win9
	call	GWM_Close_Window
	mov	eax,OFFSET Win10
	call	GWM_Close_Window
	mov	eax,OFFSET Win12
	call	GWM_Close_Window
	mov	eax,OFFSET Win13
	call	GWM_Close_Window
	mov	eax,OFFSET Win6
	call	GWM_Close_Window
	mov	eax,OFFSET Win11
	call	GWM_Flip_Window
	jmp	GWM_Wait_Mouse

;
;
; Play-Functions
;
PLAY_FastForward:
PLAY_Forward:
PLAY_SlowForward:
	mov	eax,ds:[World_Ptr]
	mov	ecx,d ds:[PFRM+8]
	mov	edx,d ds:[PTCK+8]
	shl	ecx,GVE_SCRIPT_SHIFT
	or	ecx,edx
	xor	edx,edx
	call	GVE_Jump_Frame
	retn
PLAY_FastBackward:
PLAY_Backward:
PLAY_SlowBackward:
PLAY_Stop:
PLAY_Speed:
	retn
PLAY_Exit:
	mov	eax,OFFSET Win14
	call	GWM_Close_Window
	mov	eax,OFFSET Win0
	call	GWM_Open_Window
	mov	eax,ds:[World_Ptr]
	mov	ecx,d ds:[RFRM+12]
	shl	ecx,GVE_SCRIPT_SHIFT
	xor	edx,edx
	call	GVE_Jump_Frame
	jmp	GWM_Wait_Mouse

;
;
; Rotation/ Translation control functions for camera
;
CAMERA_Select:
	mov	ebx,ds:[World_Ptr]
	mov	ebx,ds:[ebx+World_Camera_List]	;EBX = ptr to camera list
	mov	edx,ds:[ebx+4*eax+4]		;EDX = ptr to selected camera
	;
	mov	esi,dword ptr ds:[CADR+12]	;Get address of object list
	inc	eax
	shl	eax,4
	add	esi,eax                         ;ESI points to object-list entry
	mov	dword ptr ds:[CTXT+12],esi
	;
	mov	ds:[Camera_Ptr],edx
	mov	eax,ds:[World_Ptr]		;EAX = world-header
	call	GVE_Get_Camera_Info		;Get camera-info
	retn
CAMERA_Edit_Name:
	mov	esi,dword ptr ds:[CTXT+12]
	mov	edi,ds:[Camera_Ptr]
	mov	ecx,16/4
	rep	movsd
	retn
CAMERA_New:
	mov	eax,ds:[World_Ptr]
	call	GVE_Alloc_Camera
	mov	edx,eax
	mov	eax,ds:[World_Ptr]
	call	GVE_Move_Camera
	call	Get_Objects
	jmp	GWM_Wait_Mouse
CAMERA_Delete:
	mov	eax,ds:[World_Ptr]
	mov	edx,ds:[eax+World_Camera_List]
	cmp	d ds:[edx],1
	jbe	GWM_Wait_Mouse
	mov	edx,ds:[Camera_Ptr]		;Get object-number
	call	GVE_Free_Camera
	call	Get_Objects
	jmp	GWM_Wait_Mouse
CAMERA_Inc_RotX:
	mov	edx,ds:[Camera_Ptr]
	add	ds:[edx+Camera_RotationX],eax
	mov	eax,ds:[World_Ptr]
	jmp 	GVE_Move_Camera
CAMERA_Dec_RotX:
	mov	edx,ds:[Camera_Ptr]
	sub	ds:[edx+Camera_RotationX],eax
	mov	eax,ds:[World_Ptr]
	jmp 	GVE_Move_Camera
CAMERA_Inc_RotY:
	mov	edx,ds:[Camera_Ptr]
	add	ds:[edx+Camera_RotationY],eax
	mov	eax,ds:[World_Ptr]
	jmp 	GVE_Move_Camera
CAMERA_Dec_RotY:
	mov	edx,ds:[Camera_Ptr]
	sub	ds:[edx+Camera_RotationY],eax
	mov	eax,ds:[World_Ptr]
	jmp 	GVE_Move_Camera
CAMERA_Inc_RotZ:
	mov	edx,ds:[Camera_Ptr]
	add	ds:[edx+Camera_RotationZ],eax
	mov	eax,ds:[World_Ptr]
	jmp 	GVE_Move_Camera
CAMERA_Dec_RotZ:
	mov	edx,ds:[Camera_Ptr]
	sub	ds:[edx+Camera_RotationZ],eax
	mov	eax,ds:[World_Ptr]
	jmp 	GVE_Move_Camera
CAMERA_Inc_TransX:
	shl	eax,GVE_MATH_SHIFT
	mov	edx,ds:[Camera_Ptr]
	add	ds:[edx+Camera_PositionX],eax
	mov	eax,ds:[World_Ptr]
	jmp 	GVE_Move_Camera
CAMERA_Dec_TransX:
	shl	eax,GVE_MATH_SHIFT
	mov	edx,ds:[Camera_Ptr]
	sub	ds:[edx+Camera_PositionX],eax
	mov	eax,ds:[World_Ptr]
	jmp 	GVE_Move_Camera
CAMERA_Inc_TransY:
	shl	eax,GVE_MATH_SHIFT
	mov	edx,ds:[Camera_Ptr]
	add	ds:[edx+Camera_PositionY],eax
	mov	eax,ds:[World_Ptr]
	jmp 	GVE_Move_Camera
CAMERA_Dec_TransY:
	shl	eax,GVE_MATH_SHIFT
	mov	edx,ds:[Camera_Ptr]
	sub	ds:[edx+Camera_PositionY],eax
	mov	eax,ds:[World_Ptr]
	jmp 	GVE_Move_Camera
CAMERA_Inc_TransZ:
	shl	eax,GVE_MATH_SHIFT
	mov	edx,ds:[Camera_Ptr]
	add	ds:[edx+Camera_PositionZ],eax
	mov	eax,ds:[World_Ptr]
	jmp 	GVE_Move_Camera
CAMERA_Dec_TransZ:
	shl	eax,GVE_MATH_SHIFT
	mov	edx,ds:[Camera_Ptr]
	sub	ds:[edx+Camera_PositionZ],eax
	mov	eax,ds:[World_Ptr]
	jmp 	GVE_Move_Camera

;
;
; Light source Rotation/ Translation control functions
;
LIGHT_Select:
	mov	ebx,ds:[World_Ptr]
	mov	ebx,ds:[ebx+World_Light_List]	;EBX = ptr to light list
	mov	edx,ds:[ebx+4*eax+4]		;EDX = ptr to selected light
	;
	mov	esi,dword ptr ds:[LADR+12]	;Get address of object list
	inc	eax
	shl	eax,4
	add	esi,eax                         ;ESI points to object-list entry
	mov	dword ptr ds:[LTXT+12],esi
	;
	mov	ds:[Light_Ptr],edx
	mov	eax,ds:[World_Ptr]		;EAX = world-header
	call	GVE_Get_Light_Info		;Get light-info
	;
	mov	byte ptr ds:[PDARK+12],bl
	mov	byte ptr ds:[PBRIT+12],bh
	mov	byte ptr ds:[LRED+12],al
	mov	byte ptr ds:[LGRN+12],ah
	shr	eax,16
	mov	byte ptr ds:[LBLU+12],al
	retn
LIGHT_Edit_Name:
	mov	esi,dword ptr ds:[LTXT+12]
	mov	edi,ds:[Light_Ptr]
	mov	ecx,16/4
	rep	movsd
	retn
LIGHT_New:
	mov	eax,ds:[World_Ptr]
	call	GVE_Alloc_Light
	mov	edx,eax
	mov	eax,ds:[World_Ptr]
	call	GVE_Move_Light
	call	Get_Objects
	jmp	GWM_Wait_Mouse
LIGHT_Delete:
	mov	eax,ds:[World_Ptr]
	mov	edx,ds:[eax+World_Light_List]
	cmp	d ds:[edx],1
	jbe	GWM_Wait_Mouse
	mov	edx,ds:[Light_Ptr]		;Get object-number
	call	GVE_Free_Light
	call	Get_Objects
	jmp	GWM_Wait_Mouse
LIGHT_Inc_RotX:
	mov	ebx,ds:[Light_Ptr]
	add	ds:[ebx+Light_Position],eax
	mov	edx,ds:[Light_Ptr]
	jmp 	GVE_Move_Light
LIGHT_Dec_RotX:
	mov	ebx,ds:[Light_Ptr]
	sub	ds:[ebx+Light_Position],eax
	mov	edx,ds:[Light_Ptr]
	jmp 	GVE_Move_Light
LIGHT_Inc_RotY:
	mov	ebx,ds:[Light_Ptr]
	add	ds:[ebx+Light_Position+4],eax
	mov	edx,ds:[Light_Ptr]
	jmp 	GVE_Move_Light
LIGHT_Dec_RotY:
	mov	ebx,ds:[Light_Ptr]
	sub	ds:[ebx+Light_Position+4],eax
	mov	edx,ds:[Light_Ptr]
	jmp 	GVE_Move_Light
LIGHT_Inc_RotZ:
	mov	ebx,ds:[Light_Ptr]
	add	ds:[ebx+Light_Position+8],eax
	mov	edx,ds:[Light_Ptr]
	jmp 	GVE_Move_Light
LIGHT_Dec_RotZ:
	mov	ebx,ds:[Light_Ptr]
	sub	ds:[ebx+Light_Position+8],eax
	mov	edx,ds:[Light_Ptr]
	jmp 	GVE_Move_Light
LIGHT_Inc_TransX:
	shl	eax,GVE_MATH_SHIFT
	mov	ebx,ds:[Light_Ptr]
	add	ds:[ebx+Light_Position+12],eax
	mov	edx,ds:[Light_Ptr]
	jmp 	GVE_Move_Light
LIGHT_Dec_TransX:
	shl	eax,GVE_MATH_SHIFT
	mov	ebx,ds:[Light_Ptr]
	sub	ds:[ebx+Light_Position+12],eax
	mov	edx,ds:[Light_Ptr]
	jmp 	GVE_Move_Light
LIGHT_Inc_TransY:
	shl	eax,GVE_MATH_SHIFT
	mov	ebx,ds:[Light_Ptr]
	add	ds:[ebx+Light_Position+16],eax
	mov	edx,ds:[Light_Ptr]
	jmp 	GVE_Move_Light
LIGHT_Dec_TransY:
	shl	eax,GVE_MATH_SHIFT
	mov	ebx,ds:[Light_Ptr]
	sub	ds:[ebx+Light_Position+16],eax
	mov	edx,ds:[Light_Ptr]
	jmp 	GVE_Move_Light
LIGHT_Inc_TransZ:
	shl	eax,GVE_MATH_SHIFT
	mov	ebx,ds:[Light_Ptr]
	add	ds:[ebx+Light_Position+20],eax
	mov	edx,ds:[Light_Ptr]
	jmp 	GVE_Move_Light
LIGHT_Dec_TransZ:
	shl	eax,GVE_MATH_SHIFT
	mov	ebx,ds:[Light_Ptr]
	sub	ds:[ebx+Light_Position+20],eax
	mov	edx,ds:[Light_Ptr]
	jmp 	GVE_Move_Light
;
;
; File routines
;
FILE_Select:
	mov	ebx,dword ptr ds:[FADR+12]
	inc	eax				;For skipping header
	shl	eax,4				;16 bytes/entry
	add	ebx,eax
	test	word ptr ds:[ebx+14],16		;Is it sub-directory
	jnz	newdir
	push	esi
	push	edi
	mov	edi,dword ptr ds:[FNAM+12]	;LIN32 ptr to file-name
	mov	esi,ebx
	mov	ecx,16/4
	rep	movsd
	pop	edi
	pop	esi
	retn
    newdir:
	call	Chdir
	jmp     readdir
FILE_Type:
	cmp	eax,1
	jb	short @@0
	ja	short @@3
		mov	eax,OFFSET PalName
		mov	dword ptr ds:[FNAM+12],eax
		jmp	short readdir
	@@0:	mov	eax,OFFSET WorldName
		mov	dword ptr ds:[FNAM+12],eax
		jmp	short readdir
	@@2:	mov	eax,OFFSET TexName
		mov	dword ptr ds:[FNAM+12],eax
		jmp	short readdir
	@@3:    cmp	eax,3
		jb	short @@2
		ja	short @@4
		mov	eax,OFFSET LigName
		mov	dword ptr ds:[FNAM+12],eax
		jmp	short readdir
	@@4:	cmp	eax,5
		je	short @@5
		ja	short @@6
		mov	eax,OFFSET BumpName
		mov	dword ptr ds:[FNAM+12],eax
		jmp	short readdir
	@@5:	mov	eax,OFFSET ObjName
		mov	dword ptr ds:[FNAM+12],eax
		jmp	short readdir
	@@6:    cmp	eax,7
		je	short @@7
		mov	eax,OFFSET VidName
		mov	dword ptr ds:[FNAM+12],eax
		jmp	short readdir
	@@7:	mov	eax,OFFSET SongName
		mov	dword ptr ds:[FNAM+12],eax
		jmp	short readdir
    readdir:
	mov	edx,dword ptr ds:[FADR+12]
	mov	ebx,ds:[File_List+8]
	lea	ebx,[8*ebx+OFFSET Dir_Mask]
	call	GWM_Read_Directory
	jmp	GWM_Wait_Mouse
FILE_Load:
	mov	ebx,dword ptr ds:[FNAM+12]
	mov	eax,dword ptr ds:[File_List+8]	;Get current file-type
	cmp	eax,0
	jne	short @@pal
		xor	edx,edx
		jmp 	Load_World
	;
    @@pal:
	cmp	eax,1
	jne	short @@texture
		mov	eax,ds:[World_Ptr]
		mov	ecx,GVE_PAL_REMAP
		xor	edx,edx
		call	GVE_Import_Palette	;Load palette
		mov	esi,eax			;ESI = ptr to palette
		call	GWM_Init_Palette
		mov	eax,ds:[World_Ptr]
		call	GVE_Set_Palette         ;Init world
		mov	eax,esi
		xor	ebx,ebx
		mov	ecx,256
		call	SVGA_Set_Palette
		jmp	GWM_WAit_Mouse		;bye-bye !
	;
    @@texture:
	cmp	eax,2
	jne	short @@phong
		mov	eax,ds:[World_Ptr]
		mov	ecx,GVE_TEXT_REMAP or GVE_TEXT_RESCALE
		mov	edx,dword ptr ds:[TNUM+12]
		call 	GVE_Import_Texture
		mov	dword ptr ds:[TADR+12],eax	;Save texture address
		jmp	GWM_WAit_Mouse			;bye-bye !
	;
    @@phong:
	cmp	eax,3
	jne	short @@bump
		mov	eax,ds:[World_Ptr]
		mov	ecx,GVE_TEXT_RESCALE
		mov	edx,dword ptr ds:[PNUM+12]
		call 	GVE_Import_LightMap
		mov	dword ptr ds:[PADR+12],eax	;Save texture address
		jmp	GWM_WAit_Mouse			;bye-bye !
	;
    @@bump:
	cmp	eax,4
	jne	short @@object
		mov	eax,ds:[World_Ptr]
		mov	ecx,GVE_TEXT_RESCALE
		mov	edx,dword ptr ds:[BNUM+12]
		call 	GVE_Import_BumpMap
		mov	dword ptr ds:[BADR+12],eax	;Save texture address
		jmp	GWM_WAit_Mouse			;bye-bye !
	;
    @@object:
	cmp	eax,5
	jne	short @@video
		mov	eax,ds:[World_Ptr]
		xor	edx,edx
		call	GVE_Import_3DS
		call	Get_Objects
		jmp	GWM_WAit_Mouse			;bye-bye !
	;
    @@video:
	cmp	eax,6
	jne	short @@song
		mov	eax,ds:[World_Ptr]
		mov	edx,dword ptr ds:[TNUM+12]
		call 	GVE_Import_Video
		mov	dword ptr ds:[TADR+12],edx	;Save texture address
		jmp	GWM_WAit_Mouse			;bye-bye !
	;
    @@song:
	cmp	eax,7
	jne	short @@fuck
		push	ebx
		call	GMI_Stop_Song
		mov	eax,ds:[Song_Ptr]
		call 	GMI_Free_Song
		pop	ebx
		xor	edx,edx
		call	GMI_load_Song
		mov	ds:[Song_Ptr],eax
		call	GMI_Play_Song
		jmp	GWM_Wait_Mouse
	;
    @@fuck:
	retn
FILE_Delete:
	retn
FILE_Save:
	mov	ebx,dword ptr ds:[FNAM+12]	;EBX = ptr to file-name
	mov	eax,dword ptr ds:[File_List+8]	;EAX = current file-type
	cmp	eax,0
	jne	@@pal
		mov	eax,ds:[World_Ptr]	;EAX = world-ptr
		mov	ecx,COMPRESSION_LZW
		xor	edx,edx			;EDX = file-start
		call	GVE_Save_World
		jmp	readdir
	;
    @@pal:
	cmp	eax,1
	jne	short @@texture
		mov	eax,ds:[World_Ptr]
		xor	ecx,ecx			;ECX = options
		xor	edx,edx			;EDX = file-start
		call	GVE_Export_Palette	;Save palette
		jmp	readdir			;bye-bye !
	;
    @@texture:
	cmp	eax,2
	jne	short @@phong
		mov	eax,ds:[World_Ptr]
		xor	ecx,ecx			;ECX = options
		mov	edx,dword ptr ds:[TNUM+12]
		call	GVE_Export_Texture	;Save palette
		jmp	readdir			;bye-bye !
	;
    @@phong:
	cmp	eax,3
	jne	short @@bump
		mov	eax,ds:[World_Ptr]
		xor	ecx,ecx			;ECX = options
		mov	edx,dword ptr ds:[PNUM+12]
		call	GVE_Export_LightMap	;Save palette
		jmp	readdir			;bye-bye !
	;
    @@bump:
	cmp	eax,4
	jne	short @@fuck
		mov	eax,ds:[World_Ptr]
		xor	ecx,ecx			;ECX = options
		mov	edx,dword ptr ds:[BNUM+12]
		call	GVE_Export_BumpMap	;Save palette
		jmp	readdir			;bye-bye !
	;
    @@fuck:
	retn
FILE_New:
	mov	eax,ds:[World_Ptr]	;First lets free old world
	call	GVE_Free_World
	call	GVE_Alloc_World
	mov	ds:[World_Ptr],eax
	xor	edx,edx
	call	GVE_Alloc_Light
	mov	eax,ds:[World_Ptr]
	call	GVE_Alloc_Camera
	mov	eax,ds:[World_Ptr]
	call	GVE_Alloc_Object
	jmp	Init_World
FILE_Name:
	retn


;
;
; Object routines
;
OBJECT_Select:
	mov	ebx,ds:[World_Ptr]
	mov	ebx,ds:[ebx+World_Object_List]	;EBX = ptr to object list
	mov	edx,ds:[ebx+4*eax+4]		;EDX = ptr to selected object
	;
	mov	esi,dword ptr ds:[OADR+12]	;Get address of object list
	inc	eax
	shl	eax,4
	add	esi,eax                         ;ESI points to object-list entry
	mov	dword ptr ds:[OTXT+12],esi
	;
	mov	ds:[Object_Ptr],edx
	mov	eax,ds:[World_Ptr]		;EAX = world-header
	call	GVE_Get_Object_Info		;Get object-info
	mov	byte ptr ds:[PEXP+12],ah	;Save phong exponent
	mov	byte ptr ds:[PNUM+12],ah	;Save phong exponent
	mov	byte ptr ds:[BNUM+12],bh
	mov	dword ptr ds:[TNUM+12],ecx
	mov	edx,ds:[Object_Ptr]
	add	edx,Object_Flags		;EDX = ptr to object-flags
	mov	dword ptr ds:[OFL1+8],edx
	mov	dword ptr ds:[OFL2+8],edx
	mov	dword ptr ds:[OFL3+8],edx
	mov	dword ptr ds:[OFL4+8],edx
	;
	movzx	ebx,bl				;EBX = Object colour
	mov	edx,ds:[World_Ptr]
	mov	edx,ds:[edx+World_Palette]
	lea	edx,[edx+4*ebx]			;EDX = 4*EBX (size of RGB triple)
	cmp	dword ptr ds:[CBUT+12],' 552'	;Get first letters
	je	short @@J2
		shr	bl,4
@@J2:	mov	byte ptr ds:[CNUM+12],bl	;Save colour number
	mov	ebx,ds:[edx]			;Get RGB-values
	mov	byte ptr ds:[CRED+12],bl
	mov	byte ptr ds:[CGRN+12],bh
	shr	ebx,8
	mov	byte ptr ds:[CBLU+12],bh	;And save palette values here !
	;
	mov	esi,OFFSET Shading_List+16	;ESI = first entry in shading
	xor	ebx,ebx				;       list
@@L1:	cmp	ds:[esi+14],al			;Compare current shading
	je	short @@End			;  and list entry
	add	esi,16				;Next entry
	inc	ebx
	cmp	ebx,ds:[Shading_List]
	jb	short @@L1                      ;Loop
@@End:	mov	byte ptr ds:[Shading_List+8],bl	;Save shading-list-no
	;
	mov	eax,ds:[World_Ptr]		;EAX = world-header
	mov	edx,ecx				;EDX = texture-no
	call	GVE_Get_Texture_Info		;Get info
	mov	dword ptr ds:[TADR+12],eax	;Save texture address
	mov	eax,ds:[World_Ptr]		;EAX = world-header
	mov	edx,dword ptr ds:[PNUM+12]	;EDX = texture-no
	call	GVE_Get_LightMap_Info		;Get info
	mov	dword ptr ds:[PADR+12],eax	;Save texture address
	mov	eax,ds:[World_Ptr]		;EAX = world-header
	mov	edx,dword ptr ds:[BNUM+12]	;EDX = bump-no
	call	GVE_Get_BumpMap_Info		;Get info
	mov	dword ptr ds:[BADR+12],eax	;Save bump address
	retn
OBJECT_Delete:
	mov	eax,ds:[World_Ptr]
	mov	edx,ds:[Object_Ptr]		;Get object-number
	call	GVE_Free_Object
	call	Get_Objects
	jmp	GWM_Wait_Mouse
OBJECT_Normals:
	mov	eax,ds:[World_Ptr]
	mov	edx,ds:[Object_Ptr]		;Get object-number
	jmp 	GVE_Init_Normals
OBJECT_Triangles:
	mov	eax,ds:[World_Ptr]
	mov	edx,ds:[Object_Ptr]		;Get object-number
	call 	GVE_Make_Triangles
	jmp	GWM_Wait_Mouse
OBJECT_Edit_Name:
	mov	esi,dword ptr ds:[OTXT+12]
	mov	edi,ds:[Object_Ptr]
	mov	ecx,16/4
	rep	movsd
	retn
SRFC_Select:
	mov	eax,dword ptr ds:[SADR+12]
	mov	ebx,dword ptr ds:[eax+8]        ;Get selected shading
	shl	ebx,4				;*16 bytes/list_entry
	mov	bl,ds:[eax+ebx+16+14]		;get shdaing-method
	mov	eax,ds:[World_Ptr]
	mov	edx,ds:[Object_Ptr]		;Get object number
	mov	ch,GVE_CHANGE_SHADING
	jmp	GVE_Change_Object
OBJECT_Inc_RotX:
	mov	ebx,ds:[Object_Ptr]
	add	ds:[ebx+Object_Position],eax
	mov	edx,ds:[Object_Ptr]
	jmp 	GVE_Move_Object
OBJECT_Dec_RotX:
	mov	ebx,ds:[Object_Ptr]
	sub	ds:[ebx+Object_Position],eax
	mov	edx,ds:[Object_Ptr]
	jmp 	GVE_Move_Object
OBJECT_Inc_RotY:
	mov	ebx,ds:[Object_Ptr]
	add	ds:[ebx+Object_Position+4],eax
	mov	edx,ds:[Object_Ptr]
	jmp 	GVE_Move_Object
OBJECT_Dec_RotY:
	mov	ebx,ds:[Object_Ptr]
	sub	ds:[ebx+Object_Position+4],eax
	mov	edx,ds:[Object_Ptr]
	jmp 	GVE_Move_Object
OBJECT_Inc_RotZ:
	mov	ebx,ds:[Object_Ptr]
	add	ds:[ebx+Object_Position+8],eax
	mov	edx,ds:[Object_Ptr]
	jmp 	GVE_Move_Object
OBJECT_Dec_RotZ:
	mov	ebx,ds:[Object_Ptr]
	sub	ds:[ebx+Object_Position+8],eax
	mov	edx,ds:[Object_Ptr]
	jmp 	GVE_Move_Object
OBJECT_Inc_TransX:
	shl	eax,GVE_MATH_SHIFT
	mov	ebx,ds:[Object_Ptr]
	add	ds:[ebx+Object_Position+12],eax
	mov	edx,ds:[Object_Ptr]
	jmp 	GVE_Move_Object
OBJECT_Dec_TransX:
	shl	eax,GVE_MATH_SHIFT
	mov	ebx,ds:[Object_Ptr]
	sub	ds:[ebx+Object_Position+12],eax
	mov	edx,ds:[Object_Ptr]
	jmp 	GVE_Move_Object
OBJECT_Inc_TransY:
	shl	eax,GVE_MATH_SHIFT
	mov	ebx,ds:[Object_Ptr]
	add	ds:[ebx+Object_Position+16],eax
	mov	edx,ds:[Object_Ptr]
	jmp 	GVE_Move_Object
OBJECT_Dec_TransY:
	shl	eax,GVE_MATH_SHIFT
	mov	ebx,ds:[Object_Ptr]
	sub	ds:[ebx+Object_Position+16],eax
	mov	edx,ds:[Object_Ptr]
	jmp 	GVE_Move_Object
OBJECT_Inc_TransZ:
	shl	eax,GVE_MATH_SHIFT
	mov	ebx,ds:[Object_Ptr]
	add	ds:[ebx+Object_Position+20],eax
	mov	edx,ds:[Object_Ptr]
	jmp 	GVE_Move_Object
OBJECT_Dec_TransZ:
	shl	eax,GVE_MATH_SHIFT
	mov	ebx,ds:[Object_Ptr]
	sub	ds:[ebx+Object_Position+20],eax
	mov	edx,ds:[Object_Ptr]
	jmp 	GVE_Move_Object


;
;
; Texture routines
;
TXT_Retexture:
	mov	eax,ds:[World_Ptr]
	mov	edx,ds:[Object_Ptr]		;Get selected thing
	jmp 	GVE_Texture_Object
TXT_Delete:
	mov	eax,ds:[World_Ptr]
	mov	edx,dword ptr ds:[TNUM+12]	;Get selected thing
	call	GVE_Free_Texture
TXT_Select:
	mov	edx,dword ptr ds:[TNUM+12]	;Save texture-number
	mov	eax,ds:[World_Ptr]
	call	GVE_Get_Texture_Info		;Get info
	mov	dword ptr ds:[TADR+12],eax	;Save texture address
	test	eax,eax
	jz	_EMPTY_TEXTURE
	 mov	eax,ds:[World_Ptr]
	 mov	edx,ds:[Object_Ptr]		;Get object-number
	 mov	ch,GVE_CHANGE_TEXTURE
	 mov	esi,dword ptr ds:[TNUM+12]	;Get texture-number
	 jmp 	GVE_Change_Object
    _EMPTY_TEXTURE:
	retn
TXT_Nothing:
	retn

;
;
; Phong-Map routines
;
PNG_Delete:
	mov	eax,ds:[World_Ptr]
	mov	edx,dword ptr ds:[PNUM+12]	;Get selected thing
	call	GVE_Free_LightMap
PNG_Select:
	mov	edx,dword ptr ds:[PNUM+12]	;Save texture-number
	mov	eax,ds:[World_Ptr]
	call	GVE_Get_LightMap_Info		;Get info
	mov	dword ptr ds:[PADR+12],eax	;Save texture address
	test	eax,eax
	jz	_EMPTY_PHONG
	 mov	eax,ds:[World_Ptr]
	 mov	edx,ds:[Object_Ptr]		;Get object-number
	 mov	ch,GVE_CHANGE_LIGHTMAP
	 mov	bh,byte ptr ds:[PNUM+12]	;Get texture-number
	 jmp 	GVE_Change_Object
    _EMPTY_PHONG:
	retn
PNG_Nothing:
	retn

;
;
; Bump-Map routines
;
BUMP_Delete:
	mov	eax,ds:[World_Ptr]
	mov	edx,dword ptr ds:[BNUM+12]	;Get selected thing
	call	GVE_Free_BumpMap
BUMP_Select:
	mov	edx,dword ptr ds:[BNUM+12]	;Save texture-number
	mov	eax,ds:[World_Ptr]
	call	GVE_Get_BumpMap_Info		;Get info
	mov	dword ptr ds:[BADR+12],eax	;Save texture address
	test	eax,eax
	jz	_EMPTY_BUMP
	 mov	eax,ds:[World_Ptr]
	 mov	edx,ds:[Object_Ptr]		;Get object-number
	 mov	ch,GVE_CHANGE_BUMP
	 mov	cl,b ds:[BNUM+12]		;Get texture-number
	 jmp 	GVE_Change_Object
    _EMPTY_BUMP:
	retn
BUMP_Nothing:
	retn


;
;
; Colour routines
;
COL_Palette:
	mov	eax,OFFSET Win3
	call	GWM_Close_Window
	mov	eax,OFFSET Win10
	call	GWM_Flip_Window
	jmp	GWM_Wait_Mouse
COL_Phong:
	mov	bh,byte ptr ds:[PEXP+12]	;Get phong exponent
	mov	eax,ds:[World_Ptr]
	mov	edx,ds:[Object_Ptr]		;Get object number
	mov	ch,GVE_CHANGE_PHONG
	jmp 	GVE_Change_Object
COL_Colour:
	movzx	ecx,byte ptr ds:[CNUM+12]	;Get colour number
	cmp	dword ptr ds:[CBUT+12],' 552'	;Get first letters
	je	short COL_J2
		shl	cl,4
COL_J2: mov	eax,ds:[World_Ptr]		;ES:EAX points to world-header
	mov	edx,ds:[eax+World_Palette]    	;ES:EDX points to palette
	mov	ebx,ds:[edx+4*ecx]		;EBX = RGB-values
	mov	byte ptr ds:[CRED+12],bl
	mov	byte ptr ds:[CGRN+12],bh
	shr	ebx,8
	mov	byte ptr ds:[CBLU+12],bh	;And save palette values here !
	mov	edx,ds:[Object_Ptr]		;Get object number
	mov	ch,GVE_CHANGE_COLOUR
	jmp 	GVE_Change_Object
COL_Mode:
	cmp	dword ptr ds:[CBUT+12],' 552'	;Get first letters
	jne	short COL_J1
		mov	dword ptr ds:[CBUT+12],'  61'
		mov	byte ptr ds:[CNUM+20],15
		shr	byte ptr ds:[CNUM+12],4
		call	GWM_Wait_Mouse
		jmp	COL_Colour
	COL_J1: mov	dword ptr ds:[CBUT+12],' 552'
		mov	byte ptr ds:[CNUM+20],255
		or	byte ptr ds:[CNUM+12],1
		shl	byte ptr ds:[CNUM+12],4
		call	GWM_Wait_Mouse
		jmp	COL_Colour
COL_Red:
COL_Green:
COL_Blue:
	mov	bh,byte ptr ds:[CBLU+12]	;Get blue component
	shl	ebx,8
	mov	bh,byte ptr ds:[CGRN+12]	;Get green component
	mov	bl,byte ptr ds:[CRED+12]	;Get red component
	movzx	ecx,byte ptr ds:[CNUM+12]	;Get colour number
	cmp	dword ptr ds:[CBUT+12],' 552'	;Get first letters
	je	short COL_J3
		shl	cl,4
COL_J3: mov	ebx,ecx				;EBX = colour number
	mov	eax,ds:[World_Ptr]
	mov	eax,ds:[eax+World_Palette]
	lea	eax,[eax+4*ecx]			;DS:EAX points to palette entry
	mov	ds:[eax],ebx
	mov	ecx,1
	call	SVGA_Set_Palette
	retn


;
;
; Palette routines
;
PAL_SLUT:
	mov	eax,ds:[World_Ptr]
	call 	GVE_Init_Shading_LUT
	mov	eax,ds:[World_Ptr]
	jmp	GVE_Set_Palette
PAL_BLUT:
	mov	eax,ds:[World_Ptr]
	call 	GVE_Init_Bump_LUT
	mov	eax,ds:[World_Ptr]
	jmp	GVE_Set_Palette
PAL_GLUT:
	mov	eax,ds:[World_Ptr]
	call 	GVE_Init_Glass_LUT
	mov	eax,ds:[World_Ptr]
	jmp	GVE_Set_Palette
PAL_SHAD:
	mov	eax,ds:[World_Ptr]
	movzx	ecx,byte ptr ds:[CNUM+12]	;Get colour number
	cmp	dword ptr ds:[CBUT+12],' 552'	;Get first letters
	je	short PAL_J1
		shl	cl,4
PAL_J1:	call	GVE_Init_Shading_PAL
	mov	esi,ds:[World_Ptr]
	mov	ecx,256
	xor	ebx,ebx
	mov	eax,ds:[esi+World_Palette]
	call	SVGA_Set_Palette
	retn
PAL_Darkness:
PAL_Brightness:
PAL_Red:
PAL_Green:
PAL_Blue:
	mov	eax,ds:[World_Ptr]
	mov	edx,ds:[Light_Ptr]
	call	GVE_Get_Light_Info
	mov	al,byte ptr ds:[PDARK+12]
	mov	ah,byte ptr ds:[PBRIT+12]
	mov	bl,byte ptr ds:[LRED+12]
	mov	bh,byte ptr ds:[LGRN+12]
	mov	cl,byte ptr ds:[LBLU+12]
	mov	ds:[edx+Light_ColourRed],bl
	mov	ds:[edx+Light_ColourGreen],bh
	mov	ds:[edx+Light_ColourBlue],cl
	;mov	ds:[edx+Light_Darkness],al
	;mov	ds:[edx+Light_Brightness],ah
	retn
;
;
; Record routines
;
REC_Frame:
	test	ds:[Record_Flags],8
	jz	short @@1
	call	REC_Predict

@@1:	mov	eax,ds:[World_Ptr]
	mov	ecx,d ds:[RFRM+12]
	shl	ecx,GVE_SCRIPT_SHIFT
	test	ds:[Record_Flags],1
	jnz	short @@3
	xor	edx,edx
	call	GVE_Jump_Frame
@@3:	jmp	GWM_Wait_Mouse
REC_Grab:
	mov	eax,ds:[World_Ptr]
	mov	ecx,d ds:[RFRM+12]
	shl	ecx,GVE_SCRIPT_SHIFT
	mov	edx,ds:[Object_Ptr]
	test	ds:[Record_Flags],2
	jz	short @@1
	xor	edx,edx
@@1:	call	GVE_Grab_Frame
	retn
REC_View:
	mov	eax,ds:[World_Ptr]
	mov	ecx,d ds:[RFRM+12]
	shl	ecx,GVE_SCRIPT_SHIFT
	mov	edx,ds:[Object_Ptr]
	test	ds:[Record_Flags],2
	jz	short @@1
	xor	edx,edx
@@1:   	call	GVE_Jump_Frame
	retn
REC_Play:
	mov	eax,OFFSET Win0
	call	GWM_Close_Window
	mov	eax,OFFSET Win2
	call	GWM_Close_Window
	mov	eax,OFFSET Win3
	call	GWM_Close_Window
	mov	eax,OFFSET Win4
	call	GWM_Close_Window
	mov	eax,OFFSET Win5
	call	GWM_Close_Window
	mov	eax,OFFSET Win6
	call	GWM_Close_Window
	mov	eax,OFFSET Win7
	call	GWM_Close_Window
	mov	eax,OFFSET Win8
	call	GWM_Close_Window
	mov	eax,OFFSET Win9
	call	GWM_Close_Window
	mov	eax,OFFSET Win10
	call	GWM_Close_Window
	mov	eax,OFFSET Win11
	call	GWM_Close_Window
	mov	eax,OFFSET Win12
	call	GWM_Close_Window
	mov	eax,OFFSET Win13
	call	GWM_Close_Window
	mov	eax,OFFSET Win14
	call	GWM_Open_Window
	jmp 	GWM_Wait_Mouse
	retn
REC_Predict:
	mov	eax,ds:[World_Ptr]
	mov	ecx,d ds:[RFRM+12]
	shl	ecx,GVE_SCRIPT_SHIFT
	mov	edx,ds:[Object_Ptr]
	test	ds:[Record_Flags],2
	jz	short @@1
	xor	edx,edx
@@1:   	call	GVE_Suggest_Frame
	jmp	REC_View

;
;
;
;   GOMEZ VECTOR ENGINE                                      SUBROUTINES
;
;
;
;
;Load_World:
; Input:
;	EBX	- ptr to filename
;	EDX	- start-offset within file
; Output:
;       ds:[World_Ptr]
; Destroys:
;	EAX,EBX,ECX,EDX,ES
;
Load_World PROC NEAR
	push	ebx
	push	edx
	;
	mov	eax,ds:[World_Ptr]	;First lets free old world
	call	GVE_Free_World
	pop	edx
	pop	ebx
	;
	call	GVE_Load_World
	mov	ds:[World_Ptr],eax
	jc	@@Err
	;
Init_World:
	mov	eax,ds:[World_Ptr]
	call	GVE_Init_World

	mov	eax,ds:[World_Ptr]
	call	GVE_Alloc_Script

	push	esi
	push	edi
	push	ebp
	mov	esi,ds:[World_Ptr]
	mov	esi,ds:[esi+World_Palette]
	call	GWM_Init_Palette
	mov	eax,esi
	xor	ebx,ebx
	mov	ecx,256
	call	SVGA_Set_Palette
	pop     ebp
	pop	edi
	pop	esi

	mov	eax,ds:[World_Ptr]
	lea	eax,[eax+World_Flags]		;EAX = DATA32 ptr to flags
	mov	d ds:[WFL1+8],eax
	mov	d ds:[WFL2+8],eax
	mov	d ds:[WFL3+8],eax
	mov	d ds:[WFL4+8],eax
	mov	d ds:[WFL5+8],eax
	mov	d ds:[WFL6+8],eax
	mov	d ds:[WFL7+8],eax
	;
	;
	;Get objects
Get_Objects:
	push	esi
	push	edi
	push	ebp
	mov	edi,dword ptr ds:[OADR+12]	;EDI = ptr to obj-txt-list
	mov	esi,ds:[World_Ptr]
	mov	edx,ds:[esi+World_Object_List]	;EDX = ptr to obj-list
	mov	ebp,ds:[edx]			;EBP = counter
	mov	ds:[edi],ebp
	xor	eax,eax
	mov	ds:[edi+4],eax
	mov	ds:[edi+8],eax
	test	ebp,ebp
	jz	@@1
	add	edx,4				;Skip header
	add	edi,16
	xor	eax,eax
@@L1:   mov	esi,ds:[edx]			;ESI = ptr to object
	test	esi,esi
	jz	short @@emo
	mov	ecx,16/4
	rep	movsd
	jmp	@@nxo
@@emo:	mov	ecx,16/4
	rep	stosd
@@nxo:	add	edx,4
	dec	ebp
	jnz	short @@L1
@@1:	;
	mov	edi,dword ptr ds:[LADR+12]	;EDI = ptr to light-txt-list
	mov	esi,ds:[World_Ptr]
	mov	edx,ds:[esi+World_Light_List]	;EDX = ptr to light-list
	mov	ebp,ds:[edx]			;EBP = counter
	mov	ds:[edi],ebp
	xor	eax,eax
	mov	ds:[edi+4],eax
	mov	ds:[edi+8],eax
	test	ebp,ebp
	jz	@@2
	add	edx,4				;Skip header
	add	edi,16
	xor	eax,eax
@@L2:   mov	esi,ds:[edx]			;ESI = ptr to light
	test	esi,esi
	jz	short @@eml
	mov	ecx,16/4
	rep	movsd
	jmp	@@nxl
@@eml:	mov	ecx,16/4
	rep	stosd
@@nxl:	add	edx,4
	dec	ebp
	jnz	short @@L2
@@2:	;
	mov	edi,dword ptr ds:[CADR+12]	;EDI = ptr to camera-txt-list
	mov	esi,ds:[World_Ptr]
	mov	edx,ds:[esi+World_Camera_List]	;EDX = ptr to camera-list
	mov	ebp,ds:[edx]			;EBP = counter
	mov	ds:[edi],ebp
	xor	eax,eax
	mov	ds:[edi+4],eax
	mov	ds:[edi+8],eax
	test	ebp,ebp
	jz	@@3
	add	edx,4				;Skip header
	add	edi,16
	xor	eax,eax
@@L3:   mov	esi,ds:[edx]			;ESI = ptr to camera
	test	esi,esi
	jz	short @@emc
	mov	ecx,16/4
	rep	movsd
	jmp	@@nxc
@@emc:	mov	ecx,16/4
	rep	stosd
@@nxc:	add	edx,4
	dec	ebp
	jnz	short @@L3
@@3:	;
	xor	eax,eax
	call	OBJECT_Select
	xor	eax,eax
	call	LIGHT_Select
	xor	eax,eax
	call	CAMERA_Select
	clc
	pop	ebp
	pop	edi
	pop	esi
	retn
	;
@@Err:  stc
	pop	ebp
	pop	edi
	pop	esi
	retn
Load_World ENDP

code32 ends
END
