;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                            
;        Kaya Memisoglu                                                      
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
;
;
;
;   GOMEZ PENTIUM PROFILER                                Opcode-Definitons
;
;
;


RDTSC	MACRO			;Read TIme stamp counter
	db      0fh,31h         ; hex opcode for RDTSC
	ENDM

RDMSR	MACRO			;Read Model specific register ECX into EDX:EAX
	db	0fh,32h		
	ENDM
	
WRMSR	MACRO			;Write Model specific register ECX from EDX:EAX
	db	0fh,30h		
	ENDM

GPP_START_COUNTER MACRO n,ctype
	push	eax
	push	ecx
	push	edx
	mov	ecx,11h		;Read event counter
	RDMSR			;Read in old register
	if (n eq 0)
	 mov	ax,ctype+111000000b			
	else
	 and	eax,0ffffh
	 or	eax,(ctype+111000000b) shl 16
	endif
	WRMSR
	pop	edx
	pop	ecx
	pop	eax
	ENDM
	
GPP_STOP_COUNTER MACRO n

	ENDM

GPP_READ_COUNTER MACRO n
	push	ecx
	mov	ecx,12h+n
	RDMSR
	pop	ecx	
	ENDM
	
GPP_WRITE_COUNTER MACRO n
	push	ecx
	mov	ecx,12h+n
	WRMSR
	pop	ecx
	ENDM
	
GPP_RESET_COUNTER MACRO n
	push	eax
	push	ecx
	push	edx
	xor	eax,eax
	xor	edx,edx
	mov	ecx,12h+n
	WRMSR
	pop	edx
	pop	ecx
	pop	eax
	ENDM

;
GPP_EVENT_DATA_READ			equ	0
GPP_EVENT_DATA_WRITE			equ	1
GPP_EVENT_DATA_TLB_MISS			equ	2
GPP_EVENT_DATA_READ_MISS		equ	3
GPP_EVENT_DATA_WRITE_MISS		equ	4
GPP_EVENT_WRITE_HIT			equ	5
GPP_EVENT_DATA_CACHE_WRITW_BACK		equ	6
GPP_EVENT_DATA_CACHE_SNOOP		equ	7
GPP_EVENT_DATA_CACHE_SNOOP_HIT		equ	8
GPP_EVENT_DUAL_MEMORY_ACCESS		equ	9
GPP_EVENT_BANK_CONFLICT			equ	0Ah
GPP_EVENT_UNALIGNED_DATA		equ	0Bh
GPP_EVENT_CODE_READ			equ	0Ch
GPP_EVENT_CODE_TLB_MISS			equ	0Dh
GPP_EVENT_CODE_CACHE_MISS		equ	0Eh
GPP_EVENT_CODE_READ_MISS		equ	GPP_EVENT_CODE_CACHE_MISS
GPP_EVENT_SEGMENT_LOAD			equ	0Fh
GPP_EVENT_SEGMENT_CACHE_ACCESS		equ	10h
GPP_EVENT_SEGMENT_CACHE_HIT		equ	11h
GPP_EVENT_BRANCHES			equ	12h
GPP_EVENT_BTB_HIT			equ	13h				   	
GPP_EVENT_TAKEN_BRANCH			equ	14h
GPP_EVENT_PIPELINE_FLUSH		equ	15h
GPP_EVENT_INSTRUCTIONS			equ	16h
GPP_EVENT_INSTRUCTIONS_IN_V		equ	17h
GPP_EVENT_BUS_CYCLE			equ	18h
GPP_EVENT_STALL_BY_WRITE_BACKUP		equ	19h
GPP_EVENT_STALL_BY_DATA_READ		equ	1Ah
GPP_EVENT_STALL_BY_DATA_WRITE		equ	1Bh
GPP_EVENT_LOCKED_BUS_CYCLE		equ	1Ch
GPP_EVENT_IO_CYCLE			equ	1Dh
GPP_EVENT_NONCACHE_DATA			equ	1Eh
GPP_EVENT_AGI				equ	1Fh
GPP_EVENT_DATA_ACCESS			equ	28h
GPP_EVENT_DATA_ACCESS_MISS		equ	29h
