;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
;
P486
LOCALS
JUMPS
GVE_SYSTEM_FILE		equ	1



;
;
;
;   GOMEZ VECTOR ENGINE                                            v2.0
;
;
;
code32  segment para public use32
	assume cs:code32, ds:code32
	largestack


include gve32.inc
include gomez.inc
include gvelist.inc

extrn GVE_IO_Buffer:BYTE


;
;   GOMEZ VECTOR ENGINE                                   ATTRIBUTE-TABLE
;
PUBLIC C GVE_Shading_List
ALIGN DWORD
GVE_Shading_List LABEL DWORD
	dd	0					;VOBJ_NOTHING
	dd	VST_WIRE                		;VOBJ_WIRE_POLY
	dd	VST_FILLED				;VOBJ_FILLED_POLY
	dd	VST_LAMBERT+VST_FILLED          	;VOBJ_LAMBERT_POLY
	dd	VST_GOURAUD+VST_FILLED			;VOBJ_GOURAUD_POLY
	dd	VST_PHONG+VST_FILLED			;VOBJ_PHONG_POLY
	dd	VST_GLASS+VST_FILLED			;VOBJ_GLASS_POLY
	dd	VST_GLASS+VST_FILLED+VST_LAMBERT	;VOBJ_LAMBERT_GLASS
	dd	VST_GLASS+VST_FILLED+VST_GOURAUD	;VOBJ_GOURAUD_GLASS
	dd	VST_GLASS+VST_FILLED+VST_PHONG		;VOBJ_PHONG_GLASS
	dd	VST_TEXTURE				;VOBJ_FAST_TEXTURE
	dd	VST_TEXTURE+VST_LAMBERT			;VOBJ_LAMBERT_TEXTURE
	dd	VST_TEXTURE+VST_GOURAUD			;VOBJ_GOURAUD_TEXTURE
	dd	VST_TEXTURE+VST_PHONG			;VOBJ_PHONG_TEXTURE
	dd	VST_CHROME+VST_TEXTURE			;VOBJ_PLASMA_CHROME
	dd	VST_CHROME				;VOBJ_CHROME_POLY
	dd	VST_CHROME+VST_LAMBERT			;VOBJ_LAMBERT_CHROME
	dd	VST_CHROME+VST_GOURAUD			;VOBJ_GOURAUD_CHROME
	dd	VST_CHROME+VST_PHONG			;VOBJ_PHONG_CHROME
	dd	VST_FILLED+VST_PHONG			;VOBJ_FAST_PHONG
	dd	VST_TEXTURE+VST_GLASS			;VOBJ_GLASS_TEXTURE
	dd	VST_CHROME+VST_GLASS			;VOBJ_GLASS_CHROME
	dd	VST_BUMP				;VOBJ_BUMP_POLY
	dd	VST_BUMP+VST_LAMBERT			;VOBJ_LAMBERT_BUMP
	dd	VST_BUMP+VST_GOURAUD			;VOBJ_GOURAUD_BUMP
	dd	VST_BUMP+VST_PHONG			;VOBJ_PHONG_BUMP
	dd	VST_BUMP+VST_GLASS			;VOBJ_GLASS_BUMP
	dd	VST_WIRE				;VOBJ_SOFT_WIRE
	dd	VST_WIRE+VST_GLASS			;VOBJ_GLASS_WIRE
	dd	VST_TEXTURE+VST_LIGHTMAP		;VOBJ_LIGHTMAP_TEXTURE
	dd	VST_TEXTURE+VST_CHROME			;VOBJ_CHROME_TEXTURE
	dd	VST_BUMP+VST_LIGHTMAP			;VOBJ_LIGHTMAP_BUMP
	dd	VST_POINT				;VOBJ_POINT
	dd	VST_FILLED				;VOBJ_CARVA_POLY
	dd	VST_FILLED+VST_LAMBERT			;VOBJ_LAMBERT_CARVA
	dd	VST_FILLED+VST_GOURAUD			;VOBJ_GOURAUD_CARVA
	dd	VST_FILLED+VST_PHONG			;VOBJ_PHONG_CARVA
	dd	VST_FILLED+VST_GLASS			;VOBJ_GLASS_CARVA
	dd	VST_TEXTURE				;VOBJ_PTEXTURE
	dd	VST_TEXTURE+VST_LAMBERT			;VOBJ_LAMBERT_PTEXTURE
	dd	VST_TEXTURE+VST_GOURAUD			;VOBJ_GOURAUD_PTEXTURE
	dd	VST_TEXTURE+VST_PHONG			;VOBJ_PHONG_PTEXTURE
	dd	VST_TEXTURE+VST_LIGHTMAP		;VOBJ_LIGHTMAP_PTEXTURE
	dd	VST_TEXTURE+VST_CHROME			;VOBJ_CHROME_PTEXTURE
	dd	VST_TEXTURE+VST_GLASS			;VOBJ_GLASS_PTEXTURE
	dd	VST_TEXTURE+VST_BUMP+VST_LIGHTMAP	;VOBJ_BUMP_TEXTURE



;
;
;
;   GOMEZ VECTOR ENGINE                            WORLD EDITING FUNCTIONS
;
;
;
;
;
; GVE_Init_Bounding_Box
;  Input:
; 	EAX 	- DATA32 ptr to world-header
;	EDX	- DATA32 ptr to object header
;  Output:
; 	[CF]	- error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Init_Bounding_Box
GVE_Init_Bounding_Box PROC NEAR
	push	ds
	push	esi
	push	edi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	eax,ds:[eax+World_Object_List]
	call	Find_List_Entry
	jc	@@End
	mov	edx,ds:[edx]			;EDX = ptr to object-header
	;
	mov	esi,ds:[edx+Object_Vertex_List] ;ESI = DATA32 ptr to vertex list
	test	esi,esi
	jz	@@Succ
	mov	ebp,edx				;EBP = DATA32 ptr to object
	mov	edi,ds:[esi]			;EDI = Number of vertices
	add	esi,4
	test	edi,edi
	jz	@@Succ
	;
	mov	ds:[@@minX],7fffffffh
	mov	ds:[@@minY],7fffffffh
	mov	ds:[@@minZ],7fffffffh
	mov	ds:[@@maxX],-7fffffffh
	mov	ds:[@@maxY],-7fffffffh
	mov	ds:[@@maxZ],-7fffffffh
	;
	@@L1:	mov	eax,ds:[esi+VertexX]
		cmp	ds:[@@minX],eax
		jle	short @@1
		mov	ds:[@@minX],eax
	@@1:	cmp	ds:[@@maxX],eax
		jge	short @@2
		mov	ds:[@@maxX],eax

	@@2:	mov	eax,ds:[esi+VertexY]
		cmp	ds:[@@minY],eax
		jle	short @@3
		mov	ds:[@@minY],eax
	@@3:	cmp	ds:[@@maxY],eax
		jge	short @@4
		mov	ds:[@@maxY],eax

	@@4:	mov	eax,ds:[esi+VertexZ]
		cmp	ds:[@@minZ],eax
		jle	short @@5
		mov	ds:[@@minZ],eax
	@@5:	cmp	ds:[@@maxZ],eax
		jge	short @@6
		mov	ds:[@@maxZ],eax

	@@6:	add	esi,GVE_VERTEX_SIZE
		dec	edi
		jnz	short @@L1
	;
	mov	eax,ds:[@@minX]
	mov	ebx,ds:[@@maxX]
	mov	ds:[ebp+Object_Bound_MinX],eax
	mov	ds:[ebp+Object_Bound_MaxX],ebx
	mov	eax,ds:[@@minY]
	mov	ebx,ds:[@@maxY]
	mov	ds:[ebp+Object_Bound_MinY],eax
	mov	ds:[ebp+Object_Bound_MaxY],ebx
	mov	eax,ds:[@@minZ]
	mov	ebx,ds:[@@maxZ]
	mov	ds:[ebp+Object_Bound_MinZ],eax
	mov	ds:[ebp+Object_Bound_MaxZ],ebx
	;
@@Succ:	clc
@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	ds
	retn
	;
	ALIGN 4
	@@minX	dd	?
	@@minY	dd	?
	@@minZ	dd	?
	@@maxX	dd	?
	@@maxY	dd	?
	@@maxZ	dd	?
GVE_Init_Bounding_Box ENDP



;
;
; GVE_Init_Normals
;  Input:
; 	EAX 	- DATA32 ptr to world-header
;	EDX	- DATA32 ptr to object header
;  Output:
; 	[CF]	- error flag
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Init_Normals
GVE_Init_Normals PROC NEAR
	push	ds
	push	esi
	push	edi
	push	ebp

	cld
	mov	ds,cs:[DATA32_Selector]
	mov	eax,ds:[eax+World_Object_List]
	call	Find_List_Entry
	jc	@@End
	mov	edi,ds:[edx]			;EDI = ptr to object-header
	mov	esi,ds:[edi+Object_Face_List]	;ESI = ptr to face-list
	mov	ebp,ds:[edi+Object_Vertex_List]	;EBP = ptr to vertex-list
	;
	lea	ebx,[ebp+4]			;EBX = ptr to first vertex
	mov	ecx,ds:[ebp]			;ECX = number of vertices

	xor	eax,eax				;Use EAX for clearing
@@L3:	mov	ds:[ebx+Vertex_NormalX],eax
	mov	ds:[ebx+Vertex_NormalY],eax
	mov	ds:[ebx+Vertex_NormalZ],eax
	add	ebx,GVE_VERTEX_SIZE
	dec	ecx
	jnz	short @@L3
	;
	push	ebp				;Save vertex-list ptr
	mov	ebp,ds:[esi]			;EBP = Number of primitives
	add	esi,4				;Skip counter
@@L5:   movzx 	ecx,byte ptr ds:[esi+3]		;Get number of vectors
	cmp	ecx,3     			;If fewer than 3 vertices, no normal
	jb	@@Next				;   can be calculated !
	;
	push	ecx
	push	ebp
	mov 	ebx,ds:[esi+Triangle_Vertex1] 	;Get vector address of vector 1
	mov	ecx,ds:[esi+Triangle_Vertex2]	;Get vector address #2
	mov	ebp,ds:[esi+Triangle_Vertex3]	;Get vector address #3
	;
	;
	;First we have to get the differences between the vectors:
	;The differences will be saved in vectors #1 and #2 !
	;This is difference #1-#2
	mov	eax,ds:[ebx+VertexX]
	sub	eax,ds:[ecx+VertexX]
	mov	ds:[ebx+Vertex@X],eax		;Save new X1
	mov	eax,ds:[ebx+VertexY]
	sub	eax,ds:[ecx+VertexY]
	mov	ds:[ebx+Vertex@Y],eax		;Save new Y1
	mov	eax,ds:[ebx+VertexZ]
	sub	eax,ds:[ecx+VertexZ]
	mov	ds:[ebx+Vertex@Z],eax		;Save new Z1

	;This is difference #3-#2
	mov	eax,ds:[ebp+VertexX]
	sub	eax,ds:[ecx+VertexX]
	mov	ds:[ecx+Vertex@X],eax		;Save new X2
	mov	eax,ds:[ebp+VertexY]
	sub	eax,ds:[ecx+VertexY]
	mov	ds:[ecx+Vertex@Y],eax		;Save new Y2
	mov	eax,ds:[ebp+VertexZ]
	sub	eax,ds:[ecx+VertexZ]
	mov	ds:[ecx+Vertex@Z],eax		;Save new Z2

	;
	;
	;Now lets calculate the normal vector via cross-product
	;                     
	;       a2*b3 - a3*b2 
	; AxB:= a3*b1 - a1*b3 
	;       a1*b2 - a2*b1 
	;                     
	fwait
	fild	dword ptr ds:[ebx+Vertex@Z]	;ST(0) = a3
	fimul	dword ptr ds:[ecx+Vertex@Y]	;ST(0) = a3*b2
	fild	dword ptr ds:[ebx+Vertex@Y]	;ST(0) = a2     ST(1) = a3*b2
	fimul	dword ptr ds:[ecx+Vertex@Z]	;ST(0) = a2*b3  ST(1) = a3*b2
	fsub	st(0),st(1)			;ST(0) = a2*b3 - a3*b2
	ffree	st(1)

	fild	dword ptr ds:[ebx+Vertex@X]
	fimul	dword ptr ds:[ecx+Vertex@Z]	;ST(0) = a1*b3
	fild	dword ptr ds:[ebx+Vertex@Z]
	fimul	dword ptr ds:[ecx+Vertex@X]	;ST(0) = a3*b1  ST(1) = a1*b3
	fsub	st(0),st(1)			;ST(0) = a3*b1 - a1*b3
	fstp	st(1)				;  ST(0) = Normal_Y
						;  ST(1) = Normal_X
	fild	dword ptr ds:[ebx+Vertex@Y]
	fimul	dword ptr ds:[ecx+Vertex@X]	;ST(0) = a2*b1
	fild	dword ptr ds:[ebx+Vertex@X]
	fimul	dword ptr ds:[ecx+Vertex@Y]	;ST(0) = a1*b2  ST(1) = a2*b1
	fsub	st(0),st(1)			;ST(0) = a1*b2 - a2*b1
	fstp	st(1)                   	;  ST(0) = Normal_Z
						;  ST(1) = Normal_Y
						;  ST(2) = Normal_X
	;
	fld	st(2)
	fmul	st(0),st(0)			;ST(0) = Normal_X
	fld	st(2)
	fmul	st(0),st(0)			;ST(0) = Normal_Y
	fadd	st(0),st(1)			;ST(0) = Normal_X + Normal_Y
	fstp	st(1)
	fld	st(1)
	fmul	st(0),st(0)			;ST(0) = Normal_Z
	fadd	st(0),st(1)			;ST(0) = Normal_X + Normal_Y +Normal_Z
	fstp	st(1)
	;
	;
	;Now the floating point stack looks like this:
	;	ST(0) =  Normal 
	;	ST(1) = Normal_Z
	;	ST(2) = Normal_Y
	;	ST(3) = Normal_X
	;
	fsqrt					;ST(0) = SQRT (ST(0))
	fdiv	st(1),st
	fdiv	st(2),st
	fdiv	st(3),st
	fstp	st(0)				;Throw away root

	fild	ds:[@@shiftsize]		;ST(0) = GVE_MATH_SHIFT
	fld	st(3)				;ST(0) = Normal_X
	fscale
	fistp   ds:[esi+Triangle_NormalX]	;Save normalized Normal_X
	fwait
	fld	st(2)				;ST(0) = Normal_Y
	fscale
	fistp   ds:[esi+Triangle_NormalY]	;Save normalized Normal_Y
	fwait
	fld	st(1)				;ST(0) = Normal_Z
	fscale
	fistp   ds:[esi+Triangle_NormalZ]	;Save normalized Normal_Z
	fwait
	ffree	st(0)
	ffree	st(1)
	ffree	st(2)
	ffree	st(3)
	;
	;
	;Now lets build the plane-equation for this polygon.
	;Remember that the equation
	;
	;  	Ax + By + Cz + D = 0
	;
	;must be true for all points that lie within the plane.
	;A,B and C are simply the surface normal-values. D has to
	;be evaluated by plugging in a vertex.
	mov	edi,ds:[esi+Triangle_Vertex1]	;EDI = ptr to vertex
	mov	eax,ds:[esi+Triangle_NormalX]	;EAX = A
	imul	d ds:[edi+VertexX]		;EDX:EAX = Vertex-X * A
	mov	ebx,eax
	mov	ebp,edx				;EBP:EBX = A*x
	mov	eax,ds:[esi+Triangle_NormalY]	;EAX = B
	imul	ds:[edi+VertexY]		;EDX:EAX = Vertex_Y * B
	add	ebx,eax
	adc	ebp,edx				;EBP:EBX = A*x + B*y
	mov	eax,ds:[esi+Triangle_NormalZ]	;EAX = C
	imul	ds:[edi+VertexZ]		;EDX:EAX = Vertex_Z * C
	add	eax,ebx
	adc	edx,ebp				;EDX:EAX = A*x + B*y + C*z
	shrd	eax,edx,GVE_NORMAL_SHIFT
	neg	eax				;EAX = D
	mov	ds:[esi+Triangle_Plane],eax	;Save D in polygon

	mov	eax,ds:[esi+Triangle_NormalX]
	mov	ebx,ds:[esi+Triangle_NormalY]
	mov	edx,ds:[esi+Triangle_NormalZ]	;Get back surface-normal
	pop	ebp				;Restore primitive counter
	pop	ecx				;Restore vertex counter
	;
	;
	;Now lets save our great result in all vertices !
	@@L4:	mov	edi,ds:[esi+20+4*ecx]	;EDI = vertex
		add	ds:[edi+Vertex_NormalX],eax
		add	ds:[edi+Vertex_NormalY],ebx
		add	ds:[edi+Vertex_NormalZ],edx
		dec 	ecx
		jnz	short @@L4
	;
@@Next:	movzx	eax,word ptr ds:[esi]	;Get size
	add	esi,eax			;Skip to next primitive
	dec	ebp
	jnz	@@L5
	;
	pop	ebp			;EBP = ptr to vertex-list
	mov	ecx,ds:[ebp]		;ECX = number of vertices
	add	ebp,4
@@L6:           fild	ds:[ebp+Vertex_NormalX]	;ST(4) = Normal_X
		fild	ds:[ebp+Vertex_NormalY]	;ST(3) = Normal_Y
		fild	ds:[ebp+Vertex_NormalZ]	;ST(2) = Normal_Z
		fldz                            ;ST(1) = 0
		fld	st(3)                   ;ST(0) = Normal_X
		fmul	st(0),st(0)
		fadd	st(1),st(0)		;ST(1) = Normal_X
		fstp	st(0)
		fld	st(2)
		fmul	st(0),st(0)
		fadd	st(1),st(0)		;ST(1) = Normal_X + Normal_Y
		fstp	st(0)
		fld	st(1)
		fmul	st(0),st(0)
		fadd	st(1),st(0)		;ST(1) = Normal_X + Normal_Y + Normal_Z
		fstp	st(0)                   ;ST(0) = ST(1)
		fsqrt
		fdiv	st(1),st(0)
		fdiv	st(2),st(0)
		fdiv	st(3),st(0)
		fstp	st(0)			;Throw away root

		fild	ds:[@@shiftsize]	;ST(0) = GVE_MATH_SHIFT
		fld	st(3)			;ST(0) = Normal_X
		fscale
		fistp   ds:[ebp+Vertex_NormalX]
		fld	st(2)			;ST(0) = Normal_Y
		fscale
		fistp   ds:[ebp+Vertex_NormalY]
		fld	st(1)			;ST(0) = Normal_Z
		fscale
		fistp   ds:[ebp+Vertex_NormalZ]
		ffree	st(0)
		ffree	st(1)
		ffree	st(2)
		ffree	st(3)

		add 	ebp,GVE_VERTEX_SIZE
		dec 	ecx
		jnz 	@@L6
	;
@@End:	clc
	pop	ebp
	pop	edi
	pop	esi
	pop	ds
	retn

	@@shiftsize	dd	GVE_MATH_SHIFT
GVE_Init_Normals ENDP


;
;
; GVE_Alloc_Light
;  Input:
;	EAX	- DATA32 ptr to world-header
;  Output:
;	EAX	- DATA32 ptr to light-header
;	[CF]	- Error-Flag
;
PUBLIC C GVE_Alloc_Light
GVE_Alloc_Light PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	cld
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	mov	ebp,eax				;EBP = ptr to world-header
	mov	eax,ds:[ebp+World_Light_List]	;EAX = ptr to light-list
	call	New_List_Entry
	jc 	@@Err
	mov	ds:[ebp+World_Light_List],eax	;Save new list
	;
	push	edx				;EDX = DATA32 ptr to new entry
	mov	ecx,GVE_LIGHT_SIZE
	call	Malloc                  	;EAX = allocated light-hdr
	pop	edx
	jc	@@Err
	mov	ds:[edx],eax			;Save hdr-address
	;
	push	eax
	mov	edi,eax
	mov	ecx,GVE_LIGHT_SIZE/4
	xor	eax,eax
	rep	stosd				;Clear object !
	pop	eax				;EAX = ptr to light header
	mov	d ds:[eax+Light_Colour],0ffffffh
	mov	d ds:[eax+Light_Type],GVE_TYP_POINTLIGHT
	mov	d ds:[eax+Light_Magic],eax
	mov	esi,OFFSET @@txt
	mov	edi,eax
	movsd
	movsd
	clc
@@Err:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn

@@txt	db	"unnamed",0
GVE_Alloc_Light ENDP



;
;
; GVE_Free_Light
;  Input:
;	EAX	- DATA32 ptr to world-header
;      EDX	- DATA32 ptr to light-header
;  Output:
;	[CF]	- Error-Flag
;
PUBLIC C GVE_Free_Light
GVE_Free_Light PROC NEAR
	push	ds
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	ebp,eax				;EBP = World-Header
	mov	eax,ds:[eax+World_Light_List]	;EAX = light-list
	call	Find_List_Entry
	jc	short @@End
	;
	mov	ecx,ds:[edx]			;ECX = DATA32 ptr to light-header
	mov	d ds:[edx],0
	call	Free

	mov	eax,ds:[ebp+World_Light_List]	;EAX = DATA32 ptr to light-list
	call	Shrink_List			;Tidy up light list !
	mov	ds:[ebp+World_Light_List],eax
	clc
	;
@@End:	pop	ebp
	pop	ds
	retn
GVE_Free_Light ENDP



;
;
; GVE_Get_Light_Info
;  Input:
;	EAX	- DATA32 ptr to world-header
;     	EDX	- DATA32 ptr to light-header
;  Output:
;	[CF]	- error flag
; 	EAX	- Light colour
;	EDX	- Ptr to light-text
;
PUBLIC C GVE_Get_Light_Info
GVE_Get_Light_Info PROC NEAR
	push	ds

	mov	ds,cs:[DATA32_Selector]
	mov	eax,ds:[eax+World_Light_List]
	call	Find_List_Entry
	jc	@@Err
	;
	mov	edx,ds:[edx]			;EDX = ptr to light-header
	mov	eax,ds:[edx+Light_Colour]
	clc
	pop	ds
	retn
	;
@@Err:  xor	eax,eax
	xor	ebx,ebx
	xor	ecx,ecx
	xor	edx,edx
	pop	ds
	stc
	retn
GVE_Get_Light_Info ENDP



;
;
; GVE_Alloc_Camera
;  Input:
;	EAX	- DATA32 ptr to world-header
;  Output:
;	EAX	- DATA32 ptr to camera-header
;	CF	- Error-Flag
;
PUBLIC C GVE_Alloc_Camera
GVE_Alloc_Camera PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	cld
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	mov	ebp,eax				;EBP = ptr to world-header
	mov	eax,ds:[ebp+World_Camera_List]
	call	New_List_Entry
	jc 	@@Err
	mov	ds:[ebp+World_Camera_List],eax	;Save new list
	;
	push	edx				;EDX = DATA32 ptr to new entry
	mov	ecx,GVE_CAMERA_SIZE
	call	Malloc                  	;EAX = allocated camera-hdr
	pop	edx
	jc	@@Err
	mov	ds:[edx],eax			;Save hdr-address
	;
	push	eax
	mov	edi,eax
	mov	ecx,GVE_CAMERA_SIZE/4
	xor	eax,eax
	rep	stosd				;Clear object !
	pop	eax				;EAX = ptr to camera header
	mov	ds:[eax+Camera_Distance],1 shl GVE_DISTANCE
	mov	ds:[eax+Camera_PositionZ],-100 shl GVE_MATH_SHIFT
	mov	ds:[eax+Camera_Type],GVE_TYP_CAMERA
	mov	ds:[eax+Camera_Magic],eax
	mov	esi,OFFSET @@txt
	mov	edi,eax
	movsd
	movsd
	clc
@@Err:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn

@@txt	db	"unnamed",0
GVE_Alloc_Camera ENDP



;
;
; GVE_Free_Camera
;  Input:
;	EAX	- DATA32 ptr to world-header
;      EDX	- DATA32 ptr to camera-header
;  Output:
;	CF	- Error-Flag
;
PUBLIC C GVE_Free_Camera
GVE_Free_Camera PROC NEAR
	push	ds
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	ebp,eax				;EBP = World-Header
	mov	eax,ds:[eax+World_Camera_List]	;EAX = camera-list
	call	Find_List_Entry
	jc	short @@End
	;
	mov	ecx,ds:[edx]			;ECX = DATA32 ptr to camera-header
	mov	d ds:[edx],0
	call	Free

	mov	eax,ds:[ebp+World_Camera_List]	;EAX = DATA32 ptr to camera-list
	call	Shrink_List			;Tidy up camera list !
	mov	ds:[ebp+World_Camera_List],eax
	clc
	;
@@End:	pop	ebp
	pop	ds
	retn
GVE_Free_Camera ENDP



;
;
; GVE_Get_Camera_Info
;  Input:
;	EAX	- DATA32 ptr to world-header
;     	EDX	- DATA32 ptr to camera-header
;  Output:
;	CF	- error flag
;	EDX	- Ptr to camera-text
;
PUBLIC C GVE_Get_Camera_Info
GVE_Get_Camera_Info PROC NEAR
	push	ds

	mov	ds,cs:[DATA32_Selector]
	mov	eax,ds:[eax+World_Camera_List]
	call	Find_List_Entry
	jc	@@Err
	;
	mov	edx,ds:[edx]			;EDX = ptr to camera-header
	clc
	pop	ds
	retn
	;
@@Err:  xor	eax,eax
	xor	ebx,ebx
	xor	ecx,ecx
	xor	edx,edx
	pop	ds
	stc
	retn
GVE_Get_Camera_Info ENDP




;
;
; GVE_Get_Object_Info
;  Input:
;	EAX	- DATA32 ptr to world-header
;     	EDX	- DATA32 ptr to object-header
;  Output:
;	CF	- error flag
; 	AL	- Shading-Method
;	AH	- Phong-Exponent
;	BL 	- Surface-colour
;	BH	- Bump-Map
;	ECX	- Surface texture
;	EDX	- Object-Flags
;
PUBLIC C GVE_Get_Object_Info
GVE_Get_Object_Info PROC NEAR
	push	ds
	push	esi
	push	edi

	mov	ds,cs:[DATA32_Selector]
	mov	eax,ds:[eax+World_Object_List]
	call	Find_List_Entry
	jc	short @@Err
	mov	edi,ds:[edx]		;EDI = ptr to object-header
	mov	esi,ds:[edi+Object_Face_List]
	test	esi,esi
	jz	short @@Err
	;
	add	esi,4
	mov	al,ds:[esi+Triangle_Type]
	mov	ah,ds:[esi+Triangle_Phong]
	mov     bl,ds:[esi+Triangle_Colour]
	mov	bh,ds:[esi+Triangle_Bump]
	mov	cx,ds:[esi+Triangle_Texture]
	and	ecx,3fffh
	mov	edx,ds:[edi+Object_Flags]
	clc
	pop	edi
	pop	esi
	pop	ds
	retn
	;
@@Err:  xor	eax,eax
	xor	ebx,ebx
	xor	ecx,ecx
	xor	edx,edx
	pop	edi
	pop	esi
	pop	ds
	stc
	retn
GVE_Get_Object_Info ENDP




;
;
; GVE_Change_Object
;  Input:
;	EAX	- DATA32 ptr to world-header
;      EDX	- DATA32 ptr to object-header
;	BL	- Shading-Method
;	BH	- Phong-Exponent
;	CL	- Colour / Bump
;	CH	- Change-flags:
;		bit 0 - Change shading method
;		bit 1 - Change phong exponent
;		bit 2 - Change surface colour
;		bit 3 - Change surface texture
;		bit 4 - Change lightmap
;		bit 5 - Change bumpmap
;	ESI	- Surface texture
;  Output:
;	CF	- Error-Flag
;
PUBLIC C GVE_Change_Object
GVE_Change_Object PROC NEAR
	push	ds
	push	esi
	push	edi

	mov	ds,cs:[DATA32_Selector]
	push	ebx
	push	ecx
	mov	eax,ds:[eax+World_Object_List]
	call	Find_List_Entry
	pop	ecx
	pop	ebx
	jc	@@Err
	mov	edi,ds:[edx]		;EDI = ptr to object-header
	mov	edi,ds:[edi+Object_Face_List]
	test	edi,edi
	jz	@@End
	;
	mov	edx,ds:[edi]		;EDX = Number of primitves
	add	edi,4			;Skip header
	@@L1:	test	ch,GVE_CHANGE_SHADING
		jz	short @@J1
		mov	ds:[edi+Triangle_Type],bl
	@@J1:	test	ch,GVE_CHANGE_PHONG or GVE_CHANGE_LIGHTMAP
		jz	short @@J2
		mov	ds:[edi+Triangle_Phong],bh
	@@J2:	test	ch,GVE_CHANGE_COLOUR
		jz	short @@J3
		mov     ds:[edi+Triangle_Colour],cl
	@@J3:	test	ch,GVE_CHANGE_BUMP
		jz	short @@J4
		mov     ds:[edi+Triangle_Bump],cl
	@@J4:	test	ch,GVE_CHANGE_TEXTURE
		jz	short @@J5
		and	ds:[edi+Triangle_Texture],NOT 3fffh
		or     	ds:[edi+Triangle_Texture],si
	@@J5:

		movzx	ebp,word ptr ds:[edi]
		add	edi,ebp
		dec	edx
		jnz	short @@L1
	;
@@End:	clc
@@Err:	pop	edi
	pop	esi
	pop	ds
	retn
GVE_Change_Object ENDP



;
;
; GVE_Alloc_Object
;  Input:
;	EAX	- DATA32 ptr to world-header
;  Output:
;	EAX	- DATA32 ptr to object-header
;	CF	- Error-Flag
;
PUBLIC C GVE_Alloc_Object
GVE_Alloc_Object PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	cld
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	mov	ebp,eax			;EBP = ptr to world-header
	mov	eax,ds:[ebp+World_Object_List]	;EAX = ptr to object-list
	call	New_List_Entry
	jc 	@@Err
	mov	ds:[ebp+World_Object_List],eax	;Save new list
	;
	push	edx				;EDX = DATA32 ptr to new entry
	mov	ecx,GVE_OBJECT_SIZE
	call	Malloc                  	;EAX = allocated object-hdr
	pop	edx
	jc	@@Err
	mov	ds:[edx],eax			;Save hdr-address
	;
	push	eax
	mov	edi,eax
	mov	ecx,GVE_OBJECT_SIZE/4
	xor	eax,eax
	rep	stosd				;Clear object !
	pop	eax				;EAX = ptr to object header
	mov	ds:[eax+Object_Type],GVE_TYP_OBJECT
	mov	ds:[eax+Object_Magic],eax
	mov	esi,OFFSET @@txt
	mov	edi,eax
	movsd
	movsd
	clc
@@Err:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn

@@txt	db	"unnamed",0
GVE_Alloc_Object ENDP



;
;
; GVE_Free_Object
;  Input:
;	EAX	- DATA32 ptr to world-header
;      EDX	- DATA32 ptr to object-header
;  Output:
;	CF	- Error-Flag
;
PUBLIC C GVE_Free_Object
GVE_Free_Object PROC NEAR
	push	ds
	push	esi
	push	edi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	ebp,eax			;EBP = World-Header
	mov	eax,ds:[eax+World_Object_List]
	call	Find_List_Entry
	jc	short @@End
	;
	mov	esi,ds:[edx]		;ESI = DATA32 ptr to object-header
	mov	d ds:[edx],0

	mov	ecx,ds:[esi+Object_Vertex_List]
	call	Free
	mov	ecx,ds:[esi+Object_Face_List]
	call	Free
	mov	ecx,esi			;ECX = ptr to object-hdr
	call	Free

	mov	eax,ds:[ebp+World_Object_List]
	call	Shrink_List		;Tidy up object list !
	mov	ds:[ebp+World_Object_List],eax
	clc
	;
@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	ds
	retn
GVE_Free_Object ENDP



;
;
; GVE_Make_Triangles
;  Input:
;	EAX	- DATA32 ptr to world-header
;      EDX	- DATA32 ptr to object-header
;  Output:
;	EAX	- DATA32 ptr to new face list
;	CF	- Error-Flag
;
PUBLIC C GVE_Make_Triangles
GVE_Make_Triangles PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	cld
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	mov	eax,ds:[eax+World_Object_List]	
	call	Find_List_Entry
	jc	@@End
	mov	ebp,ds:[edx]		;EBP = ptr to object-header
	mov	edi,ds:[ebp+Object_Face_List]
	;
	;
	; First get surface type and calcultae size of one triagle
	;
	mov	ebx,3*4+24		;EBX = Size of one triangle
	movzx	eax,byte ptr ds:[edi+6]	;EAX = shading method
	ifndef	GVE_VERTEX_TEXTURE_UV
	 test	ds:[GVE_Shading_List+eax],VST_BUMP+VST_TEXTURE
	 jz	short @@J1
	 add	ebx,3*4			;Make room for texture-coordinates
	endif
@@J1:	mov	ds:[@@trisize],ebx


	;
	;
	; First lets get the size of the new primitive list
	;
	; Result:
	;	EBX	- 	size of new list (in bytes)
	;	ESI	-	number of triangles
	;	EDI	-	???
	;	EBP	- 	ptr to object-header
	;
	push	edi			;Save source-list
	mov	ecx,ds:[edi]		;ECX = Number of primitves
	add	edi,4			;Skip header
	mov	ebx,4			;EBX = size for new primitive list
	xor	esi,esi			;ESI = number of new primitives
@@L1:	movzx	edx,word ptr ds:[edi]	;EDX = size of this primitive
	movzx	eax,byte ptr ds:[edi+3]	;EAX = number of vertices
	cmp	al,3			;Are there at least 3 vertices ???
	jb	short @@No
	sub	eax,2			;EAX = number of new primitives
	add	esi,eax			;ESI += number of triangles
	imul	eax,ds:[@@trisize]	;EAX *= size of one triangle
	add	ebx,eax			;EBX += size of new triangles
@@No:	add	edi,edx                 ;EDI = ptr to next primitive
	dec	ecx
	jnz	short @@L1              ;Loop !

	;
	;
	; Now lets allocate the new list
	;
	mov	ecx,ebx			;ECX = size of new list
	call	Malloc
	mov	edi,eax			;EDI = ptr to new list
	mov	ds:[edi],esi		;ESI = Number of new primitives
	pop	esi			;ESI = ptr to old list
	jc	@@End			;Carry => Allocation error !
	push	edi			;Save ptr to new list
	push	esi			;Save ptr to old list
	mov	ds:[ebp+Object_Face_List],edi

	;
	;
	; Rebuilding of new primitive list
	;
	mov	eax,ds:[esi]		;EAX = Number of primitves
	add	esi,4			;ESI = source ptr
	add	edi,4			;EDI = dst pointer
@@L2:   push	eax			;Save primitive counter
	movzx	ebp,word ptr ds:[esi]	;EBP = size of this primitive
	movzx	ecx,byte ptr ds:[esi+3]
	cmp	cl,3			;ECX = Number of vertices
	jb	@@Skp			;ECX < 3 ==> Copy primitive !
	sub	ecx,2			;ECX = number of triangles
	mov	eax,ds:[esi]    	;Get 1st dword of header
	and	eax,0ff0000h
	or	eax,03000000h		;3 vertices / 36bytes size
	or	eax,ds:[@@trisize]
	@@L3:	mov	ds:[edi],eax
		mov	ebx,ds:[esi+4]	;Get 2nd dword of header
		mov	ds:[edi+4],ebx
		mov	ebx,ds:[esi+8]	;Get normal stuff
		mov	ds:[edi+8],ebx
		mov	ebx,ds:[esi+12]
		mov	ds:[edi+12],ebx
		mov	ebx,ds:[esi+16]
		mov	ds:[edi+16],ebx
		mov	ebx,ds:[esi+20]
		mov	ds:[edi+20],ebx

		mov	edx,ds:[esi+24]
		mov	ds:[edi+24],edx
		mov	edx,ds:[esi+4*ecx+24]
		mov	ds:[edi+28],edx
		mov	edx,ds:[esi+4*ecx+28]
		mov	ds:[edi+32],edx
		add	edi,ds:[@@trisize]
		dec	ecx
		jnz	short @@L3
	;
@@Skp:  add	esi,ebp			;ESI += Primitive size
	pop	eax			;EAX = face counter
	dec	eax
	jnz	@@L2              	;Loop !
	;
	pop	ecx			;ECX = ptr to old list
	call	Free			;Free old list
	pop	eax			;EAX = ptr to new list

@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn

@@trisize	dd	3*4+24
GVE_Make_Triangles ENDP


;
;
; GVE_Texture_Object
;  Input:
;	EAX	- DATA32 ptr to world-header
;      EDX	- DATA32 ptr to object-header
;  Output:
;	CF	- Error-Flag
;
PUBLIC C GVE_Texture_Object
GVE_Texture_Object PROC NEAR
	push	ds
	push	esi
	push	edi
	push	ebp

	cld
	mov	ds,cs:[DATA32_Selector]
	mov	eax,ds:[eax+World_Object_List]
	call	Find_List_Entry
	jc	short @@End

	mov	edi,ds:[edx]				;EDI = ptr to object-header
	;
	ifdef	GVE_VERTEX_TEXTURE_UV
	 mov	esi,ds:[edi+Object_Vertex_List]
	 test	esi,esi
	 jz	short @@End
	 mov	edx,ds:[esi]				;EDX - Number of vertices
	 test	edx,edx
	 jz	short @@End
	 add	esi,4					;Skip header

	 @@L1:	mov	eax,ds:[esi+Vertex_NormalX]	;Get Normal_Y
		mov	ebx,ds:[esi+Vertex_NormalY]	;Get Normal_X
		add	eax,1 shl GVE_NORMAL_SHIFT
		add	ebx,1 shl GVE_NORMAL_SHIFT
		shl	eax,15-GVE_NORMAL_SHIFT		;Texture u  (16:16 bit FP)
		shl	ebx,15-GVE_NORMAL_SHIFT		;Texture v  (16:16 bit FP)
		mov	ds:[esi+Vertex_TextureU],eax
		mov	ds:[esi+Vertex_TextureV],ebx
		add	esi,GVE_VERTEX_SIZE
		dec     edx
		jnz	short @@L1
	 clc
	 jmp 	short @@End
else	;
	 mov	esi,ds:[edi+Object_Face_List]
	 mov	edx,ds:[esi]				;EDX - Number of primitves
	 add	esi,4					;Skip header

@@L1:    movzx	eax,byte ptr ds:[esi+2]			;EAX = object type
	 test	ds:[GVE_Shading_List+eax],VST_TEXTURE+VST_BUMP
	 jz	short @@No				;No texture poly at all !

	 movzx	ecx,byte ptr ds:[esi+3]			;ECX = vertex counter
	 lea	edi,[esi+20+4*ecx]			;EDI points to texture data
	@@L2:	mov	ebp,ds:[esi+20+4*ecx]
		mov	eax,ds:[ebp+Vertex_NormalX]	;Get Normal_Y
		mov	ebx,ds:[ebp+Vertex_NormalY]	;Get Normal_X
		add	eax,1 shl GVE_NORMAL_SHIFT
		add	ebx,1 shl GVE_NORMAL_SHIFT
		shl	eax,11+16-GVE_NORMAL_SHIFT	;Texture u  (12:4 bit FP)
		shl	ebx,11-GVE_NORMAL_SHIFT		;Texture v  (12:4 bit FP)
		shld	ebx,eax,16			;EBX = texture-address
		mov	ds:[edi+4*ecx],ebx
		dec     ecx
		jnz	short @@L2

@@No:    movzx	ebp,word ptr ds:[esi]
	 add	esi,ebp
	 dec	edx
	 jnz	short @@L1
	 clc
	 jmp 	short @@End
	endif
	;
@@Err:	stc
@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	ds
	retn
GVE_Texture_Object ENDP
code32 ends
end
