;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
;
P486
LOCALS
JUMPS
SMART
WARN ICG


GVE_SYSTEM_FILE		equ	1
GVE_PRO			equ	1


;
;
;
;   GOMEZ VECTOR ENGINE  pro                                       v2.0
;
;
;
code32  segment para public use32
	assume cs:code32, ds:code32
	largestack


include gve32.inc
include gomez.inc
include gpp.inc
include gvecolor.inc



;
;
;
;   GOMEZ VECTOR ENGINE  pro                             ASSEMBLING-CHECK
;
;
;

ifndef GVE_CULL_FIRST
 ifndef GVE_CULL_AFTER
  ERR "You must define GVE_CULL_FIRST or GVE_CULL_AFTER !"
 endif
else
 ifdef GVE_CULL_AFTER
  ERR "You cannot use both GVE_CULL_FIRST and GVE_CULL_AFTER !"
 endif
endif

if ((GVE_MATRIX_SHIFT+GVE_NORMAL_SHIFT) ge 31)
 ERR "GVE_MATRIX_SHIFT+GVE_NORMAL_SHIFT must be less or equal to 30 !"
endif


ifdef GVE_DISPLAY_OPTIONS
 ifdef GVE_PRO
  DISPLAY "   GVE/pro Version"
 endif
 ifdef GVE_CULL_FIRST
  DISPLAY "   Culling before vertex-transformation"
 endif
 ifdef GVE_CULL_AFTER
  DISPLAY "   Culling after vertex-transformation"
 endif
 ifdef GVE_PROFILER
  DISPLAY "   Profiler enabled"
  ifndef GVE_EXACT_FRAME_SPEED
   DISPLAY "   16 frames will be used for fps calculation"
  else
   DISPLAY "   1 frame will be used for fps calculation"
  endif
 endif
 ifdef GVE_MULTI_LIGHTS
  DISPLAY "   Multiple light sources enabled"
 endif
 ifdef GVE_BOUNDING_BOX
  DISPLAY "   Bounding boxes enabled"
 endif
 ifdef GVE_VIDEO
  DISPLAY "   Video texture support enabled"
 endif
 ifdef GVE_SPHERICAL_CHROME
  DISPLAY "   Spherical chrome mapping via acos/asin enabled"
  endif
 ifdef GVE_VERTEX_TEXTURE_UV
  DISPLAY "   Texture UV coordinates stored in vertices"
 endif
 ifdef GVE_TRIVIAL_REJECT
  DISPLAY "   Trivial rejecting enabled"
 endif
 ifdef GVE_RASTER8
  DISPLAY "   8 Bit Raster Code enabled"
 endif
 ifdef GVE_RASTER16
  DISPLAY "   15/16 Bit Raster Code enabled"
 endif
 ifdef GVE_RASTER32
  DISPLAY "   24/32 Bit Raster Code enabled"
 endif
endif



;
;
;
;   GOMEZ VECTOR ENGINE  pro                            Variable declaration
;
;
;
PUBLIC GVE_Texture_List
PUBLIC GVE_PhongMap_List
PUBLIC GVE_BumpMap_List
PUBLIC GVE_Shading_LUT
PUBLIC GVE_Glass_LUT
PUBLIC GVE_Bump_LUT
PUBLIC GVE_Blurr_LUT
PUBLIC GVE_IO_Buffer
PUBLIC GVE_Video_Buffer
PUBLIC GVE_SOften_Mask

PUBLIC C GVE_Old_Frame_Buffer
PUBLIC C GVE_Frame_Buffer
PUBLIC C GVE_Frame_Width
PUBLIC C GVE_Frame_Height
PUBLIC C GVE_Frame_Depth
PUBLIC C GVE_Frame_Line_Size
PUBLIC C GVE_Frame_Aspect_Ratio
PUBLIC C GVE_Frame_Speed

PUBLIC C GVE_Clip_X1
PUBLIC C GVE_Clip_Y1
PUBLIC C GVE_Clip_X2
PUBLIC C GVE_Clip_Y2

PUBLIC C GVE_Timer
PUBLIC C GVE_Palette_Buffer


ALIGN 4
GVE_Texture_List		dd	0
GVE_PhongMap_List		dd	0
GVE_BumpMap_List		dd	0
GVE_Order_List			dd	0
GVE_Shading_LUT			dd	0
GVE_Glass_LUT			dd	0
GVE_Bump_LUT			dd	0
GVE_Blurr_LUT			dd	0
GVE_Video_Buffer		dd	0
GVE_Soften_Mask			dd	0
GVE_Timer			dd	0

GVE_Old_Frame_Buffer		dd	0
GVE_Frame_Buffer		dd	0
GVE_Frame_Width			dd	0
GVE_Frame_Height		dd	0
GVE_Frame_Depth			dd	0
GVE_Frame_Line_Size		dd	0
GVE_Frame_Aspect_Ratio		dd	0
GVE_Frame_Speed			dd	0

GVE_Clip_X1			dd	?
GVE_Clip_Y1			dd	?
GVE_Clip_X2			dd	?
GVE_Clip_Y2			dd	?

ifndef GVE_MULTI_LIGHTS
 Object_Light_Direction		GVE_VECTOR	<?>
endif
Object_View_Position		GVE_VECTOR	<?>
Object_View_Direction		GVE_VECTOR	<?>


;
;   GOMEZ VECTOR ENGINE   pro     			DATA AREA
;
ALIGN 16
GVE_IO_Buffer 		db	270 dup (?)
GVE_Palette_Buffer 	db	1024 dup (?)


PUBLIC Phong_Table
PUBLIC Phong_Texture_Table
PUBLIC Carva_Table
PUBLIC GVE_Sinus_Table
PUBLIC GVE_Cosinus_Table
Phong_Table		db	256*GVE_PHONG_MAX_EXP	dup (?)
Phong_Texture_Table 	db	256*GVE_PHONG_MAX_EXP	dup (?)
Carva_Table		db	256			dup (?)
GVE_Sinus_Table		dd	GVE_COSINE_SIZE/4	dup (?)
GVE_Cosinus_Table	dd	GVE_COSINE_SIZE		dup (?)
ifdef GVE_SPHERICAL_CHROME
 ASinTab		dd      (GVE_ASINE_SIZE+1)	dup (?)
endif

SinTab			equ	GVE_Sinus_Table
CosTab			equ	GVE_Cosinus_Table


;
;
;
;   GOMEZ VECTOR ENGINE  pro                             RASTER ALGORITHMS
;
;
;
ifdef GVE_RASTER8
 extrn 	GVE_Method_Table8:DWORD
 extrn 	FX8_Motion_Trace:NEAR
 extrn	FX8_Motion_Blurr:NEAR
 extrn	FX8_Feed_Back:NEAR
 extrn	FX8_Soften_Horizontal:NEAR
 extrn	FX8_Soften_Vertical:NEAR
endif
ifdef GVE_RASTER16
 extrn 	GVE_Method_Table16:DWORD
 extrn 	FX16_Motion_Trace:NEAR
 extrn	FX16_Motion_Blurr:NEAR
 extrn	FX16_Feed_Back:NEAR
 extrn	FX16_Soften_Horizontal:NEAR
 extrn	FX16_Soften_Vertical:NEAR
endif
ifdef GVE_RASTER32
 extrn 	GVE_Method_Table32:DWORD
 extrn 	FX32_Motion_Trace:NEAR
 extrn	FX32_Motion_Blurr:NEAR
 extrn	FX32_Feed_Back:NEAR
 extrn	FX32_Soften_Horizontal:NEAR
 extrn	FX32_Soften_Vertical:NEAR
endif


;
;
;
;   GOMEZ VECTOR ENGINE   pro                        MATHEMATICAL FUNCTIONS
;
;
;
;
;
; The next two macros are used for matrix-vector multiplications:
;
; MULT_VECTOR (matrix,src,dst,type)
;  Input:
;    matrix	- Matrix A
;    src	- Source Vector x
;    type	- MV_MULT_4x4  or
;		  MV_MULT_3x3
;  Output:
;    dst	- Destination Vector y:=Ax
;  Destroys:
;    EAX,EBX,ECX,EDX
;
;
; TRANSPOSED_MULT_VECTOR (matrix,src,dst,type)
;  Input:
;    matrix	- Matrix A
;    src	- Source Vector x
;  Output:
;    dst	- Destination Vector y:=A'x
;                with A' the transposed matrix of A
;  Destroys:
;    EAX,EBX,ECX,EDX
;
MV_MULT_4x4	equ	1
MV_MULT_3x3	equ	2
MV_REG_INIT	equ	4

MULT_VECTOR MACRO mtx,src,dst,typ
	push	ebp
	if ((typ) AND MV_REG_INIT)
	 mov	ebp,ebx			;EBP = Y
	 mov	ebx,eax			;EBX = X
	else
	 mov	ebx,d ds:[src]		;EBX = X
	 mov	ebp,d ds:[src+4]	;EBP = Y
	 mov	ecx,d ds:[src+8]	;ECX = Z
	endif
	;
	mov 	eax,d ds:[mtx+Matrix11]
	imul 	ebx
	shld 	edx,eax,32-GVE_MATRIX_SHIFT
	mov 	d ds:[dst],edx
	mov 	eax,d ds:[mtx+Matrix12]
	imul 	ebp
	shld 	edx,eax,32-GVE_MATRIX_SHIFT
	add 	d ds:[dst],edx
	mov 	eax,ds:[mtx+Matrix13]
	imul 	ecx
	shld 	edx,eax,32-GVE_MATRIX_SHIFT
	if ((typ) AND MV_MULT_4x4)
	 mov	eax,d ds:[mtx+Matrix14]
	 add 	d ds:[dst],edx
	 add 	d ds:[dst],eax
	else
	 add 	d ds:[dst],edx
	endif
	;
	mov 	eax,d ds:[mtx+Matrix21]
	imul	ebx
	shld 	edx,eax,32-GVE_MATRIX_SHIFT
	mov 	d ds:[dst+4],edx
	mov 	eax,d ds:[mtx+Matrix22]
	imul 	ebp
	shld 	edx,eax,32-GVE_MATRIX_SHIFT
	add 	d ds:[dst+4],edx
	mov 	eax,d ds:[mtx+Matrix23]
	imul 	ecx
	shld 	edx,eax,32-GVE_MATRIX_SHIFT
	if ((typ) AND MV_MULT_4x4)
	 mov	eax,d ds:[mtx+Matrix24]
	 add 	d ds:[dst+4],edx
	 add 	d ds:[dst+4],eax
	else
	 add 	d ds:[dst+4],edx
	endif
	;
	mov 	eax,d ds:[mtx+Matrix31]
	imul 	ebx
	shld 	edx,eax,32-GVE_MATRIX_SHIFT
	mov 	d ds:[dst+8],edx
	mov 	eax,d ds:[mtx+Matrix32]
	imul 	ebp
	shld 	edx,eax,32-GVE_MATRIX_SHIFT
	add 	d ds:[dst+8],edx
	mov 	eax,d ds:[mtx+Matrix33]
	imul 	ecx
	shld 	edx,eax,32-GVE_MATRIX_SHIFT
	if ((typ) AND MV_MULT_4x4)
	 mov	eax,d ds:[mtx+Matrix34]
	 add 	d ds:[dst+8],edx
	 add 	d ds:[dst+8],eax
	else
	 add 	d ds:[dst+8],edx
	endif
	pop	ebp
	ENDM
;
TRANSPOSED_MULT_VECTOR MACRO mtx,src,dst,typ
	push	ebp
	if ((typ) AND MV_REG_INIT)
	 mov	ebp,ebx			;EBP = Y
	 mov	ebx,eax			;EBX = X
	else
	 mov	ebx,d ds:[src]		;EBX = X
	 mov	ebp,d ds:[src+4]	;EBP = Y
	 mov	ecx,d ds:[src+8]	;ECX = Z
	endif
	;
	if ((typ) AND MV_MULT_4x4)
	 sub	ebx,d ds:[mtx+Matrix41]
	 sub	ebp,d ds:[mtx+Matrix42]
	 sub	ecx,d ds:[mtx+Matrix43]
	endif
	;
	mov 	eax,d ds:[mtx+Matrix11]
	imul 	ebx
	shld 	edx,eax,32-GVE_MATRIX_SHIFT
	mov 	d ds:[dst],edx
	mov 	eax,d ds:[mtx+Matrix21]
	imul 	ebp
	shld 	edx,eax,32-GVE_MATRIX_SHIFT
	add 	d ds:[dst],edx
	mov 	eax,d ds:[mtx+Matrix31]
	imul 	ecx
	shld 	edx,eax,32-GVE_MATRIX_SHIFT
	add 	d ds:[dst],edx
	;
	mov 	eax,d ds:[mtx+Matrix12]
	imul	ebx
	shld 	edx,eax,32-GVE_MATRIX_SHIFT
	mov 	d ds:[dst+4],edx
	mov 	eax,d ds:[mtx+Matrix22]
	imul 	ebp
	shld 	edx,eax,32-GVE_MATRIX_SHIFT
	add 	d ds:[dst+4],edx
	mov 	eax,d ds:[mtx+Matrix32]
	imul 	ecx
	shld 	edx,eax,32-GVE_MATRIX_SHIFT
	add 	d ds:[dst+4],edx
	;
	mov 	eax,d ds:[mtx+Matrix13]
	imul 	ebx
	shld 	edx,eax,32-GVE_MATRIX_SHIFT
	mov 	d ds:[dst+8],edx
	mov 	eax,d ds:[mtx+Matrix23]
	imul 	ebp
	shld 	edx,eax,32-GVE_MATRIX_SHIFT
	add 	d ds:[dst+8],edx
	mov 	eax,d ds:[mtx+Matrix33]
	imul 	ecx
	shld 	edx,eax,32-GVE_MATRIX_SHIFT
	add 	d ds:[dst+8],edx
	pop	ebp
	ENDM


;
;
; Now follow two maacros for the SINE and COSINE functions including a
; (Co)Sine-table. There is also another table used for phong-shading,
; which contains 256 values for cos(acos(x)/2).
;
;   Sine and Cosine table (GVE_MATRIX_SHIFT bit fixed point arithmetic (FPA) )
;   Phong-Table with 8 bit FPA
;
include gvetable.inc
;
;Cosinus und Sinus:
;    In : bx      -> Angel (from 0 to 1024 for 2PI or 360 degerees)
;         eax     -> Value to multpiply sine with
;    Out: ebx     -> Sinus or Cosinus
;         edx:eax -> Multiplied result
;
Sinus MACRO
	and 	ebx,GVE_COSINE_SIZE-1
	mov 	ebx,ds:[OFFSET SinTab+4*ebx]
	imul 	ebx
	shrd 	eax,edx,GVE_MATRIX_SHIFT
	sar 	edx,GVE_MATRIX_SHIFT
      ENDM
Cosinus MACRO
	and 	ebx,GVE_COSINE_SIZE-1
	mov 	ebx,ds:[OFFSET CosTab+4*ebx]
	imul 	ebx
	shrd 	eax,edx,GVE_MATRIX_SHIFT
	sar 	edx,GVE_MATRIX_SHIFT
      ENDM

;
;MSinusCosinus:
;  Input:
;	???   	- Angel
;  Output:
;	EAX	- Sinus
;	EBX	- Cosinus
;
MSinusCosinus MACRO angel
	and	angel,GVE_COSINE_SIZE-1
	mov 	eax,ds:[OFFSET SinTab+4*angel]
	mov 	ebx,ds:[OFFSET CosTab+4*angel]
      ENDM


;
;
; GVE_Build_Matrix:
;   This function builds the transformation matrix as follows:
;   The order of the rotations are as follows:
;         X , Y , Z
; Input:
;   EAX    -  X translation
;   EBX    -  Y translation
;   ECX    -  Z translation
;   EDX    -  X Rotation  ()
;   ESI    -  Y Rotation  ()
;   EDI    -  Z Rotation  ()
;   DS:EBP -  ptr to destination matrix
; Output:
;   DS:EBP -  Transformation matrix
; Destryos:
;   Everything
;
;
; This routine calculates a matrix as a combination of the following
; matrices (plus the translation that will be performed last):
;
;                                                                  
; cos   -sin   0   0    1   0        0   0    cos   0   sin   0
; sin   cos    0   0    0  cos  -sin   0    0      1     0    0
;  0      0      1   0 *  0  sin  cos    0 *  -sin  0   cos   0
;  0      0      0   1    0   0        0   1    0      0     0    1
;                                                                  
;       Z rotation              X Rotation               Y Rotation
;
;
; The resulting matrix looks like this: (Calculated with CC4 !)
;                                                                              
;  cos*cos - sin*sin*sin    -sin*cos    cos*sin + sin*sin*cos   Tx 
;  sin*cos + cos*sin*sin     cos*cos    sin*sin - cos*sin*cos   Ty 
;          -cos*sin               sin              cos*cos             Tz 
;              0                     0                    0                 1  
;                                                                              
;
;
PUBLIC GVE_Build_Matrix
GVE_Build_Matrix PROC NEAR
	mov	ds:[ebp+Matrix14],eax	;Set all translation thingys
	mov	ds:[ebp+Matrix24],ebx
	mov	ds:[ebp+Matrix34],ecx
	xor	eax,eax
	mov	ds:[ebp+Matrix44],1 shl GVE_MATRIX_SHIFT
	mov	ds:[ebp+Matrix41],eax
	mov	ds:[ebp+Matrix42],eax
	mov	ds:[ebp+Matrix43],eax

	mov	ebx,edx			;Set EBX to 
	and	ebx,GVE_COSINE_SIZE-1
	and	esi,GVE_COSINE_SIZE-1
	and	edi,GVE_COSINE_SIZE-1	;Normalize angles

	mov	eax,ds:[SinTab+4*ebx]	;Get sin
	mov	ds:[ebp+Matrix32],eax	;-=> E32 is ready ! <=-
	imul	ds:[SinTab+4*edi]	;sin*sin
	shrd	eax,edx,GVE_MATRIX_SHIFT
	imul	ds:[SinTab+4*esi]	;sin*sin*sin
	shrd	eax,edx,GVE_MATRIX_SHIFT
	mov	ecx,eax			;ECX=sin*sin*sin

	mov	eax,ds:[CosTab+4*edi]	;cos
	imul	ds:[CosTab+4*esi]	;cos*cos
	shrd	eax,edx,GVE_MATRIX_SHIFT
	sub	eax,ecx			;EAX=cos*cos - sin*sin*sin
	mov	ds:[ebp+Matrix11],eax	;-=> E11 is ready ! <=-


	mov	eax,ds:[SinTab+4*edi]	;sin
	imul	ds:[CosTab+4*ebx]	;sin*cos
	shrd	eax,edx,GVE_MATRIX_SHIFT
	neg	eax
	mov	ds:[ebp+Matrix12],eax	;-=> E12 is ready ! <=-


	mov	eax,ds:[CosTab+4*edi]	;cos
	imul	ds:[SinTab+4*esi]	;cos*sin
	shrd	eax,edx,GVE_MATRIX_SHIFT
	mov	ecx,eax			;ECX=cos*sin

	mov	eax,ds:[SinTab+4*edi]	;sin
	imul	ds:[SinTab+4*ebx]	;sin*sin
	shrd	eax,edx,GVE_MATRIX_SHIFT
	imul	ds:[CosTab+4*esi]	;sin*sin*cos
	shrd	eax,edx,GVE_MATRIX_SHIFT
	add	eax,ecx
	mov	ds:[ebp+Matrix13],eax	;-=> E13 is ready ! <=-


	mov	eax,ds:[SinTab+4*ebx]	;Get sin
	imul	ds:[CosTab+4*edi]	;cos*sin
	shrd	eax,edx,GVE_MATRIX_SHIFT
	imul	ds:[SinTab+4*esi]	;cos*sin*sin
	shrd	eax,edx,GVE_MATRIX_SHIFT
	mov	ecx,eax			;ECX=cos*sin*sin

	mov	eax,ds:[SinTab+4*edi]	;sin
	imul	ds:[CosTab+4*esi]	;sin*cos
	shrd	eax,edx,GVE_MATRIX_SHIFT
	add	eax,ecx			;EAX=sin*cos + cos*sin*sin
	mov	ds:[ebp+Matrix21],eax	;-=> E21 is ready ! <=-


	mov	eax,ds:[CosTab+4*edi]	;cos
	imul	ds:[CosTab+4*ebx]	;cos*cos
	shrd	eax,edx,GVE_MATRIX_SHIFT
	mov	ds:[ebp+Matrix22],eax	;-=> E22 is ready ! <=-


	mov	eax,ds:[SinTab+4*edi]	;sin
	imul	ds:[SinTab+4*esi]	;sin*sin
	shrd	eax,edx,GVE_MATRIX_SHIFT
	mov	ecx,eax			;ECX=cos*sin

	mov	eax,ds:[CosTab+4*edi]	;cos
	imul	ds:[SinTab+4*ebx]	;cos*sin
	shrd	eax,edx,GVE_MATRIX_SHIFT
	imul	ds:[CosTab+4*esi]	;cos*sin*cos
	shrd	eax,edx,GVE_MATRIX_SHIFT
	sub	ecx,eax
	mov	ds:[ebp+Matrix23],ecx	;-=> E23 is ready ! <=-


	mov	eax,ds:[CosTab+4*ebx]	;cos
	imul	ds:[SinTab+4*esi]	;cos*sin
	shrd	eax,edx,GVE_MATRIX_SHIFT
	neg	eax
	mov	ds:[ebp+Matrix31],eax	;-=> E31 is ready ! <=-


	mov	eax,ds:[CosTab+4*ebx]	;cos
	imul	ds:[CosTab+4*esi]	;cos*cos
	shrd	eax,edx,GVE_MATRIX_SHIFT
	mov	ds:[ebp+Matrix33],eax	;-=> E33 is ready ! <=-


	retn
GVE_Build_Matrix ENDP



;
;
; GVE_Build_Direction:
;   This function builds a normal direction vector by applying the following
;   rotations:
;         X , Y , Z
; Input:
;   EBX    -  X Rotation  ()
;   ESI    -  Y Rotation  ()
;   EDI    -  Z Rotation  ()
;   DS:EBP -  ptr to destination vector
; Output:
;   DS:EBP -  normalized direction vector
; Destryos:
;   Everything
;
;
; The resulting vector looks like this:
;                                
;    cos*cos - sin*sin*sin  
;    sin*cos + cos*sin*sin  
;            -cos*sin          
;                                
;
; Note that all entries use GVE_MATRIX_SHIFT for precision control.
;
PUBLIC GVE_Build_Direction
GVE_Build_Direction PROC NEAR
	mov	ebx,edx			;Set EBX to 
	and	ebx,GVE_COSINE_SIZE-1
	and	esi,GVE_COSINE_SIZE-1
	and	edi,GVE_COSINE_SIZE-1	;Normalize angles


	mov	eax,ds:[SinTab+4*ebx]	;Get sin
	imul	ds:[SinTab+4*edi]	;sin*sin
	shrd	eax,edx,GVE_MATRIX_SHIFT
	imul	ds:[SinTab+4*esi]	;sin*sin*sin
	shrd	eax,edx,GVE_MATRIX_SHIFT
	mov	ecx,eax			;ECX=sin*sin*sin

	mov	eax,ds:[CosTab+4*edi]	;cos
	imul	ds:[CosTab+4*esi]	;cos*cos
	shrd	eax,edx,GVE_MATRIX_SHIFT
	sub	eax,ecx			;EAX=cos*cos - sin*sin*sin
	mov	ds:[ebp],eax		;-=> E1 is ready ! <=-


	mov	eax,ds:[SinTab+4*ebx]	;Get sin
	imul	ds:[CosTab+4*edi]	;cos*sin
	shrd	eax,edx,GVE_MATRIX_SHIFT
	imul	ds:[SinTab+4*esi]	;cos*sin*sin
	shrd	eax,edx,GVE_MATRIX_SHIFT
	mov	ecx,eax			;ECX=cos*sin*sin

	mov	eax,ds:[SinTab+4*edi]	;sin
	imul	ds:[CosTab+4*esi]	;sin*cos
	shrd	eax,edx,GVE_MATRIX_SHIFT
	add	eax,ecx			;EAX=sin*cos + cos*sin*sin
	mov	ds:[ebp+4],eax		;-=> E2 is ready ! <=-


	mov	eax,ds:[CosTab+4*ebx]	;cos
	imul	ds:[SinTab+4*esi]	;cos*sin
	shrd	eax,edx,GVE_MATRIX_SHIFT
	neg	eax
	mov	ds:[ebp+8],eax		;-=> E3 is ready ! <=-


	retn
GVE_Build_Direction ENDP




;
;
; GVE_Mult_Matrix:
;	This function is used to multiply two 4x4 matrices
;
; Input:
;	ES	-	Selector for matrices
;	ESI	-	Matrix A
;	EBP	-	Matrix B
;	EDI	-	Resulting matrix A*B
;	CH	-	Number of rows to calculate
; Output:
;	resulting matrix
; Destroys:
;	EAX,EBX,ECX,EDX
;
;
; Note: CH is used as a row-counter, because when calculating the final
;       transformation matrix, 3 rows suffice, but normally you would like
;	 to get 4 rows. So for speed, I made it this way
;
PUBLIC GVE_Mult_Matrix
GVE_Mult_Matrix PROC NEAR
	push	edi
	push	esi
;	mov	ch,4
@@L1:	mov	cl,4
@@L2:		mov	eax,ds:[esi]
		imul	d ds:[ebp]
		shrd	eax,edx,GVE_MATRIX_SHIFT
		mov	ebx,eax

		mov	eax,ds:[esi+4]
		imul	d ds:[ebp+4*4]
		shrd	eax,edx,GVE_MATRIX_SHIFT
		add	ebx,eax

		mov	eax,ds:[esi+8]
		imul	d ds:[ebp+8*4]
		shrd	eax,edx,GVE_MATRIX_SHIFT
		add	ebx,eax

		mov	eax,ds:[esi+12]
		imul	d ds:[ebp+12*4]
		shrd	eax,edx,GVE_MATRIX_SHIFT
		add	eax,ebx		;EAX holds result

		stosd			;Save it in matrix
		add	ebp,4
		dec	cl		;Next coloumn in B
		jnz	short @@L2
	sub	ebp,4*4
	add	esi,4*4			;Next row in A
	dec	ch
	jnz	short @@L1

	pop	esi
	pop	edi
	retn
GVE_Mult_Matrix ENDP
;
;
; FTOL@
; Calls to FTOL@ are generated by the compiler for code
; that needs to convert a floating point type to an integral type.
; Input:  floating point number on the top of the '87.
; Output: a (signed or unsigned) long in EAX,
; All other registers preserved.
;
FTOL@:	sub     esp, 12
	fstcw   ss:[esp]              	; save the control word
	fwait
	mov     al, ss:[esp+1]
	or      byte ptr ss:[esp+1], 0Ch
	fldcw   ss:[esp]
	fistp   qword ptr ss:[esp+4]   	; convert to 64-bit integer
	mov     ss:[esp+1], al
	fldcw   ss:[esp]               	; restore the control word
	mov     eax, ss:[esp+4]        	; return LS 32 bits
	mov	edx, ss:[esp+8]
	add     esp, 12
	retn
;
;
; This macro tests if a surface is visible. The test is done in 2D-screen
; space !
; TEST_BACK_CULLING_2D
;   Input:
;	DS:ESI 	- primitive header
;   Output:
;      SIGN	- 1 - not visible
;		  0 - visible
;   Destroys:
;	EAX,EBX,ECX,EDX,EBP
;
;
; The calculation is based on the following formular:
;  v[x]:=p1.x - p2.x;
;  v[y]:=p1.y - p2.y;
;  w[x]:=p3.x - p2.x;
;  w[y]:=p3.y - p2.y;
;  m1  :=v[x] * w[y];
;  m2  :=v[y] * w[x];
;  visible:=m1 - m2>0;
;
TEST_BACK_CULLING_2D MACRO
	mov	ebx,ds:[esi+24]			;DS:EBX points to p1
	mov	ecx,ds:[esi+28]			;DS:ECX points to p2
	mov     ebp,ds:[esi+32]			;DS:EBP points to p3

	mov	eax,ds:[ebx+Vertex_ScreenX]
	mov	edx,ds:[ebp+Vertex_ScreenY]
	sub	eax,ds:[ecx+Vertex_ScreenX]  	;EAX = p1x-p2x
	sub	edx,ds:[ecx+Vertex_ScreenY]	;EDX = p3y-p2y
	sar	eax,16
	imul	edx         	            	;EAX = v[x] * w[y]

	mov	edx,ds:[ebp+Vertex_ScreenX]
	mov	ebp,eax				;EBP = v[x] * w[y]
	sub	edx,ds:[ecx+Vertex_ScreenX]	;EDX = p3x-p2x
	mov	eax,ds:[ebx+Vertex_ScreenY]
	sar	edx,16
	sub	eax,ds:[ecx+Vertex_ScreenY]  	;EAX = p1y-p2y
	imul	edx				;EAX = v[y] * w[x]

	cmp	ebp,eax
	ENDM



;
;   GOMEZ VECTOR ENGINE   pro                             SORTING ROUTINES
;
;
;
; Hugh again... The byte-sort algorithm is still too complex. Now I decided
; clever as I am, to rip some quick-sort code from the Borland C++ library.
; It was some work to get it work (C to ASM conversion can be tricky !), but
; now quick_sort is _VERY_ fast compared with bubble sort.
;
; Quicker_Sort:
;  Input:
;	DS  - DATA32 Selector
;	ESI - ptr to first element to sort
;	EDX - number of elements to sort
;  Output:
;	Sorted list
;  Destroys:
;	EAX,EBX,ECX,EDX,EDI,ESI,EBP
;
Quicker_Sort PROC NEAR
@@Tail:	cmp	edx,2			;Is number <= 2 ???
	jb	short @@End		;JB: Only 1 element !
	ja	short @@DoIt		;JA: More than 2 elements
		;
		;Need only to sort 2 elements !
		mov	eax,ds:[esi+4]
		cmp	eax,ds:[esi+12]
		jge	short @@End

		mov	ebx,ds:[esi]
		xchg	eax,ds:[esi+12]
		xchg	ebx,ds:[esi+8]
		mov	ds:[esi+4],eax
		mov	ds:[esi],ebx
	@@End:	retn

@@DoIt: ;
	;Need to sort more than 2 elements !
	;
	lea	edi,[esi+8*edx-8]	;EDI is rightP (last entry)
	mov	ebp,edx
	shr	ebp,1
	lea	ebp,[esi+8*ebp]		;EBP is leftP (middle entry)

	;
	;First something like "Median of three"
	;Registers are:
	;  	ESI	- 	pivotP
	;	EBP	-       leftP
	;	EDI	-	rightP
	;	EDX	-	Counter
	;
	mov	eax,ds:[ebp+4]		;EAX is left pleft-element
	cmp	eax,ds:[edi+4]		;Is *leftP > *rightP ???
	jge	short @@N1
		mov	ebx,ds:[ebp]
		xchg	eax,ds:[edi+4]	;Exchange *leftP and *rightP...
		xchg	ebx,ds:[edi]
		mov	ds:[ebp+4],eax
		mov	ds:[ebp],ebx
@@N1:	cmp	eax,ds:[esi+4]		;EAX still contains leftP
	jg 	short @@N2
		cmp	edx,3		;Only 3 elements to process ???
		je	short @@End	;JE ==> Ready !
		mov	ebx,ds:[ebp]
		xchg	eax,ds:[esi+4]	;Exchange leftP and pivotP
		xchg	ebx,ds:[esi]
		mov	ds:[ebp+4],eax
		mov	ds:[ebp],ebx
		jmp	short @@Hoare
@@N2:   mov	eax,ds:[esi+4]		;EAX = pivot
	cmp	eax,ds:[edi+4]		;Is *pivotP > *rightP ???
	jge	short @@N3
		mov	ebx,ds:[esi]
		xchg	eax,ds:[edi+4]	;Exchange pivot and pright
		xchg	ebx,ds:[edi]
		mov	ds:[esi+4],eax
		mov	ds:[esi],ebx
@@N3:	cmp	edx,3
	ja	short @@Hoare		;Are there only 3 elements ???
		mov	ebx,ds:[esi]
		xchg	eax,ds:[ebp+4]	;Exchange *leftP and *pivotP
		xchg	ebx,ds:[ebp]
		mov	ds:[esi+4],eax
		mov	ds:[esi],ebx
		retn

@@Hoare:
	;
	;Now lets start the classic Hoare-algorithm
	;
	;Registers are:
	;	ESI	-	pivotP
	;	EDI	-	rightP
	;	EBP	-       leftP
	;	EBX	-	pivotEnd
	;	EDX	-	Counter
	;
	;The order is:
	;       *leftP > *pivotP > *rightP
	;
	;The pointer order is:
	;	pivotP < leftP < rightP
	;
	lea	ebx,[esi+8]		;Initialize LeftP and pivotEnd
	mov	ebp,ebx
	;
	;Now the pointer order is:
	;	pivotP < leftP=pivotEnd=pivotP+1 < rightP
	;
	;The item order is:
	;	*pivotP > *rightP
	;but we cannot assume anything about *leftP
	;

	;
	;In the following loop, we look for the first item between
	;pivotP(first entry) and rightP(last entry) that is smaller than
	;*pivotP
	;
@@L1:   mov	eax,ds:[ebp+4]		;EAX=*leftP
	cmp	eax,ds:[esi+4]		;Is *leftP < *pivotP ?
	jl	short @@L2
	jne	short @@NEq
		;
		;The following thing happens when *leftP = *pivotP
		;Then we exchange the current thing with the entry just
		;behind the pivot-element (pivotEnd).
		mov	ecx,ds:[ebp]
		xchg	eax,ds:[ebx+4]	;Exchange *leftP and *pivotEnd
		xchg	ecx,ds:[ebx]
		mov	ds:[ebp+4],eax
		mov	ds:[ebp],ecx
		add	ebx,8		;pivotEnd += 8
@@NEq:  add     ebp,8			;leftP += 8
	cmp	ebp,edi			;Is leftP < rightP ???
	jbe	short @@L1
	sub	ebp,8                   ;Oha, there is no item between pivotP
	jmp	short @@qBreak		;  and rightP that is smaller than
					;  pivotP

	;
	;Ok, we have just found an entry *leftP between pivotP and rightP
	;for which is true:
	;		*pivotP > *leftP
	;		pivotEnd< leftP < rightP
	;
	;Out goal is that all entries bigger/equal to *pivotP get to the left
	;end of the list and all entries smaller get to the right end of the
	;list.
	;
@@L2:	cmp	ebp,edi			;Is leftP < rightP ???
	jae	short @@EndL2		;JAE: No ==> Quit loop !
	mov	eax,ds:[esi+4]		;EAX=*pivotP
	cmp	eax,ds:[edi+4]		;Is *pivotP < *rightP ?
	jle	short @@J1
		sub	edi,8		;rightP-=8
		jmp	short @@L2
	@@J1:	mov	eax,ds:[edi+4]	;Exchange *leftP and *rightP
		mov	ecx,ds:[edi]
		xchg	eax,ds:[ebp+4]
		xchg	ecx,ds:[ebp]
		mov	ds:[edi+4],eax
		mov	ds:[edi],ecx

		je	short @@EndL2	;Jump if *pivotP = *rightP
		add     ebp,8           ;leftP += 8
		sub	edi,8		;rightP -= 8
@@EndL2:
	cmp	ebp,edi			;Is leftP < rightP ???
	jb	short @@L1


@@qBreak:
	mov	eax,ds:[ebp+4]		;EAX = *leftP
	cmp	eax,ds:[esi+4]		;Is *leftP < *pivotP ??
	jl	short @@J2
		add	ebp,8		;leftP += 8
@@J2:   ;
	;Now Regsiters will set to:
	;	ESI	- 	pivotP / pivotTemp
	;	EDI	-	leftTemp
	;	EBX	-	pivotEnd
	;	EBP	-	leftP
	;	EDX	-	Counter
	;
	lea	edi,[ebp-8]		;EDI = leftTemp
	push	esi			;Save pivotP

@@L3:	cmp	esi,ebx			;Is pivotTemp < pivotEnd ?
	jae	short @@EndL3
	cmp     edi,ebx
	jb	short @@EndL3
		mov	eax,ds:[edi+4]	;Exchange *pivotTemp and *leftTemp
		mov	ecx,ds:[edi]
		xchg	eax,ds:[esi+4]
		xchg	ecx,ds:[esi]
		mov	ds:[edi+4],eax
		mov	ds:[edi],ecx
		add	esi,8		;pivotTemp += 8
		sub	edi,8		;leftTemp -= 8
		jmp	short @@L3
@@EndL3:
	pop	esi			;ESI = pivotP
	mov	eax,ebp
	sub	eax,ebx
	shr	eax,3			;EAX = lnum = (leftP - pivotEnd) / 8
	lea	edx,[8*edx+esi]
	sub	edx,ebp
	shr	edx,3			;EDX = nElem = (nElem * 8 + pivotP - leftP) / 8

	push	eax			;Save lnum
	push	esi			;Save pivotP
	mov	esi,ebp			;ESI = leftP
	call	Quicker_Sort
	pop	esi
	pop	edx			;Restore nElem=lnum

	jmp	@@Tail
Quicker_Sort ENDP






;
;
;
;   GOMEZ VECTOR ENGINE  pro                             USER FUNCTIONS
;
;
;
;
;
; Now follow the front-end routines (GVE_Transform_World,GVE_Draw_World)
; Only these needs to be called by the user.
; And first of all you must use GVE_Init_World to tell the engine where to
; find all datas needed. But you only need to call this once.
;
; The prefix GVE is derived from Gomez Vector Engine.
;
;
; The following profiling areas are defined:
;	0	-	Transformation
;	1	-	Sorting
;	2	-	Drawing
;	3	-	Postprocessing
;	4	- 	Culling / Visible Surface Determination
;	5	-	User #1
;	6	-	User #2
;	7	-	Vertex-Counter
;	8	-	Face-Counter
;
;
;   GOMEZ VECTOR ENGINE  pro                    INITIIALISATION FUNCTIONS
;
PUBLIC C Init_GVE
Init_GVE PROC NEAR
	cld
	push	ds
	push	es
	push	edi
	push	esi
	push	ebp
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	;
	test	ds:[GOMEZ_System],7 shl 11	;Test for FPU
	stc					;Carry for error
	jz	@@Err				;No FPU ==> Error
	;
	mov	ds:[GVE_Frame_Width],eax
	mov	ds:[GVE_Frame_Height],ebx
	mov	ds:[GVE_Frame_Depth],ecx
	ifdef 	GVE_RASTER8
	 cmp	cl,8
	 je	short @@Set8
	endif
	ifdef 	GVE_RASTER16
	 cmp	cl,15
	 je	short @@Set15
	 cmp	cl,16
	 je	short @@Set16
	endif
	ifdef	GVE_RASTER32
	 cmp	cl,32
	 je	short @@Set32
	endif
	stc
	jmp	@@Err

	;
	;  Colour specific setup
	;
	ifdef	GVE_RASTER8
@@Set8:	 mov	dword ptr ds:[MTBL-4],OFFSET GVE_Method_table8
	 jmp	@@All
	endif
	;
	ifdef	GVE_RASTER16
@@Set16: mov	eax,NOT 00001000001000010000100000100001b
	 jmp	short @@J1
@@Set15: mov	eax,NOT 10000100001000011000010000100001b
@@J1:	 mov	ds:[GVE_SOften_Mask],eax
	 mov	dword ptr ds:[MTBL-4],OFFSET GVE_Method_table16
	 jmp	@@All
	endif
	;
	ifdef	GVE_RASTER32
@@Set32: mov	dword ptr ds:[MTBL-4],OFFSET GVE_Method_table32
	endif

@@All: 	;
	;  Other global setup
	;
	mov	ecx,GVE_MAX_VISIBLE_POLYS*8
	call	Malloc
	mov	ds:[GVE_Order_List],eax
	jc	@@Err

	ifdef GVE_VIDEO_TEXTURES
	 mov	ecx,GVE_VIDEO_BUFFER_SIZE*1024
	 call	Malloc
	 mov	ds:[GVE_Video_Buffer],eax
	 jc	@@Err
	endif
	;
	xor	edx,edx
	mov	eax,ds:[GVE_Frame_Width]	;EAX = Width
	shl	eax,16
	idiv	ds:[GVE_Frame_Height]
	mov	ecx,eax				;ECX = Aspect ratio
	mov	eax,ds:[GVE_Frame_Width]	;EAX = Width
	mov	ebx,ds:[GVE_Frame_Height]	;EBX = Height
	call	GVE_Set_Frame_Size
	;
	finit
	xor	ecx,ecx
	mov	edi,OFFSET SinTab
	fwait
	fild	ds:[@costabsize]		;ST(2) = Cossize
	fild	ds:[@cosshiftsize]		;ST(1) = 16
@@L1:	push	ecx
	fwait
	fldpi					;ST(0) = pi
	fimul	dword ptr ss:[esp]		;ST(0) = ECX*pi
	fdiv	st(0),st(2)			;ST(0) = ECX*pi / Table_Size
	fsin                            	;ST(0) = sin
	fscale					;ST(0) <<= ST(1)
	fistp	dword ptr ss:[esp]
	fwait
	pop	eax
	stosd
	inc	ecx
	cmp	ecx,(GVE_COSINE_SIZE*5)/4
	jb	short @@L1
	ffree	st(1)
	ffree	st(0)
	;
	xor	edi,edi
	mov	ebx,1
@@L3:	xor	ebp,ebp
@@L2:   movsx	ecx,ds:[Phong_Translation_Table+2*ebp]
	shl	ecx,10				;Make 20 bit FPA

	mov	eax,100000h			;EAX = base
	mov	bh,bl				;BH = Exponent
	@@EXP:  imul	ecx			;EAX *= ECX (Phong_Table)
		shrd	eax,edx,20
		dec	bh
		jnz	short @@EXP
	sar	eax,14
	mov	ds:[Phong_Texture_Table+edi],al
	sar	eax,1
	sub	al,16
	mov	ds:[Phong_Table+edi],al
	inc	edi

	inc	ebp
	cmp	ebp,256
	jl	short @@L2			;Next base

	inc	bl				;Next exponent
	cmp	bl,GVE_PHONG_MAX_EXP
	jbe	short @@L3
	;
	mov	edi,OFFSET Carva_Table
	mov	ecx,256
@@L4:	mov	edx,015a4e35h
	mov	eax,ds:[@noise]
	mul 	edx
	shrd 	eax,edx,16
	inc 	eax
	mov 	ds:[@noise],eax
	and	eax,01fh
	stosb
	dec	ecx
	jnz	short @@L4
	;
	;
	; asin (x) = atan (x / sqrt (1 - x))
	;
	ifdef GVE_SPHERICAL_CHROME
	 mov	edi,OFFSET AsinTab
	 mov	ecx,GVE_ASINE_SIZE
@@L5:    mov	eax,ecx
	 sub	eax,GVE_ASINE_SIZE/2
	 push	eax
	 fwait
	 fild	dword ptr ss:[esp]		;ST(0) = Counter
	 fidiv 	ds:[@asintabsize]		;ST(0) /= asinsize
	 fld	st(0)				;Save ST(0) for later
	 fmul	st(0),st(0)			;ST(0) = x
	 fld1					;ST(0) = 1.0  ST(1) = x
	 fsub	st(0),st(1)			;ST(0) = 1.0 - x
	 fsqrt					;ST(0) = sqrt (1.0 - x)
	 fld	st(2)				;ST(0) = x
	 ftst
	 fstsw	ax
	 sahf
;	 jz	short @@Zer5
	 fpatan					;ST(0) = atan (x / sqrt (1 - x))
	 fldpi					;ST(0) = Pi
	 fdivr	st(0),st(1)			;ST(0) = ST(1) / Pi
	 fild	ds:[@asinshiftsize]
	 fxch	st(1)
	 fscale					;ST(0) <<= ST(1)
@@Zer5:	 fistp	dword ptr ss:[esp]
	 ffree	st(0)
	 ffree	st(1)
	 ffree	st(2)
	 ffree	st(3)
	 fwait
	 pop	eax
	 stosd
	 dec	ecx
	 jns	short @@L5
	endif

	;
	;  Profiler setup
	;
	ifdef GVE_PROFILER
	 mov	eax,0
	 mov	ebx,OFFSET Timer_Handler
	 call	Set_Flat_IRQ
	 mov	ds:[TIMER_PM_Int],ebx
	 mov	eax,0
;	 call	Link_Real_IRQ
	 mov	ds:[TIMER_RM_Int],ebx

	 cli
	 mov 	al,36h
	 out 	43h,al
	 mov	ebx,GVE_TIMER_SPEED
	 xor 	edx,edx
	 mov 	eax,123333h                    	;Calculate timer constant
	 div 	ebx
	 out 	40h,al
	 sar 	eax,8
	 out 	40h,al
	 sti

	 ;
	 ;Set minimal counts of #vertices and #faces
	 mov	eax,0fffffffh
	 mov	ds:[PROFILING_DATA+7*16+4],eax
	 mov	ds:[PROFILING_DATA+8*16+4],eax
	endif
	;
	clc
@@Err:	pop	ebp
	pop	esi
	pop	edi
	pop	es
	pop	ds
	retn

@costabsize	dd	GVE_COSINE_SIZE/2
@cosshiftsize	dd	GVE_MATRIX_SHIFT
@asintabsize	dd	GVE_ASINE_SIZE/2
@asinshiftsize	dd	16
@noise		dd	1
@chromeadd	dd	1 shl 14
Init_GVE ENDP



;
;
; Exit_GVE
;  Input:
;	Nothing
;  Output:
;	CF	- Error flag
;
PUBLIC C Exit_GVE
Exit_GVE PROC NEAR
	push	ds
	push	es
	mov	ds,cs:[DATA32_Selector]

	mov	ecx,ds:[GVE_Order_List]
	call	Free
	mov	ecx,ds:[GVE_Video_Buffer]
	call	Free

	ifdef GVE_PROFILER
	 mov 	ax,36h 	; PIT channel 0, square wave,binary, send LSB & MSB
	 out 	43h,al 	; send command
	 mov 	al,0
	 out 	40h,al 	; maximum timer count (freq. = 18.2 Hz)
	 out 	40h,al 	;

	 mov	eax,0
	 mov	ebx,ds:[TIMER_RM_Int]
;	 call	UnLink_Real_IRQ
	 mov	eax,0
	 mov	ebx,ds:[TIMER_PM_Int]
	 call	Set_Flat_IRQ

	 call 	Print_Profiler
	endif

	clc
	pop	es
	pop	ds
	retn
Exit_GVE ENDP



;
;
; GVE_Set_Frame_Size
;  Input:
;	EAX	- New frame width
;	EBX	- New frame height
;	ECX	- New aspect ratio
;  Output:
;	CF	- Error flag
;
PUBLIC C GVE_Set_Frame_Size
GVE_Set_Frame_Size PROC NEAR
	push	ds
	mov	ds,cs:[DATA32_Selector]

	mov	edx,ds:[GVE_Frame_Depth]
	mov	ds:[GVE_Frame_Width],eax
	mov	ds:[GVE_Frame_Line_Size],eax
	mov	ds:[GVE_Frame_Height],ebx
	mov	ds:[GVE_Frame_Aspect_Ratio],ecx
	dec	eax
	dec	ebx
	mov	ds:[GVE_Clip_X1],0
	mov	ds:[GVE_Clip_Y1],0
	mov	ds:[GVE_Clip_X2],eax
	mov	ds:[GVE_Clip_Y2],ebx

	cmp	dl,8
	jbe	short @@End
	shl	ds:[GVE_Frame_Line_Size],1
	cmp	dl,16
	jbe	short @@End
	shl	ds:[GVE_Frame_Line_Size],1

@@End:	clc
	pop	ds
	retn
GVE_Set_Frame_Size ENDP



;
;
; GVE_Set_Clip_Window
;  Input:
;	EAX	- x1
;	EBX	- y1
;	ECX	- x2
;	EDX	- y2
;  Output:
;	CF	- Error flag
;
PUBLIC C GVE_Set_Clip_Window
GVE_Set_Clip_Window PROC NEAR
	push	ds
	mov	ds,cs:[DATA32_Selector]

	mov	ds:[GVE_Clip_X1],eax
	mov	ds:[GVE_Clip_Y1],ebx
	mov	ds:[GVE_Clip_X2],ecx
	mov	ds:[GVE_Clip_Y2],edx

	clc
	pop	ds
	retn
GVE_Set_Clip_Window ENDP




;
;   GOMEZ VECTOR ENGINE  pro               DRAWING/TRANSFORMATION FUNCTIONS
;
;
;
; GVE_Move_Camera
;  Input:
;	EAX 	- DATA32 ptr to world-header
;	EDX	- DATA32 ptr to camera
;  Output:
;	GVE_Camera_Matrix
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Move_Camera
GVE_Move_Camera PROC NEAR
	cld
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	mov	ebp,edx
	test	edx,edx
	jz	short @@End

	mov	eax,ds:[ebp+Camera_Position+12]
	mov	ebx,ds:[ebp+Camera_Position+16]
	mov	ecx,ds:[ebp+Camera_Position+20]
	mov	edx,ds:[ebp+Camera_Position]
	mov	esi,ds:[ebp+Camera_Position+4]
	mov	edi,ds:[ebp+Camera_Position+8]
	neg	eax
	neg	ebx
	neg	ecx
	neg	edx
	neg	esi
	neg	edi

	lea	ebp,[ebp+Camera_Matrix]
	call	GVE_Build_Matrix

@@End:	clc
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
GVE_Move_Camera ENDP



;
;
; GVE_Move_Object
;  Input:
;	EAX	- DATA32 ptr to world-header
;	EDX	- DATA32 ptr to object-header
;  Output:
;      Matrix within object
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Move_Object
GVE_Move_Object PROC NEAR
	cld
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	mov	ebp,edx
	test	edx,edx
	jz	short @@End

	mov	eax,ds:[ebp+Object_Position+12]
	mov	ebx,ds:[ebp+Object_Position+16]
	mov	ecx,ds:[ebp+Object_Position+20]
	mov	edx,ds:[ebp+Object_Position]
	mov	esi,ds:[ebp+Object_Position+4]
	mov	edi,ds:[ebp+Object_Position+8]
	lea	ebp,[ebp+Object_Local_Matrix]
	call	GVE_Build_Matrix

@@End:	clc
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
GVE_Move_Object ENDP



;
;
; GVE_Move_Light
;  Input:
;	EAX	- DATA32 ptr to world-header
;	EDX	- DATA32 ptr to lightsource
;  Output:
;	GVE_Light_Matrix
;  Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Move_Light
GVE_Move_Light PROC NEAR
	cld
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	mov	ebp,edx
	test	edx,edx
	jz	short @@End

	mov	edx,ds:[ebp+Light_Position]
	mov	esi,ds:[ebp+Light_Position+4]
	mov	edi,ds:[ebp+Light_Position+8]
	lea	ebp,[ebp+Light_Direction]
	call	GVE_Build_Direction

@@End:	clc
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
GVE_Move_Light ENDP




;
;
; GVE_Set_Distance   (only here for compatibility)
;  Input:
;	EAX	- DATA32 ptr to world-header
;  Output:
;	Nothing
;  Destroys:
;	Nothing
;
PUBLIC C GVE_Set_Distance
GVE_Set_Distance PROC NEAR
	clc
	retn
GVE_Set_Distance ENDP




;
;
; GVE_Transform_World  (only here for compatibility)
;  Input:
;	EAX	- DATA32 ptr to world-header
;  Output:
;	Nothing
;  Destroys:
;	Nothing
;
PUBLIC C GVE_Transform_World
GVE_Transform_World PROC NEAR
	clc
	retn
GVE_Transform_World ENDP





;
;
; GVE_Draw_World:
;   Input:
;	EAX	- DATA32 ptr to world-header
;	EBX	- DATA32 ptr to camera
;	ECX	- ptr to old frame-buffer
;	EDX   	- ptr to frame-buffer
;   Output:
;	refreshed frame-buffer
;   Destroys:
;	EAX,EBX,ECX,EDX
;
PUBLIC C GVE_Draw_World
GVE_Draw_World PROC NEAR
	push 	ds
	push	es
	push	esi
	push	edi
	push	ebp


	cld
	mov 	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	mov	ebp,eax				;EBP = World-ptr
	mov	ds:[@@World_Ptr],eax
	mov	ds:[@@Camera_Ptr],ebx
	mov	ds:[GVE_Old_Frame_Buffer],ecx
	mov	ds:[GVE_Frame_Buffer],edx

	mov	eax,ds:[ebp+World_Flags]	;EAX = World flags
	mov	ebx,ds:[ebp+World_TextureMap_List];EBX = Texture-list
	mov	ecx,ds:[ebp+World_PhongMap_List];ECX = Texture-list
	mov	edx,ds:[ebp+World_Object_List]	;EDX = Object-List
	mov	esi,ds:[ebp+World_Light_List]	;ESI = Light-List
	mov	edi,ds:[ebp+World_BumpMap_List]	;EDI = Bump-List
	mov	ds:[@@WrldFLags],eax
	mov	ds:[GVE_Texture_List],ebx
	mov	ds:[GVE_PhongMap_List],ecx
	mov	ds:[@@Object_List],edx
	mov	ds:[@@Light_List],esi
	mov	ds:[GVE_BumpMap_List],edi
	mov	eax,ds:[ebp+World_Shading_LUT]
	mov	ebx,ds:[ebp+World_Bump_LUT]
	mov	ecx,ds:[ebp+World_Glass_LUT]
	mov	edx,ds:[ebp+World_Blurr_LUT]
	mov	ds:[GVE_SHading_LUT],eax
	mov	ds:[GVE_Bump_LUT],ebx
	mov	ds:[GVE_Glass_LUT],ecx
	mov	ds:[GVE_Blurr_LUT],edx

	;
	;   GOMEZ VECTOR ENGINE                              Profiling-stuff
	;
	ifdef GVE_PROFILER
	 ifdef GVE_EXACT_FRAME_SPEED
	  mov	eax,ds:[GVE_Timer]
	  mov	ds:[PROFILING_STAMPS],eax
	 else
	  mov	eax,ds:[CURRENT_STAMP]
	  lea	ebx,[eax+1]
	  mov	ecx,ds:[4*eax+PROFILING_STAMPS]
	  and	ebx,0fh
	  mov	eax,ds:[GVE_Timer]		;EAX = New time stamp
	  sub	ecx,ds:[4*ebx+PROFILING_STAMPS]	;ECX = Current time for 16 frames
	  mov	ds:[4*ebx+PROFILING_STAMPS],eax	;Save new time stamp
	  mov	ds:[CURRENT_STAMP],ebx		;Save new stamp counter
	  jz	short @@J8

	  mov	eax,256*16*GVE_TIMER_SPEED
	  xor	edx,edx
	  idiv	ecx				;EAX = fps*256
	  mov	ds:[GVE_Frame_Speed],eax
@@J8:	 endif
	endif


	;
	;   GOMEZ VECTOR ENGINE                              Initialisation
	;
	mov	ebx,ds:[GVE_ORder_List]
	xor	eax,eax
	mov	ds:[ebx],eax			;Clear order list
	mov	ds:[@@ProfVertex_Counter],eax
	mov	eax,ds:[GVE_Frame_Width]
	mov	ebx,ds:[GVE_Frame_Height]
	shl	eax,15
	shr	ebx,1
	mov	d ds:[@@W2-4],eax
	mov	d ds:[@@H2-4],ebx
	;
	mov	esi,ds:[@@Camera_Ptr]
	mov	eax,ds:[esi+Camera_Distance]	;EAX = Distance
	imul	ds:[GVE_Frame_Height]
	imul	ds:[GVE_Frame_Aspect_Ratio]
	mov	ebx,640
	idiv	ebx
	mov	ds:[@@FactorX],eax

	mov	eax,ds:[esi+Camera_Distance]
	mov	ebx,480
	imul	ds:[GVE_Frame_Height]
	idiv	ebx
	mov	ds:[@@FactorY],eax


	;
	;   GOMEZ VECTOR ENGINE                               Preprocessing
	;
	;
	;
	; First lets preprocess the old screen with blurring etc... if
	; desired, or lets simply clear the buffer
	;
	;
	mov	eax,ds:[GVE_Frame_Depth]
	ifdef	GVE_RASTER8
	 cmp	al,8
	 je	short @@F86
	endif
	ifdef	GVE_RASTER16
	 cmp	al,16
	 jbe	short @@F166
	endif
	ifdef	GVE_RASTER32
	 cmp	al,32
	 je	@@F326
	endif
	;
	ifdef 	GVE_RASTER8
@@F86:	 test	ds:[@@WrldFLags],GVE_FLAG_CLEAR_FRAME
	 jz	short @@F87
	 mov 	edi,ds:[GVE_Frame_Buffer]
	 mov 	ecx,ds:[GVE_Frame_Width]
	 imul	ecx,ds:[GVE_Frame_Height]
	 shr	ecx,2
	 xor 	eax,eax
	 rep   	stosd
	 jmp	@@DoLIG

@@F87:	 test	ds:[@@WrldFLags],GVE_FLAG_MOTION_TRACE
	 jz	short @@F88
		mov 	esi,ds:[GVE_Old_Frame_Buffer]
		mov 	edi,ds:[GVE_Frame_Buffer]
		call	FX8_Motion_Trace
		jmp	@@DoLIG

@@F88:	 test	ds:[@@WrldFLags],GVE_FLAG_FEED_BACK
	 jz	short @@DoLIG
		mov 	esi,ds:[GVE_Old_Frame_Buffer]
		mov 	edi,ds:[GVE_Frame_Buffer]
		call	FX8_Feed_Back
		jmp	short @@DoLIG
	 endif
	;
	ifdef	GVE_RASTER16
@@F166:	 test	ds:[@@WrldFLags],GVE_FLAG_CLEAR_FRAME
	 jz	short @@F167
	 mov 	edi,ds:[GVE_Frame_Buffer]
	 mov 	ecx,ds:[GVE_Frame_Width]
	 imul	ecx,ds:[GVE_Frame_Height]
	 shr	ecx,1
	 xor 	eax,eax
	 rep   	stosd
	 jmp	short @@DoLIG

@@F167:	 test	ds:[@@WrldFLags],GVE_FLAG_MOTION_TRACE
	 jz	short @@F168
		mov 	esi,ds:[GVE_Old_Frame_Buffer]
		mov 	edi,ds:[GVE_Frame_Buffer]
		call	FX16_Motion_Trace
		jmp	@@DoLIG

@@F168:	 test	ds:[@@WrldFLags],GVE_FLAG_FEED_BACK
	 jz	short @@DoLIG
		mov 	esi,ds:[GVE_Old_Frame_Buffer]
		mov 	edi,ds:[GVE_Frame_Buffer]
		call	FX16_Feed_Back
		jmp	@@DoLIG
	endif
	;
	ifdef	GVE_RASTER32
@@F326:	 test	ds:[@@WrldFLags],GVE_FLAG_CLEAR_FRAME
	 jz	short @@F327
	 mov 	edi,ds:[GVE_Frame_Buffer]
	 mov 	ecx,ds:[GVE_Frame_Width]
	 imul	ecx,ds:[GVE_Frame_Height]
	 xor 	eax,eax
	 rep   	stosd
	 jmp	@@DoLIG

@@F327:	 test	ds:[@@WrldFLags],GVE_FLAG_MOTION_TRACE
	 jz	short @@F328
		mov 	esi,ds:[GVE_Old_Frame_Buffer]
		mov 	edi,ds:[GVE_Frame_Buffer]
		call	FX32_Motion_Trace
		jmp	@@DoLIG

@@F328:	 test	ds:[@@WrldFLags],GVE_FLAG_FEED_BACK
	 jz	short @@DoLIG
		mov 	esi,ds:[GVE_Old_Frame_Buffer]
		mov 	edi,ds:[GVE_Frame_Buffer]
		call	FX32_Feed_Back
		jmp	@@DoLIG
	endif


	;
	;   GOMEZ VECTOR ENGINE                      Light source processing
	;
@@DoLIG:;
	;
	; Now lets get the global light vector from GVE_Light_Matrix
	;
	ifdef GVE_MULTI_LIGHTS

	endif



@@DoOBJ:;
	;   GOMEZ VECTOR ENGINE                         Object transformation
	;
	;
	;
	; Main object loop starts here. We do four things with all objects:
	;	1.  Build final object transformation matrix
	;	    calc local viewer position
	;	    calc local viewer direction
	;	2.  Generate local light vector
	;	3.  Perform backface culling,
	;	    write face-ptr into sort-list
	;	4.  Transform vertices, if needed
	;
	mov	esi,ds:[@@Object_List]
	mov	eax,ds:[esi]			;EAX = object-counter
	add	esi,4				;Skip header
	test	eax,eax
	jz      @@DoSort

	mov	ds:[@@Object_Counter],eax	;Save it here
@@L1:   push	esi				;ESI = index in object-list
	mov	esi,ds:[esi]			;ESI = ptr to object header
	mov	ch,3				;CH = Row counter for matmul
	push	esi				;Save this ptr, too
	test	esi,esi
	jz	@@NObj
	test	ds:[esi+Object_Flags],GVE_OBJ_HIDE
	jnz	@@NObj

	;
	;
	; Here we calculate the final trasnformation matrix of the object.
	; The result will be available at DS:EDI
	;
	mov	ebx,ds:[@@Camera_Ptr]		;EBX = Camera
	mov	eax,ds:[esi+Object_Flags]       ;EAX = Object-flags
	lea	ebp,[esi+Object_Local_Matrix]	;EBP = Local transformation matrix
	mov	ds:[@@ObjFLags],eax		;Save flags...
	lea	edi,[esi+Object_Final_Matrix]
	lea	esi,[ebx+Camera_Matrix]
	call	GVE_Mult_Matrix       	      	;DS:EDI = A*B


	;
	;
	; Now we perform a quick visibility-check by using the bounding
	; volume of the whole object
	;
	mov	esi,ss:[esp]			;ESI = Object-header




	;
	;
	; Now lets get the local light vector from GVE_Light_Matrix by
	; rotating the light-source backwards via transposed matrix
	;
	ifdef GVE_MULTI_LIGHTS
	 mov    esi,ds:[@@Light_List]
	 mov	ecx,ds:[esi]			;ECX = Number of lights
	 add	esi,4
	 @@L6:  lodsd				;EAX = Lightsource
		push	ecx
		push	esi
		lea	esi,[eax+Light_Direction]
		lea	edi,[eax+Light_Object_Direction]
		TRANSPOSED_MULT_VECTOR ebp,esi,edi,MV_MULT_3x3
		pop	esi
		pop	ecx
		dec	ecx
		jnz	short @@L6
	else
	 mov	esi,ds:[@@Light_List]
	 mov	esi,ds:[esi+4]			;ESI = ptr to first light
	 TRANSPOSED_MULT_VECTOR edi,(esi+Light_Direction),Object_Light_Direction,MV_MULT_3x3
	endif


	;
	;
	; Now we calculate the reverse viewer direction and position
	;
	ifdef GVE_CULL_FIRST
	 mov	eax,ds:[edi+E14]		;X
	 mov	ebx,ds:[edi+E24]		;Y
	 mov	ecx,ds:[edi+E34]		;Z
	 TRANSPOSED_MULT_VECTOR edi,0,Object_View_Position,MV_MULT_3x3+MV_REG_INIT
	 ;
	 mov	eax,ds:[edi+E31]		;Local view direction X
	 mov	ds:[Object_View_Direction.E1],eax
	 imul	ds:[Object_View_Position.E1]
	 mov	ebx,eax
	 mov	ecx,edx				;ECX:EBX = result
	 mov	eax,ds:[edi+E32]		;Local view direction Y
	 mov	ds:[Object_View_Direction.E2],eax
	 imul	ds:[Object_View_Position.E2]
	 add	ebx,eax
	 adc	ecx,edx				;ECX:EBX = result
	 mov	eax,ds:[edi+E33]		;Local view direction Z
	 mov	ds:[Object_View_Direction.E3],eax
	 imul	ds:[Object_View_Position.E3]
	 add	eax,ebx
	 adc	edx,ecx				;EAX:EDX = result
	 shrd	eax,edx,GVE_MATH_SHIFT
	endif


	;
	;
	; Now lets perform some back-culling etc...
	;
	ifdef GVE_CULL_FIRST
	 PROF_START_AREA 4
	 mov	dword ptr ds:[@@C1-4],eax
	 mov	dword ptr ds:[@@C2-4],eax
	 mov	esi,ss:[esp]			;ESI = ptr to object-header
	 test	ds:[@@ObjFLags],GVE_BACK_CULLING
	 jz	@@All

	 mov	esi,ds:[esi+Object_Face_List]	;ESI = ptr to primitives
	 mov	edi,ds:[GVE_Order_List]		;EDI = ptr to draw-list
	 test	esi,esi
	 jz	@@Form
	 mov	ecx,ds:[esi]			;ECX = number of primitives
	 mov	ebx,ds:[edi]			;EBX = current size of order-list
	 test	ecx,ecx
	 jz	@@Form
	 add	esi,4				;Skip primitive counter
	 lea	edi,[edi+4+8*ebx]		;EDI = ptr to first new entry
	 @@L3: 	;                              
		mov	eax,ds:[esi+8]
		imul	ds:[Object_View_Position.E1]
		mov	ebx,eax
		mov	ebp,edx			;EBP:EBX = A*x
		mov	eax,ds:[esi+12]
		imul	ds:[Object_View_Position.E2]
		add	ebx,eax
		adc	ebp,edx			;EBP:EBX = A*x + B*y
		mov	eax,ds:[esi+16]
		imul	ds:[Object_View_Position.E3]
		add	eax,ebx
		adc	edx,ebp			;EDX:EAX = A*x + B*y + C*z
		shrd	eax,edx,GVE_MATH_SHIFT
		mov	ebp,ds:[esi+24]		;EBP = ptr to first vertex
		add	eax,ds:[esi+20]
		js	short @@No1		;JS: Face is not visible
		;                              
		mov	eax,ds:[ebp+VertexX]
		imul	ds:[Object_View_Direction.E1]
		shrd	eax,edx,GVE_MATH_SHIFT
		mov	ebx,eax
		mov	eax,ds:[ebp+VertexY]
		imul	ds:[Object_View_Direction.E2]
		shrd	eax,edx,GVE_MATH_SHIFT
		add	ebx,eax
		mov	eax,ds:[ebp+VertexZ]
		imul	ds:[Object_View_Direction.E3]
		shrd	eax,edx,GVE_MATH_SHIFT
		add	eax,ebx
		sub	eax,12345678h		;
	 @@C1: 	jg	short @@No1		;JG: Face is not visible
		;                              
		mov	ds:[edi+4],eax		;Save sorting key
		mov	eax,ds:[esi+24]		;EAX = ptr to 1st vertex
		mov	ebx,ds:[esi+28]         ;EBX = ptr to 2nd vertex
		mov	edx,ds:[esi+32]		;EDX = ptr to 3rd vertex
		mov	ds:[edi],esi		;Save Object address
		or	byte ptr ds:[eax+Vertex_ScreenX],1
		or	byte ptr ds:[ebx+Vertex_ScreenX],1
		or	byte ptr ds:[edx+Vertex_ScreenX],1
		add	edi,8			;EDI = ptr to next list-entry
	 @@No1:	movzx	eax,word ptr ds:[esi]	;EAX = size of primitive
		add	esi,eax			;ESI = ptr to next primitive
		dec	ecx
		jnz	@@L3
	 PROF_END_AREA 4
	 ;
	 mov	ebp,ds:[GVE_Order_List]
	 sub	edi,ebp				;EDI = size of order list
	 sub	edi,4
	 shr	edi,3                   	;EDI = Number of entries in sort-list
	 mov	ds:[ebp],edi			;Save number of visible faces...
	 jmp	@@Form				;Jump to transformations
	 ;
@@All:	 mov	esi,ds:[esi+Object_Face_List]	;ESI = ptr to primitives
	 mov	edi,ds:[GVE_Order_List]		;EDI = ptr to draw-list
	 mov	ecx,ds:[esi]			;ECX = number of primitives
	 mov	ebx,ds:[edi]			;EBX = current size of order-list
	 add	esi,4				;Skip primitive counter
	 lea	edi,[edi+4+8*ebx]		;EDI = ptr to first new entry
	 @@L4: 	;                              
		mov	ebp,ds:[esi+24]		;EBP = ptr to first vertex
		mov	eax,ds:[ebp+VertexX]
		imul	ds:[Object_View_Direction.E1]
		shrd	eax,edx,GVE_MATH_SHIFT
		mov	ebx,eax
		mov	eax,ds:[ebp+VertexY]
		imul	ds:[Object_View_Direction.E2]
		shrd	eax,edx,GVE_MATH_SHIFT
		add	ebx,eax
		mov	eax,ds:[ebp+VertexZ]
		imul	ds:[Object_View_Direction.E3]
		shrd	eax,edx,GVE_MATH_SHIFT
		add	eax,ebx
		sub	eax,12345678h		;
	 @@C2:	jg	short @@No2		;JG: Face is not visible
		;                              
		mov	ds:[edi+4],eax		;Save sorting key
		mov	eax,ds:[esi+24]		;EAX = ptr to 1st vertex
		mov	ebx,ds:[esi+28]         ;EBX = ptr to 2nd vertex
		mov	edx,ds:[esi+32]		;EDX = ptr to 3rd vertex
		mov	ds:[edi],esi		;Save Object address
		or	byte ptr ds:[eax+Vertex_ScreenX],1
		or	byte ptr ds:[ebx+Vertex_ScreenX],1
		or	byte ptr ds:[edx+Vertex_ScreenX],1
		add	edi,8			;EDI = ptr to next list-entry
	 @@No2:	movzx	eax,word ptr ds:[esi]	;EAX = size of primitive
		add	esi,eax			;ESI = ptr to next primitive
		dec	ecx
		jnz	@@L4
	 PROF_END_AREA 4
	 ;
	 mov	ebp,ds:[GVE_Order_List]
	 sub	edi,ebp				;EDI = size of order list
	 sub	edi,4
	 shr	edi,3                   	;EDI = Number of entries in sort-list
	 mov	ds:[ebp],edi			;Save number of visible faces...
	endif


	;
	;
	; Transformation of vertices
	;
@@Form: PROF_START_AREA 0
	mov	esi,ss:[esp]			;ESI = ptr to object header
	lea	edi,[esi+Object_FInal_Matrix]	;EDI = ptr to transformation matrix
	mov	esi,ds:[esi+Object_Vertex_List]	;ESI = ptr to vertex list
	test	esi,esi
	jz	@@NObj
	mov	eax,ds:[esi]			;EAX = vertex counter
	add	esi,4
	test	eax,eax
	jz	@@NObj
	mov	ds:[@@Vertex_Counter],eax


	@@L5:   ;
		;
		; The main transformation loop starts here:
		;
		;   1.  Transformation of vertex
		;   2.  Transformation of normal   (optional)
		;   3.  Vertex shading   (optional)
		;   4.  Projection
		;
		ifdef GVE_CULL_FIRST
		 test  	byte ptr ds:[esi+Vertex_ScreenX],1
		 jz	@@J3
		endif
		MULT_VECTOR edi,esi+VertexX,esi+Vertex@X,MV_MULT_4x4

		;
		;
		; Project of the 3D view-space coordinates to 2D screen space.
		; Note the following thing:
		;
		;	PX is stored as a 16.16 bit integer with the
		;         lowest bit used as a flag whether transformation
		;         is necessary for this vertex
		;      PY is stored as an 32.0 integer
		;
		mov     ebx,ds:[esi+Vertex@Z]	;EBX = Z
		xor	ecx,ecx
		mov	ebp,ebx
		mov 	eax,ds:[esi+Vertex@X]	;EAX = X
		sar	ebp,1			;EBP = Z/2
		jng	@@Skip
		sub	ecx,ebp			;ECX = -Z
		imul	ds:[@@FactorX]		;EAX = X*Distance
		cmp	edx,ebp
		jge	@@Skip
		cmp	edx,ecx
		jle	@@Skip
		idiv 	ebx			;EAX = (X * Distance) / Z
		add	eax,12345678h		;(DISPLAY_Width/2) shl 16
	@@W2:	and	al,0feh			;Clear transformation flag
		mov	ds:[esi+Vertex_ScreenX],eax

		mov 	eax,ds:[esi+Vertex@Y]
		imul	ds:[@@FactorY]
		cmp	edx,ebp
		jge	@@Skip
		cmp	edx,ecx
		jle	@@Skip
		idiv 	ebx
		add	eax,12345678h		;DISPLAY_Height/2
	@@H2:	mov	ds:[esi+Vertex_ScreenY],eax
		inc	ds:[@@ProfVertex_Counter]

		;
		;
		; Now transform the surface normal (if desired)
		;
		test	ds:[@@ObjFLags],GVE_OBJ_NORMALS
		jz	@@J2
		MULT_VECTOR edi,esi+Vertex_Normal,esi+Vertex_Normal@X,MV_MULT_3x3

		ifdef GVE_SPHERICAL_CHROME
		 mov	edx,ds:[esi+Vertex_Normal@X]	;Get Normal_Y
		 mov	eax,ds:[esi+Vertex_Normal@Y]	;Get Normal_X
		 sar	edx,GVE_NORMAL_SHIFT-GVE_ASINE_SHIFT+1
		 sar	eax,GVE_NORMAL_SHIFT-GVE_ASINE_SHIFT+1
		 mov	edx,ds:[ASinTab+4*edx+GVE_ASINE_SIZE*2+4]
		 mov	eax,ds:[ASinTab+4*eax+GVE_ASINE_SIZE*2+4]
		 mov	ds:[esi+Vertex_ChromeX],edx
		 mov	ds:[esi+Vertex_ChromeY],eax
		else
		 mov	edx,ds:[esi+Vertex_Normal@X]	;Get Normal_Y
		 mov	eax,ds:[esi+Vertex_Normal@Y]	;Get Normal_X
		 add	edx,1 shl GVE_NORMAL_SHIFT
		 add	eax,1 shl GVE_NORMAL_SHIFT
		 shl	edx,15-GVE_NORMAL_SHIFT		;Texture u  (8:8 bit FP)
		 shl	eax,15-GVE_NORMAL_SHIFT		;Texture v  (8:8 bit FP)
		 mov	ds:[esi+Vertex_ChromeX],edx
		 mov	ds:[esi+Vertex_ChromeY],eax
		endif

		;
		;
		; Now perform vertex shading
		;
	@@J2:	test	ds:[@@ObjFLags],GVE_OBJ_VERTEX_SHADING
		jz	short @@J3
		mov	ebx,ds:[esi+Vertex_NormalX]	;Get Normal_X
		mov   	eax,ds:[esi+Vertex_NormalY]	;Get Normal_Y
		imul	ebx,d ds:[Object_Light_Direction.VectorX]
		imul	d ds:[Object_Light_Direction.VectorY]
		add	ebx,eax
		mov   	eax,ds:[esi+Vertex_NormalZ]	;Get Normal_Z
		imul	d ds:[Object_Light_Direction.VectorZ]
		add	eax,ebx				;EAX = dot product
		sar	eax,GVE_MATRIX_SHIFT+GVE_NORMAL_SHIFT-GVE_SHAD_SHIFT
		mov	ds:[esi+Vertex_Shading],eax
		;
	@@J3:	add 	esi,GVE_VERTEX_SIZE	;Go to the Skip vector...
		dec 	ds:[@@Vertex_Counter]
		jnz 	@@L5
		jmp	short @@Cont

	@@Skip: mov	ds:[esi+Vertex@Z],(-1 shl 28)
		add 	esi,GVE_VERTEX_SIZE	;Go to the Skip vector...
		dec 	ds:[@@Vertex_Counter]
		jnz 	@@L5

@@Cont:	PROF_END_AREA 0


	;
	;
	; Here we perform a second visible surface determination
	;
	ifdef GVE_CULL_AFTER
	PROF_START_AREA 4
	mov	esi,ss:[esp]			;ESI = ptr to object-header
	mov	al,72h				;JB opcode
	test	ds:[@@ObjFLags],GVE_OBJ_BACK_CULLING
	jnz	short @@J7
	mov	al,0ebh				;JMP opcode
@@J7:   mov	byte ptr ds:[@@C7-2],al		;Save opcode
	;
	mov	esi,ds:[esi+Object_Face_List]	;ESI = ptr to primitives
	mov	edi,ds:[GVE_Order_List]		;EDI = ptr to draw-list
	test	esi,esi
	jz	@@NObj
	mov	eax,ds:[esi]			;EAX = number of primitives
	mov	ebx,ds:[edi]			;EBX = current size of order-list
	test	eax,eax
	jz	@@NObj
	mov	ds:[@@Face_Counter],eax
	add	esi,4				;Skip primitive counter
	lea	edi,[edi+4+8*ebx]		;EDI = ptr to first new entry
	@@L3:  	;                              
		ifdef GVE_TRIVIAL_REJECT
		SET_MINMAX MACRO src,min,max
		LOCAL J1,J2,J3,J4,J5,J6
		cmp	min,src
		jl	short J1
			mov	min,src
			jmp	short J2
	J1:	cmp	max,src
		jg	short J2
			mov	max,src
	J2:	ENDM

		mov	edx,ds:[esi+24]		;EBX = ptr to 1st vertex
		mov	eax,ds:[edx+Vertex_ScreenX]
		mov	ebx,ds:[edx+Vertex_ScreenY]
		mov	edx,ds:[esi+24+4]	;EBX = ptr to 2nd vertex
		mov	ds:[@@PolyMinX],eax
		mov	ds:[@@PolyMaxX],eax
		mov	ds:[@@PolyMinY],ebx
		mov	ds:[@@PolyMaxY],ebx
		mov	eax,ds:[edx+Vertex_ScreenX]
		mov	ebx,ds:[edx+Vertex_ScreenY]
		mov	edx,ds:[esi+24+8]	;EBX = ptr to 3rd vertex
		SET_MINMAX eax,ds:[@@PolyMinX],ds:[@@PolyMaxX]
		SET_MINMAX ebx,ds:[@@PolyMinY],ds:[@@PolyMaxY]
		mov	eax,ds:[edx+Vertex_ScreenX]
		mov	ebx,ds:[edx+Vertex_ScreenY]
		SET_MINMAX eax,ds:[@@PolyMinX],ds:[@@PolyMaxX]
		SET_MINMAX ebx,ds:[@@PolyMinY],ds:[@@PolyMaxY]

		mov	eax,ds:[@@PolyMinX]
		mov	ebx,ds:[@@PolyMaxX]
		sar	eax,16
		sar	ebx,16
		cmp	eax,ds:[GVE_Clip_X2]
		jg	short @@NoAdd
		cmp	ebx,ds:[GVE_Clip_X1]
		jl	short @@NoAdd

		mov	eax,ds:[@@PolyMinY]
		mov	ebx,ds:[@@PolyMaxY]
		cmp	eax,ds:[GVE_Clip_Y2]
		jg	short @@NoAdd
		cmp	ebx,ds:[GVE_Clip_Y1]
		jl	short @@NoAdd
		endif
		;                              
		cmp   	byte ptr ds:[esi+3],3	;Get number of vertices
		jb	short @@NoRm
	@@C7:	TEST_BACK_CULLING_2D		;Test for back-culling
		js	short @@NoAdd		;JS: Face is not visible
	@@NoRm:	mov 	ebx,ds:[esi+24] 	;EBP = ptr to 1st vertex
		mov 	ecx,ds:[esi+24+1*4] 	;EBX = ptr to 2nd vertex
		mov 	edx,ds:[esi+24+2*4] 	;EDX = ptr to 3rd vertex
		mov	eax,ds:[ebx+Vertex@Z]	;EAX = 1st Z-coordinate
		add	eax,ds:[ecx+Vertex@Z]	;EAX += 2nd Z coordinate
		add	eax,ds:[edx+Vertex@Z]	;EAX += 3rd Z coordinate

		cmp	eax,1 shl (GVE_DISTANCE+2)
		jle	short @@NoAdd
		mov	ds:[edi],esi		;Save Object address
		mov	ds:[edi+4],eax		;Save average z-Coordinate
		add	edi,8			;EDI = ptr to next list-entry
		;                              
	@@NoAdd:movzx	eax,word ptr ds:[esi]	;Get size of primitive
		add	esi,eax			;Add to source-address
		dec	ds:[@@Face_Counter]
		jnz	@@L3
	;
	mov	ebp,ds:[GVE_Order_List]
	sub	edi,ebp				;EDI = size of order list
	sub	edi,4
	shr	edi,3                   	;EDI = Number of entries in sort-list
	mov	ds:[ebp],edi			;Save number of saved objects...
	PROF_END_AREA 4
	endif
	;
@@NObj: pop	eax				;EAX = ptr to object-header (trash)
	pop	esi				;ESI = object-list index
	add	esi,4
	dec	ds:[@@Object_Counter]
	jnz	@@L1


@@DoSort:
	;
	;   GOMEZ VECTOR ENGINE                             Sorting & Drawing
	;
	;
	;
	; Sorting all triangles for painters algorithm
	;
	;
	mov	ebp,ds:[GVE_Order_List]		;EBP = ptr to order-list
	mov	ecx,ds:[@@ProfVertex_Counter]	;ECX = number of transformed vertices
	mov	edx,ds:[ebp]			;EDX = number of faces
	PROF_SET_COUNTER 7,ecx
	PROF_SET_COUNTER 8,edx
	test	edx,edx				;Nothing to do ?
	jz	@@NoDraw
	test	ds:[@@WrldFLags],GVE_FLAG_NOSORT
	jnz	short @@NoSort
	PROF_START_AREA	1
	lea	esi,[ebp+4]			;ESI points to first entry
;	lea	edi,[ebp+32000]			;EDI points to destination
;	mov	ecx,BYTE_SORT_SIZE
	call	Quicker_Sort            	;Sort list !
	PROF_END_AREA 1


@@NoSort:
	;
	;
	; The main drawing loop which draws simply the odrered list.
	; Method used is to draw from back to front.
	;
	;
	PROF_START_AREA 2
	mov 	ebp,ds:[GVE_Order_List]
	mov	eax,ds:[ebp]		;Get number of primitives
	mov 	ds:[@@Face_Counter],eax
	add	ebp,4			;Skip counter
@@L6:   mov 	esi,ds:[ebp]		;ESI = primitive pointer
	xor	eax,eax			;EAX = Zero
	add	ebp,8			;EBP = ptr to next entry
	mov 	al,byte ptr ds:[esi+2]	;EAX = primitive type
	call	dword ptr ds:[GVE_Method_Table8+eax]
MTBL:	dec 	ds:[@@Face_Counter]
	jnz	short @@L6
	PROF_END_AREA 2



@@NoDraw:
	;
	;   GOMEZ VECTOR ENGINE                              Postprocessing
	;
	;
	;
	; Last but not least, zthe GVE supports some sort of postprocessing
	; like softening etc. This is done here:
	;
	;
	PROF_START_AREA 3
	mov	eax,ds:[GVE_Frame_Depth]
	cld
	ifdef	GVE_RASTER8
	 cmp	al,8
	 je	short @@F81
	endif
	ifdef	GVE_RASTER16
	 cmp	al,16
	 jbe	short @@F161
	endif
	ifdef	GVE_RASTER32
	 cmp	al,32
	 je	@@F321
	endif
	;
	ifdef	GVE_RASTER8
@@F81:	 test	ds:[@@WrldFLags],GVE_FLAG_SOFTEN_HORIZONTAL
	 jz	short @@F82
		mov 	esi,ds:[GVE_Old_Frame_Buffer]
		mov	edi,ds:[GVE_Frame_Buffer]
		call	FX8_Soften_Horizontal
@@F82:	 test	ds:[@@WrldFLags],GVE_FLAG_SOFTEN_VERTICAL
	 jz	short @@F83
		mov 	esi,ds:[GVE_Old_Frame_Buffer]
		mov	edi,ds:[GVE_Frame_Buffer]
		call	FX8_Soften_Vertical
@@F83:	 test	ds:[@@WrldFLags],GVE_FLAG_MOTION_BLURR
	 jz	short @@F84
		mov 	esi,ds:[GVE_Old_Frame_Buffer]
		mov 	edi,ds:[GVE_Frame_Buffer]
		call	FX8_Motion_Blurr
@@F84:   jmp	@@EFX
	endif
	;
	ifdef	GVE_RASTER16
@@F161:	 test	ds:[@@WrldFLags],GVE_FLAG_SOFTEN_HORIZONTAL
	 jz	short @@F162
		mov 	esi,ds:[GVE_Old_Frame_Buffer]
		mov	edi,ds:[GVE_Frame_Buffer]
		call	FX16_Soften_Horizontal
@@F162:	 test	ds:[@@WrldFLags],GVE_FLAG_SOFTEN_VERTICAL
	 jz	short @@F163
		mov 	esi,ds:[GVE_Old_Frame_Buffer]
		mov	edi,ds:[GVE_Frame_Buffer]
		call	FX16_Soften_Vertical
@@F163:	 test	ds:[@@WrldFLags],GVE_FLAG_MOTION_BLURR
	 jz	short @@F164
		mov 	esi,ds:[GVE_Old_Frame_Buffer]
		mov 	edi,ds:[GVE_Frame_Buffer]
		call	FX16_Motion_Blurr
@@F164:	 jmp	@@EFX
	endif
	;
	ifdef	GVE_RASTER32
@@F321:	 test	ds:[@@WrldFLags],GVE_FLAG_SOFTEN_HORIZONTAL
	 jz	short @@F322
		mov 	esi,ds:[GVE_Old_Frame_Buffer]
		mov	edi,ds:[GVE_Frame_Buffer]
		call	FX32_Soften_Horizontal
@@F322:	 test	ds:[@@WrldFLags],GVE_FLAG_SOFTEN_VERTICAL
	 jz	short @@F323
		mov 	esi,ds:[GVE_Old_Frame_Buffer]
		mov	edi,ds:[GVE_Frame_Buffer]
		call	FX32_Soften_Vertical
@@F323:	 test	ds:[@@WrldFLags],GVE_FLAG_MOTION_BLURR
	 jz	short @@F324
		mov 	esi,ds:[GVE_Old_Frame_Buffer]
		mov 	edi,ds:[GVE_Frame_Buffer]
		call	FX32_Motion_Blurr
@@F324:	endif
@@EFX:	;
	PROF_END_AREA 3

	;
	;
	; Finally, the end !
	;
@@End:  ifdef GVE_PROFILER
	 ifdef GVE_EXACT_FRAME_SPEED
	  mov	ecx,ds:[GVE_Timer]
	  mov	eax,256*GVE_TIMER_SPEED
	  sub	ecx,ds:[PROFILING_STAMPS]
	  jz	short @@J8
	  xor	edx,edx
	  idiv	ecx				;EAX = fps*256
	  mov	ds:[GVE_Frame_Speed],eax
@@J8:	 endif
	endif
	;
	clc
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop 	ds
	retn
	;
	ALIGN	dword
	@@ProfVertex_Counter	dd	?
	@@ObjFlags		dd	?
	@@WrldFlags		dd	?
	@@World_Ptr		dd	?
	@@Camera_Ptr		dd	?
	@@Light_List		dd      ?
	@@Object_List		dd	?
	@@Object_Counter	dd	?
	@@Vertex_Counter	dd	?
	@@Face_Counter		dd	?
	@@factorX		dd	?
	@@factorY		dd	?
	@@PolyMinX		dd	?
	@@PolyMaxX		dd	?
	@@PolyMinY		dd	?
	@@PolyMaxY		dd	?
GVE_Draw_World ENDP



;
;   GOMEZ VECTOR ENGINE  pro                      World Initialisation code
;
;
;
; GVE_Init_World:
;   This routine is designed to initialise lots of things in a just loaded
;   vector world.
;
; Input:
;   EAX	- ptr to header
; Output:
;   GVE_???
; Destroys:
;   EAX,EBX,ECX,EDX,FS,GS
;
PUBLIC C GVE_Init_World
GVE_Init_World PROC NEAR
	push	ds
	push	es
	push 	ebp
	push 	esi
	push 	edi

	cld

	;
	;   GOMEZ VECTOR ENGINE                                Global setup
	;
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	mov	ds:[@@World_Ptr],eax

	mov	edx,ds:[eax+World_Object_List]
	mov	ds:[@@Object_List],edx
	mov	edx,ds:[eax+World_Light_List]
	mov	ds:[@@Light_List],edx
	mov	edx,ds:[eax+World_Camera_List]
	mov	ds:[@@Camera_List],edx
	;
	ifdef GVE_RASTER8
	 cmp	ds:[GVE_Frame_Depth],8
	 jne	short @@J1
	 mov	edx,ds:[eax+World_Shading_LUT8]
	 mov	ds:[eax+World_Shading_LUT],edx
	 mov	edx,ds:[eax+World_Bump_LUT8]
	 mov	ds:[eax+World_Bump_LUT],edx
	 mov	edx,ds:[eax+World_Glass_LUT8]
	 mov	ds:[eax+World_Glass_LUT],edx
	endif
	;
@@J1:   mov	esi,ds:[@@Object_List]		;ESI = ptr to obj-list
	mov	ebp,ds:[esi]			;EBP = number of objects
	test	ebp,ebp
	jz	short @@1
	@@L1:   mov	eax,ds:[@@world_ptr]
		mov	edx,ds:[esi+4*ebp]	;EDX = object address
		call	GVE_Move_Object		;Init object matrices
		dec	ebp
		jnz	short @@L1		;Loop !
@@1:	mov	esi,ds:[@@Light_List]		;ESI = ptr to light-list
	mov	ebp,ds:[esi]			;EBP = number of lights
	test	ebp,ebp
	jz	short @@2
	@@L2:   mov	eax,ds:[@@world_ptr]
		mov	edx,ds:[esi+4*ebp]	;EDX = light address
		call	GVE_Move_Light		;Init light matrices
		dec	ebp
		jnz	short @@L2		;Loop !
@@2:    mov	esi,ds:[@@Camera_List]		;ESI = ptr to camera-list
	mov	ebp,ds:[esi]			;EBP = number of cameras
	test	ebp,ebp
	jz	short @@3
	@@L3:   mov	eax,ds:[@@world_ptr]
		mov	edx,ds:[esi+4*ebp]	;EDX = camera address
		call	GVE_Move_Camera		;Init camera matrices
		dec	ebp
		jnz	short @@L3		;Loop !
@@3:
	;
	;   GOMEZ VECTOR ENGINE                       Colour speceific setup
	;
	;
	;
	; Initialisation of blurr-table. This table is VERY similar to
	; the shdaing table, but there are some (little) differences
	;
	ifdef	GVE_RASTER8
	 cmp	ds:[GVE_Frame_Depth],8
	 ja	@@16bt
	 ;
	 mov	ebp,ds:[@@world_ptr]
	 mov	ecx,256
	 call	Malloc
	 jc	@@Err
	 mov	ds:[ebp+World_Blurr_LUT],eax
	 jmp	@@pal
	endif
	;
	;
	; Now lets initialize a shading table, if we are in 15/16 bit modes
	;
@@16bt: ifdef 	GVE_RASTER16
	 cmp	ds:[GVE_Frame_Depth],15
	 jb	@@Err
	 cmp	ds:[GVE_Frame_Depth],16
	 ja	@@32bt
	 ;
	 mov	ebp,ds:[@@world_ptr]
	 mov	ecx,GVE_GLASS_LUT8_SIZE*2
	 call	Malloc
	 jc	@@Err
	 mov	ds:[ebp+World_Glass_LUT],eax

	 mov	ecx,1 shl 17
	 call	Malloc
	 jc	@@Err
	 mov	ds:[ebp+World_Blurr_LUT],eax

	 mov	ecx,GVE_SHADING_LUT8_SIZE*2
	 call	Malloc
	 jc	@@Err
	 mov	ds:[ebp+World_Shading_LUT],eax
	 jmp	@@pal
	endif
	;
	;
	; Now lets initialize a shading table, if we are in 24/32 bit modes
	;
@@32bt:	ifdef	GVE_RASTER32

	endif
	;
@@Pal:	mov	eax,ds:[@@world_ptr]
	call	GVE_Set_Palette
@@Err:	pop 	edi
	pop 	esi
	pop 	ebp
	pop	es
	pop	ds
	retn

	ALIGN		DWORD
	@@object_list	dd	?
	@@light_list	dd	?
	@@camera_list	dd	?
	@@world_ptr	dd	?
GVE_Init_World ENDP



;
;
; GVE_Set_Palette:
;   This routine tells the engine, that a new palette has been activated,
;   so the blurr/shading/glass LUTs  should be recalculated. Also called
;   by GVE_Init_World
;
;   Input:
; 	EAX	- World-header
;   Output:
;	CF	- Error flag
;
PUBLIC C GVE_Set_Palette
GVE_Set_Palette PROC NEAR
	push	ds
	push	es
	push 	ebp
	push 	esi
	push 	edi

	mov	es,cs:[DATA32_Selector]
	mov	ds,ds:[DATA32_Selector]
	mov	ds:[@@World_Ptr],eax
	mov	edx,ds:[eax+World_Light_List]
	mov	ds:[@@Light_List],edx
	;
	;
	; Initialisation of blurr-table. This table is VERY similar to
	; the shdaing table, but there are some (little) differences
	;
	ifdef	GVE_RASTER8
	 cmp	ds:[GVE_Frame_Depth],8
	 ja	@@16bt
	 ;
	 mov	ebp,ds:[@@world_ptr]
	 mov	edx,ds:[ebp+World_Shading_LUT8]
	 mov	ds:[ebp+World_Shading_LUT],edx
	 mov	edx,ds:[ebp+World_Bump_LUT8]
	 mov	ds:[ebp+World_Bump_LUT],edx
	 mov	edx,ds:[ebp+World_Glass_LUT8]
	 mov	ds:[ebp+World_Glass_LUT],edx
	 ;
	 mov	edi,ds:[ebp+World_Blurr_LUT]	;EDI = Blurr LUT
	 mov	ebp,ds:[ebp+World_Palette]	;EBP = Palette
	 mov	esi,ebp				;ESI = palette
	 xor	edx,edx
	 @@L7:  push	edx			;EDX = Counter
		movzx	eax,b ds:[ebp]
		imul	eax,GVE_BLURR_FACTOR
		shr	eax,6
		mov	dl,al

		movzx	eax,b ds:[ebp+1]
		imul	eax,GVE_BLURR_FACTOR
		shr	eax,6
		mov	dh,al

		movzx	eax,b ds:[ebp+2]
		imul	eax,GVE_BLURR_FACTOR
		shl	eax,10
		and	eax,0ff0000h
		or	eax,edx

		call	GVE_Fit_Colour
		pop	edx			;EDX = old colour index
		shr	ecx,8
		cmp	edx,ecx
		jne	short @@J4
		xor	ecx,ecx
	 @@J4: 	mov	ds:[edi],cl

		inc	edi
		add	ebp,4
		inc	dl
		jnz	@@L7
	 jmp	@@End
	endif
	;
	;
	; Now lets initialize a shading table, if we are in 15/16 bit modes
	;
@@16bt: ifdef 	GVE_RASTER16
	 cmp	ds:[GVE_Frame_Depth],15
	 jb	@@Err
	 cmp	ds:[GVE_Frame_Depth],16
	 ja	@@32bt
	 ;
	 mov	ebp,ds:[@@world_ptr]
	 mov	edi,ds:[ebp+World_Glass_LUT]	;EDI = Blurr LUT
	 mov	ebp,ds:[ebp+World_Palette]	;ESI = Palette
	 xor	ecx,ecx
@@163:	 xor	ebp,ebp
	 @@164: push	ecx
		xor	edx,edx
		movzx	eax,b ds:[esi+ebp+2]
		add	al,b [esi+ecx+2]
		adc	ah,0
		shr	eax,1
		mov	dl,al			;DL = Blue

		shl	edx,16
		movzx	eax,b ds:[esi+ebp+1]
		add	al,b [esi+ecx+1]
		adc	ah,0
		shr	eax,1
		mov	dh,al			;DL = Green

		movzx	eax,b ds:[esi+ebp]
		add	al,b [esi+ecx]
		adc	ah,0
		shr	eax,1
		mov	dl,al			;DL = Red
		REDUCE_COLOUR

		stosw
		pop	ecx
		add	ebp,4
		cmp	ebp,256*4
		jb	short @@164
	 add	ecx,4
	 cmp	ecx,256*4
	 jb	short @@163
	 ;
	 mov	ebp,ds:[@@world_ptr]
	 mov	edi,ds:[ebp+World_Blurr_LUT]	;EDI = Blurr LUT
	 mov	ecx,ds:[GVE_Frame_Depth]
	 mov	esi,1
	 shl	esi,cl				;ESI = Number of colours
	 xor	ebp,ebp				;EBP = Current colour
	 @@165: mov	eax,ebp			;EAX = Colour to process
		and	eax,11111b		;EAX = Red
		imul	eax,GVE_BLURR_FACTOR
		shr	eax,6			;EAX = Blurred Red

		cmp	ds:[GVE_Frame_Depth],16
		je	short @@166

		mov	ebx,ebp
		and	ebx,1111100000b		;EBX = Green
		imul	ebx,GVE_BLURR_FACTOR
		shr	ebx,6			;EBX = Blurred Green
		and	ebx,1111100000b
		or	eax,ebx

		mov	ebx,ebp
		and	ebx,111110000000000b	;EBX = Blue
		imul	ebx,GVE_BLURR_FACTOR
		shr	ebx,6			;EBX = Blurred Blue
		and	ebx,111110000000000b
		or	eax,ebx
		jmp	short @@167

	@@166:	mov	ebx,ebp
		and	ebx,11111100000b	;EBX = Green
		imul	ebx,GVE_BLURR_FACTOR
		shr	ebx,6			;EBX = Blurred Green
		and	ebx,11111100000b
		or	eax,ebx

		mov	ebx,ebp
		and	ebx,1111100000000000b	;EBX = Blue
		imul	ebx,GVE_BLURR_FACTOR
		shr	ebx,6			;EBX = Blurred Blue
		and	ebx,1111100000000000b
		or	eax,ebx

	@@167:	stosw
		inc	ebp
		cmp	ebp,esi
		jb	short @@165
	 ;
	 mov	ebp,ds:[@@world_ptr]
	 mov	edi,ds:[ebp+World_Shading_LUT]	;EDI = Blurr LUT
	 mov	esi,ds:[ebp+World_Palette]	;ESI = Palette
	 mov	eax,ds:[@@Light_List]
	 cmp	d ds:[eax],0
	 je	@@End
	 mov	eax,ds:[eax+4]
	 mov	edx,ds:[eax+Light_Colour]	;EDX = Light colour
	 mov	eax,ds:[ebp+World_Ambient_Light]
	 mov	ecx,ds:[eax+Ambient_Colour]	;ECX = Ambient colour
	 mov	bh,ds:[eax+Ambient_Specular]
	 xor	bl,bl				;EBX = Shade-counter
@@161:	 xor	ebp,ebp
	 @@162:	push	ebx			;EBX = Shade-counter
		push	ecx			;ECX = Ambient colour
		push	edx			;EDX = Light colour
		mov	eax,ds:[esi+4*ebp]	;EAX = original colour
		call	GVE_Shade_Colour	;EAX = resulting colour
		mov	edx,eax
		REDUCE_COLOUR

		stosw
		pop	edx
		pop	ecx
		pop	ebx
		inc	ebp                   	;Next source colour
		cmp	ebp,256
		jb	@@162			;Loop !
	 inc	bl
	 cmp	bl,64
	 jl	@@161
	endif
	;
	;
	; Now lets initialize a shading table, if we are in 24/32 bit modes
	;
@@32bt:	ifdef	GVE_RASTER32

	endif
@@End:	clc
@@Err:	pop 	edi
	pop 	esi
	pop 	ebp
	pop	es
	pop	ds
	retn

	ALIGN		DWORD
	@@light_list	dd	?
	@@world_ptr	dd	?
GVE_Set_Palette ENDP




;
;
;
;   GOMEZ VECTOR ENGINE  pro                             PROFILING SYSTEM
;
;
;
;
;
; This is a simple timer-counter used for the profiling option
;
; The profiling data is structured like this:
;	dword	-	Number of calls
;	dword	-	Total time called
;	dword	-	Longest call
;	dword	-	Current start-time
;
ifdef GVE_PROFILER
PROFILING_DATA		dd 	9*4 dup (0)
PROFILING_STAMPS	dd	16 dup (0)
CURRENT_STAMP		dd	?
Timer_RM_INT		dd 	?
Timer_PM_INT		dd	?
Timer_Counter		dd	0ffffh
;
Timer_Handler:
	push	ds
	push	eax
	mov	ds,cs:[DATA32_Selector]
	inc	ds:[GVE_Timer]
	mov	al,20h
	sub	ds:[Timer_Counter],123333h/GVE_TIMER_SPEED
	js	short @@1
	out	20h,al		;Send EOI to PIC
	pop	eax
	pop	ds
	iretd

@@1:	add	ds:[Timer_Counter],0ffffh
	pop	eax
	pop	ds
	jmp	cs:[Timer_PM_INT]
;
Print_Profiler:
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[LIN_Selector]

	cld
	mov	edi,0b8000h	 	;ES:EDI points to video RAM
	mov	esi,OFFSET PROFILER_LOGO
	mov	ecx,80*22/2
	rep	movsd

	mov	edi,9*160+44
	mov	esi,OFFSET PROFILING_DATA
	mov	ecx,7
 @@L1:	push	ecx
	push	edi
	mov	edx,ds:[esi]		;Get number of calls
	test	edx,edx
	jz	short @@No
	call	PrintHex32
	mov	edx,ds:[esi+4]
	shl	edx,4
	add	edi,13*2
	call	PrintHex32
	mov	edx,ds:[esi+8]
	shl	edx,4
	add	edi,14*2
	call	PrintHex32
	mov	eax,ds:[esi+4]
	xor	edx,edx
	shld	edx,eax,4
	shl	eax,4
	div	dword ptr ds:[esi]
	mov	edx,eax
	add	edi,15*2
	call	PrintHex32

 @@No:	pop	edi
	pop	ecx
	add	edi,160
	add	esi,16
	dec	ecx
	jnz	short @@L1


	cmp	d ds:[PROFILING_DATA+16*7],0
	je	short @@1
	mov	edi,18*160+44
	mov	edx,ds:[PROFILING_DATA+16*7+4]	;Min
	call	PrintHex32
	mov	edx,ds:[PROFILING_DATA+16*7+8]	;Max
	add	edi,12*2
	call	PrintHex32
	mov	eax,ds:[PROFILING_DATA+16*7+12]	;Total
	xor	edx,edx
	div	dword ptr ds:[PROFILING_DATA+16*7]
	mov	edx,eax
	add	edi,13*2
	call	PrintHex32
  @@1:	cmp	d ds:[PROFILING_DATA+16*8],0
	je	short @@2
	mov	edi,19*160+44
	mov	edx,ds:[PROFILING_DATA+16*8+4]	;Min
	call	PrintHex32
	mov	edx,ds:[PROFILING_DATA+16*8+8]	;Max
	add	edi,12*2
	call	PrintHex32
	mov	eax,ds:[PROFILING_DATA+16*8+12]	;Total
	xor	edx,edx
	div	dword ptr ds:[PROFILING_DATA+16*8]
	mov	edx,eax
	add	edi,13*2
	call	PrintHex32

  @@2:	mov 	ds:[v86_ah],2
	mov	ds:[v86_bh],0
	mov	ds:[v86_dx],1701h
	mov	eax,10h
	call	Invoke_Real_Int		;Set cursor

	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
;
PrintHex32:
	push	edi
	push	esi

	cld
	add	edi,0b8000h
	mov	ah,30

	mov	cl,8		;Display 8 digits
 @@L1:  rol	edx,4
	mov	al,dl
	and	al,0fh
	add	al,'0'
	cmp	al,'9'
	jbe	short @@1
	add	al,'A'-'9'-1

 @@1:	stosw
	dec	cl
	jnz	short @@L1

	mov	al,'h'
	stosw

 @@E:	pop	esi
	pop	edi
	retn

;
;
;Long2Text:
;  Input:
;	EDX	- Number to convert
;	EDI	- ptr to string
;  Output:
;	EDI	- ptr to terminating 0
;  Destroys:
;	EAX,EBBX,ECX,EDX
;
Long2Text:
	push	edi
	mov	edi,OFFSET GVE_IO_Buffer
	test 	edx,edx
	jnz 	@@NotZ
	mov	ax,'0'
	stosw
	pop	edi
	retn

@@NotZ:	test 	edx,edx
	jns 	short @@NoS
	mov 	byte ptr ds:[edi],'-'
	inc 	edi
	neg 	edx

@@NoS:  push	ebp
	mov	ebp,edi
	mov 	ebx,edx
	mov 	ecx,10000000
@@1:    xor 	edx,edx
	mov 	eax,ebx
	div 	ecx
	test 	al,al
	jnz 	short @@4
	cmp 	edi,ebp
	je 	short @@2
@@4:	add 	al,'0'
	stosb
@@2:	mov 	ebx,edx
	xor 	edx,edx
	mov 	eax,ecx
	mov 	ecx,10
	div 	ecx
	test 	eax,eax
	jz 	short @@3
	mov 	ecx,eax
	jmp 	short @@1

@@3:	mov 	byte ptr ds:[edi],0
	pop	ebp
	pop	edi
	retn
endif
CODE32 ends
END