;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
;
DISPLAY_WIDTH		equ	640
DISPLAY_HEIGHT		equ	480

GWM_WIN_TEXT		equ	1
GWM_WIN_BUTTON		equ	2
GWM_WIN_SWITCH		equ	3
GWM_WIN_LIST_BOX	equ	4
GWM_WIN_SELECT_BOX	equ	5
GWM_WIN_TEXTURE		equ	6
GWM_WIN_INTEGER		equ	7
GWM_WIN_STRINPUT	equ	8
GWM_WIN_INTINPUT	equ	9
GWM_WIN_END		equ	-1


GWM_BITMAP STRUC
	Bitmap_Name		db	32 dup (?)
	Bitmap_Magic		dd	?
	Bitmap_Type		dd	?
	Bitmap_Width		dw	?
	Bitmap_Height		dw	?
	Bitmap_Depth		db	?,?,?,?
	Bitmap_Flags		dd	?
	Bitmap_Palette		dd	?
				dd	2 dup (?)
GWM_BITMAP ENDS



CREATE_WINDOW MACRO x0,y0,width,height,s
	LOCAL WINDOW_END
	dw	(OFFSET WINDOW_END) - $	;Size
	dw	0			;Flags
	dw	x0,y0             	;Start-position
	dw	width,height
	db	s			;Header-text
	db	0			;Text-terminator
WINDOW_END:
	ENDM

ADD_WINDOW_TEXT MACRO x0,y0,s
	LOCAL ENTRY_END
	dw	(ENTRY_END) - $
	dw	GWM_WIN_TEXT
	dw	x0,y0
	db	s
	db	0
ENTRY_END:
	ENDM

ADD_WINDOW_INTEGER MACRO x0,y0
	LOCAL ENTRY_END
	dw	(ENTRY_END) - $
	dw	GWM_WIN_INTEGER
	dw	x0,y0
	dd	0
ENTRY_END:
	ENDM

ADD_WINDOW_BUTTON MACRO x0,y0,s,f
	LOCAL ENTRY_END
	dw	(ENTRY_END) - $
	dw	GWM_WIN_BUTTON
	dw	x0,y0
	dd	f			;Button-Function
	db	s                       ;Button text
	db	0			;Text terminator
ENTRY_END:
	ENDM

ADD_WINDOW_SWITCH MACRO x0,y0,s,state,bit
	LOCAL ENTRY_END
	dw	(ENTRY_END) - $
	dw	GWM_WIN_SWITCH
	dw	x0,y0
	dd	OFFSET state		;state-dword offset
	db	bit			;Bit-numebr
	db	s                       ;Button text
	db	0			;Text terminator
ENTRY_END:
	ENDM

ADD_WINDOW_LIST_BOX MACRO x0,y0,f
	LOCAL ENTRY_END
	dw	(ENTRY_END) - $
	dw	GWM_WIN_LIST_BOX
	dw	x0,y0
	dd	f
	dd	0			;List address
ENTRY_END:
	ENDM

ADD_WINDOW_SELECT_BOX MACRO x0,y0,f
	LOCAL ENTRY_END
	dw	(ENTRY_END) - $
	dw	GWM_WIN_SELECT_BOX
	dw	x0,y0
	dd	f
	dd	0			;List address
ENTRY_END:
	ENDM

ADD_WINDOW_TEXTURE  MACRO x0,y0,f
	LOCAL ENTRY_END
	dw	(ENTRY_END) - $
	dw	GWM_WIN_TEXTURE
	dw	x0,y0
	dd	f
	dd	0			;texture address
ENTRY_END:
	ENDM

ADD_WINDOW_STRINPUT  MACRO x0,y0,f
	LOCAL ENTRY_END
	dw	(ENTRY_END) - $
	dw	GWM_WIN_STRINPUT
	dw	x0,y0
	dd	f
	dd	0       		;text address
ENTRY_END:
	ENDM

ADD_WINDOW_INTINPUT MACRO x0,y0,min,max,f
	LOCAL ENTRY_END
	dw	(ENTRY_END) - $
	dw	GWM_WIN_INTINPUT
	dw	x0,y0
	dd	f
	dd	0
	dd	min
	dd	max
ENTRY_END:
	ENDM


TERMINATE_WINDOW MACRO
	dw	6
	dw	-1			;End-Marker
	ENDM

ifndef __GWM_SYSTEM_FILE

extrn C Init_GWM:near
extrn C Exit_GWM:near
extrn C GWM_Refresh_Desktop:near
extrn C GWM_Init_Palette:near
extrn C GWM_Open_Window:near
extrn C GWM_Close_Window:near
extrn C GWM_Flip_Window:near
extrn C GWM_Wait_Mouse:near
extrn C GWM_Read_Directory:near

endif