/***************************************************************************
 **
 ** (c) 1993,1994,1995 by Marc van Shaney , aka Kaya Memisoglu
 **
 ** This Source-Code was written by and is copyrighted by Kaya Memisoglu
 ** You may use the whole code or only parts of it in your own programs
 ** whether they are commercial or not. BUT you must give credits for these
 ** parts to me (Kaya Memisoglu  or  Marc van Shaney).
 ** I am not responsible for any damage or loss caused by this program, so
 ** if you success in erasing your harddisk with this code, then it is your
 ** own fault and you should not claim me to be responsible...
 ** I would be very pleased if you also sent me a postcard or even a letter
 ** if you can use this code. My address:
 **
 **        Kaya Memisoglu
 **        Reichenberger Ring 50
 **        63512 Hainburg
 **        Germany
 **
 ** You can also leave a message for Marc van Shaney on the Nirvana BBS:
 **
 **              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza
 **
 **
 **/

#include <stdio.h>
#include <math.h>



void main(void)
{
 FILE *h;
 double i,j;

 printf("\n\nGenerating ACOS.ASM. . . ");
 h=fopen("ACOS.ASM","wt");

 for (j=-8;j<8;j++)
	{
	 fprintf(h,"\ndw ");
	 for (i=0;i<16;i++)
		{
		 fprintf(h,"%.4xh",(int)(1024.0*cos(acos((16.0*j+i)/128.0)/2.0)) );
		 if (i<15)
			fprintf(h,",");
		}
	}

 fclose(h);
 printf("Ready !\n\n");
}