;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
;
SVGA_NoPages		equ	1


SVGA_Buffer_Flag	equ	1
SVGA_Linear_Buffer	equ	2
SVGA_VGA_Hardware	equ	4
SVGA_Virtual_Buffers	equ	8
SVGA_Multi_Pages	equ	10h
SVGA_VESA_Mode		equ	20h
SVGA_VGA_Mode		equ	40h
SVGA_Tweak_Mode		equ	80h
SVGA_Fake14_Mode	equ	100h
SVGA_Fake18_Mode	equ	200h
SVGA_Palette_Mode     	equ	400h
SVGA_VESA_PM_Interface	equ	800h
SVGA_IRQ_Busy		equ	1000h
SVGA_Wait_Retrace	equ	2000h
SVGA_BIOS_Palette	equ	4000h
SVGA_24bit_Palette	equ	8000h
SVGA_Ramp_Mode		equ	10000h

;
; Bits for using SVGA_Scan_Modes
;
SVGA_4bit_Modes		equ	100000h
SVGA_8bit_Modes		equ	200000h
SVGA_15bit_Modes	equ	400000h
SVGA_16bit_Modes	equ	800000h
SVGA_24bit_Modes	equ	1000000h
SVGA_32bit_Modes	equ	2000000h
SVGA_No_Tweak_Modes	equ	8000000h


;
; Now a list of standard VGA-Modi
;
SVGA_Mode_320x200x256	equ	10013h
SVGA_Mode_640x350x16	equ	20010h
SVGA_Mode_640x480x16	equ	20012h

;
; Now follow some constants for X-Mode, Orange-Mode and Fake-Mode
;
SVGA_ModeX_320x200x256	equ	40000h
SVGA_ModeX_320x240x256	equ	40001h
SVGA_ModeX_320x400x256	equ	40002h
SVGA_ModeX_320x480x256	equ	40003h
SVGA_ModeX_360x200x256	equ	40004h
SVGA_ModeX_360x240x256	equ	40005h
SVGA_ModeX_360x400x256	equ	40006h
SVGA_ModeX_360x480x256	equ	40007h
SVGA_ModeO_320x80x64k	equ	80001h
SVGA_ModeO_320x160x64k	equ	80003h
SVGA_ModeO_360x80x64k	equ	80005h
SVGA_ModeO_360x160x64k	equ	80007h
SVGA_ModeF_160x200x32k	equ	100000h
SVGA_ModeF_160x240x32k	equ	100001h
SVGA_ModeF_160x400x32k	equ	100002h
SVGA_ModeF_160x480x32k	equ	100003h
SVGA_ModeF_180x200x32k	equ	100004h
SVGA_ModeF_180x240x32k	equ	100005h
SVGA_ModeF_180x400x32k	equ	100006h
SVGA_ModeF_180x480x32k	equ	100007h

;
; Finally some VESA-Modes
;
SVGA_Mode_320x200x32k	equ	10dh
SVGA_Mode_320x200x64k	equ	10eh
SVGA_Mode_320x200x16M	equ	10fh
SVGA_Mode_640x400x256	equ	100h
SVGA_Mode_640x400x32k	equ	0
SVGA_Mode_640x400x64k	equ	0
SVGA_Mode_640x400x16M	equ	0
SVGA_Mode_640x480x256	equ	101h
SVGA_Mode_640x480x32k	equ	110h
SVGA_Mode_640x480x64k	equ     111h
SVGA_Mode_640x480x16M	equ	112h
SVGA_Mode_800x600x256	equ	103h
SVGA_Mode_800x600x32k	equ	113h
SVGA_Mode_800x600x64k	equ	114h
SVGA_Mode_800x600x16M	equ	115h
SVGA_Mode_1024x768x256	equ	104h
SVGA_Mode_1024x768x32k	equ	116h
SVGA_Mode_1024x768x64k	equ	117h
SVGA_Mode_1024x768x16M	equ	118h
SVGA_Mode_1280x1024x256	equ	107h
SVGA_Mode_1280x1024x32k	equ	119h
SVGA_Mode_1280x1024x64k	equ	11ah
SVGA_Mode_1280x1024x16M	equ	11bh




ifndef __SVGA_System_file
extrn C Init_SVGA:near
extrn C Exit_SVGA:near
extrn C SVGA_Select_Mode:near
extrn C SVGA_Scan_Modes:near
extrn C SVGA_Switch_Frame:near
extrn C SVGA_Put_Frame:near
extrn C SVGA_Set_Palette:near
extrn C SVGA_Set_Ramp:near
extrn C SVGA_Get_Video_Address:near

extrn C SVGA_Display_Width:dword
extrn C SVGA_Display_Height:dword
extrn C SVGA_Display_Depth:dword
extrn C SVGA_Flags:dword
extrn C SVGA_Frame_Buffer:dword
extrn C SVGA_Old_Frame_Buffer:dword
extrn C SVGA_Bytes_per_Line:dword
endif

